
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: mime.pl,v 1.2 2002/09/24 05:19:54 snavi Exp $


#----------------------------------------------------------------------------
#
# MIMEפɲä
#
sub addMimeType
{
    local($type, $extension) = @_;
    local(@lines, @types, @ent) = ();
    local($i);

    # MIMEפΥ顼å
    if (!$type) {
        &showErrorPage("MIMEפꤷƲ");
        exit(1);
    }
    $type =~ s/^\s*//;
    $type =~ s/\s*$//;
    if ($type =~ /[^\x21-\x7E]/) {
        &showErrorPage("MIMEפˤȾѱѿʸȰȾѵǻꤷƲ");
        exit(1);
    }
    # RFC2616 3.7򻲾
    if ($type !~ /^[^\x22\x28\x29\x2C\x2F\x3A-\x40\x5B-\x5D\x7B\x7D]+\/[^\x22\x28\x29\x2C\x2F\x3A-\x40\x5B-\x5D\x7B\x7D]+$/) {
        &showErrorPage(" MIME פǤ");
        exit(1);
    }

    # Ϥ줿ĥҤΥǥߥ" "Ѵ
    if (!$extension) {
        &showErrorPage("ĥҤꤷƲ");
        exit(1);
    }
    @ent = split(/[\s,]+/, $extension);
    for ($i = 0; $i <= $#ent; $i++) {
        if ($type =~ /[^\x21-\x7E]/) {
            &showErrorPage("ĥҤˤȾѱѿʸȾѵꤷƲ");
            exit(1);
        }
    }
    $extension = join(" ", @ent);
    &deldot(*extension);

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*AddType\s+([^\s]+)/i) {
            if ($type =~ /^\Q$1\E$/i) {
                &showErrorPage("Ʊ̾MIMEפ¸ߤޤ");
                exit(1);
            }
        }
        elsif ($lines[$i] =~ /^\s*#\s*AddType\s+([^\s]+)/i) {
        }
    }
    push(@lines, "AddType $type $extension\n");

    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # Ƶư
    if (&isServiceRunning("")) {
        &restartApache();
    }
}

#
# MIMEפΰ
#
sub getSystemMimeTypes
{
    local(@lines, @ans);

    if (!&readFile("/etc/mime.types", "mime.types", *lines)) {
        goto done;
    }
    @ans = ();
    for ($i = 0; $i <= $#lines; $i++) {
        $lines[$i] =~ s/^\s*//;
        $lines[$i] =~ s/\s*$//;
        if ($lines[$i] =~ /^\s*$/) {
            next;
        }
        if ($lines[$i] =~ /^#/) {
            next;
        }
        push(@ans, $lines[$i]);
    }

  done:
    return(@ans);
}

#
# MIMEפΰ
#
sub getLocalMimeTypes
{
    local($type) = @_;
    local(@lines, @ans);

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        goto done;
    }
    @ans = ();
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] !~ /^\s*AddType\s+/i) {
            next;
        }
        if ($type) {
            $lines[$i] =~ /^\s*AddType\s+([^\s]+)/;
            if ($type !~ /^\Q$1\E$/i) {
                next;
            }
        }
        push(@ans, $lines[$i]);
    }

  done:
    return(@ans);
}

#
# MIMEפѹ
#
sub modMimeTypes
{
    local($type, $extension) = @_;
    local(@lines, @ent) = ();

    # Ϥ줿ǡΥǥߥ" "Ѵ
    @ent = split(/[\s,]+/, $extension);
    $extension = join(" ", @ent);
    &deldot(*extension);

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] !~ /^\s*AddType\s+/i) {
            next;
        }
        if ($type) {
            $lines[$i] =~ /^\s*AddType\s+([^\s]+)/;
            if ($type !~ /^\Q$1\E$/i) {
                next;
            }
        }
        splice(@lines, $i, 1, "AddType $type $extension\n");
    }
    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # Ƶư
    if (&isServiceRunning("")) {
        &restartApache();
    }
}

#
# MIMEפ
#
sub delMimeType
{
    local($type) = @_;
    local(@lines);

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*AddType\s+([^\s]+)/i) {
            if ($type =~ /^\Q$1\E$/i) {
                splice(@lines, $i, 1);
            }
        }
    }
    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # Ƶư
    if (&isServiceRunning("")) {
        &restartApache();
    }
}

#
# ĥҤƬˤ"."
#
sub deldot
{
    local(*suff) = @_;
    local(@ent) = ();
    local($i);

    @ent = split(/[\s,]+/, $suff);
    for ($i = 0; $i <= $#ent; $i++) {
        if ($ent[$i] =~ /^\.+([^\.]+)$/) {
            $ent[$i] = $1;
        }
    }
    $suff = join(" ", @ent);

    return;
}

1;

