#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: ssl.pl,v 1.2 2002/09/27 12:27:24 snavi Exp $

#--------------------------------------------------------------------------

#--------------------------------------------------------------------------
##000802 v4.1 require -> Хѥѹ  Hori
##000804 v4.1 require (2ɤ߹ߤϾ꤯ʤ) Hori

#require "../../../lib/wbmc.pl";

#
# SSLξ֤
#
sub getSslStatus
{
    local($server, $port, *status) = @_;
    local(@lines, $target);
    local($err);

    $status = 0;

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        $err = "եɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    $target = 0;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
            if ("$server:$port" eq $1) {
                $target = 1;
            }
        }
        elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
            $target = 0;
        }
        elsif ($target == 0) {
            next;
        }
        elsif ($lines[$i] =~ /^\s*SSLEngine\s+On\s+/i) {
            $status = 1;
            goto done;
        }
    }

done:
    return($err);
}

#
# SSLξ֤ꤹ
#
sub setSslStatus
{
    local($server, $port, $status_flag) = @_;
    local(@lines, @lines2, $target, $insert_here);
    local($text, $status);
    local($err);

    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        $err = "եɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    $target = 0;
    $insert_here = -1;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
            if ("$server:$port" eq $1) {
                $target = 1;
                $insert_here = $i + 1;
            }
        }
        elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
            $target = 0;
        }
        elsif ($target == 0) {
            next;
        }
        elsif ($lines[$i] =~ /^\s*SSLEngine\s+/i) {
            splice(@lines, $i, 1);
            $i--;
        }
        elsif ($lines[$i] =~ /^\s*SSLCertificateFile\s+/i) {
            splice(@lines, $i, 1);
            $i--;
        }
        elsif ($lines[$i] =~ /^\s*SSLCertificateKeyFile\s+/i) {
            splice(@lines, $i, 1);
            $i--;
        }
    }

    if (($status_flag eq "on") && ($insert_here != -1)) {
        # ̩Ⱦ¸ߤ뤫å
        if ($err = &getSecretStatus($server, $port, *status)) {
            goto done;
        }
        if ($status == 0) {
            $err = "̩Ƥޤ";
            goto done;
        }
        if ($err = &getCertificate($server, $port, *text, *who, *exist)) {
            goto done;
        }
        if ($exist == 0) {
            $err = "Ƥޤ";
            goto done;
        }

        @lines2 = ();
        push(@lines2, "\tSSLEngine On\n");
        push(@lines2, "\tSSLCertificateFile /etc/httpd/conf/ssl.crt/crt_$server-$port.pem\n");
        push(@lines2, "\tSSLCertificateKeyFile /etc/httpd/conf/ssl.key/key_$server-$port.pem\n");
        splice(@lines, $insert_here, 0, @lines2);
    }

    # Listen Ĵ
    &checkVirtualHost(*lines);

    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        $err = "եν񤭹ߤ˼Ԥޤ";
        goto done;
    }

done:
    return($err);
}

#
# ̩ξ֤
#
sub getSecretStatus
{
    local($server, $port, *status) = @_;
    local($key) = "/etc/httpd/conf/ssl.key/key_$server-$port.pem";
    local($err);

    $status = 0;

    if (-e $key && -s $key) {
        $status = 1;
    }

    return($err);
}

#
# ̩
#
sub deleteSecret
{
    local($server, $port) = @_;
    local($key) = "/etc/httpd/conf/ssl.key/key_$server-$port.pem";
    local($err);

    if (!-e $key) {
        goto done;
    }
    if (!open CMD, "/bin/chmod 600 $key |") {
        $err = "̩Υѹ˼Ԥޤ";
        goto done;
    }
    close(CMD);
    if (!open CMD, "/bin/rm -f $key |") {
        $err = "̩κ˼Ԥޤ";
        goto done;
    }
    close(CMD);

    # Listen Ĵ
    if ($err = &changeListen()) {
        goto done;
    }

 done:
    return($err);
}

#
# ̾׵
#
sub makeCertificateRequest
{
    local($server, $port, $country, $state, $city, $company,
        $section, $fqdn) = @_;
    local($key, $csr, $crt);
    local($err);

    # ѥ᡼γǧ
    if ($err = &checkCertificateParameter($country, $state, $city,
        $company, $section, $fqdn)) {
        goto done;
    }

    # Υǥ쥯ȥγǧ
    if ($err = &checkDirectory()) {
        goto done;
    }

    # 
    $key = "/etc/httpd/conf/ssl.key/key_$server-$port.pem";
    $csr = "/etc/httpd/conf/ssl.csr/csr_$server-$port.pem";
    $crt = "/etc/httpd/conf/ssl.crt/crt_$server-$port.pem";

    # ̩κ
    if ($err = &createSecret($key)) {
        goto done;
    }

    # ̾׵κ
    if ($err = &createCertificateRequest($key, $csr,
        $contry, $state, $city, $company, $section, $fqdn)) {
        goto done;
    }

    # Listen Ĵ
    if ($err = &changeListen()) {
        goto done;
    }

done:
    return($err);
}

#
# ̾׵Ƥ
#
sub getCertificateRequest
{
    local($server, $port, *text, *exist) = @_;
    local($csr) = "/etc/httpd/conf/ssl.csr/csr_$server-$port.pem";
    local($err);

    $exist = 0;
    if (!-e $csr || -z $csr) {
        goto done;
    }
    $exist = 1;

    if (!&readFile($csr, "csr.pem", *text)) {
        $err = "̾׵ɤ߹ߤ˼Ԥޤ";
        goto done;
    }

 done:
    return($err);
}

#
# ̾׵
#
sub deleteCertificateRequest
{
    local($server, $port) = @_;
    local($err);

    $csr = "/etc/httpd/conf/ssl.csr/csr_$server-$port.pem";
    if (!-e $csr) {
        goto done;
    }
    if (!open CMD, "/bin/rm -f $csr |") {
        $err = "̾׵κ˼Ԥޤ";
        goto done;
    }
    close(CMD);

 done:
    return($err);
}

#
# 
#
sub makeSelfCertificate
{
    local($server, $port, $country, $state, $city, $company,
        $section, $fqdn) = @_;
    local($key, $csr, $crt);
    local($err);

    # ѥ᡼γǧ
    if ($err = &checkCertificateParameter($country, $state, $city,
        $company, $section, $fqdn)) {
        goto done;
    }

    if ($err = &checkDirectory()) {
        goto done;
    }
    $key = "/etc/httpd/conf/ssl.key/key_$server-$port.pem";
    $csr = "/etc/httpd/conf/ssl.csr/csr_$server-$port.pem";
    $crt = "/etc/httpd/conf/ssl.crt/crt_$server-$port.pem";

    # ̩κ
    if ($err = &createSecret($key)) {
        goto done;
    }
    
    # ̾׵κ
    if ($err = &createCertificateRequest($key, $csr,
        $contry, $state, $city, $company, $section, $fqdn)) {
        goto done;
    }

    # κ
    if ($err = &createCertificate($key, $csr, $crt)) {
        goto done;
    }

    # ̾׵κ
    if ($err = &deleteCertificateRequest($server, $port)) {
        goto done;
    }

    # Listen Ĵ
    if ($err = &changeListen()) {
        goto done;
    }

 done:
    return($err);
}

#
# Ͽ
#
sub registCertificate
{
    local($server, $port, @text) = @_;
    local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-$port.pem";
    local($tmp) = "/etc/httpd/conf/tmp.$$";
    local($err);

    if (!writeFile($crt, "crt.pem", @text)) {
        $err = "Ͽ˼Ԥޤ";
        goto done;
    }
    
    if (!open CMD, "/usr/bin/openssl x509 -in $crt -out $tmp -text |") {
        &removeFile($crt);
        &removeFile($tmp);
        $err = "PEMξϿƲ";
        goto done;
    }
    close(CMD);
    &removeFile($tmp);

    # Listen Ĵ
    if ($err = &changeListen()) {
        goto done;
    }

 done:
    return($err);
}

#
# Ƥ
#
sub getCertificate
{
    local($server, $port, *text, *who, *exist) = @_;
    local($value) = 0;
    local(@issuer, $issuer) = ();
    local(@tmp) = ();
#   local(@buf, @tmp) = ();
#   local($who_flag) = 0;
    local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-$port.pem";
    local($err);

    $exist = 0;

    if (!-e $crt || -z $crt) {
        goto done;
    }

    $exist = 1;

    # Ф
    if ($err = &getCertificateInfo($crt, "text", *text)) {
        goto done;
    }

 done:
    return($value);
}

#
# 
#
sub deleteCertificate
{
    local($server, $port) = @_;
    local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-$port.pem";
    local($err);
    
    if (!-e $crt) {
        goto done;
    }
    if (!open CMD, "/bin/rm -f $crt |") {
        $err = "κ˼Ԥޤ";
        goto done;
    }
    close(CMD);

    $err = &changeListen();

 done:
    return($err);
}
#
# ̩
#
sub createSecret
{
    local($key) = @_;
    local($err);

    if (-e $key) {
        if (!open CMD, "/bin/chmod 600 \"$key\" |") {
            $err = "̩Υѡߥåѹ˼Ԥޤ";
            goto done;
        }
        close(CMD);
    }
    # ̩
    if (!open(EXEC, "| /usr/bin/openssl genrsa -out $key -passout stdin -des 1024 > /dev/null 2>&1")) {
        $err = "̩κ˼Ԥޤ";
        goto done;
    }

    # ΥѥɤϤ
    print EXEC "wbmc\n";
    print EXEC "wbmc\n";
    close(EXEC);

    # ̩Υѥɤ
    if (!open EXEC, "| /usr/bin/openssl rsa -in $key -passin stdin -out $key > /dev/null 2>&1") {
        $err = "̩Υѥɤβ˼Ԥޤ";
        goto done;
    }
    print EXEC "wbmc\n";
    close(EXEC);
    
    # root Фɤ߼긢Τߤ
    if (!open CMD, "/bin/chmod 400 \"$key\" |") {
        $err = "̩Υѡߥåѹ˼Ԥޤ";
        goto done;
    }
    close(CMD);

 done:
    return($err);
}

#
# ̾׵
#
sub createCertificateRequest
{
    local($key, $csr,
          $contry, $state, $city, $company, $section, $fqdn) = @_;
    local($err);

    # 
    if (!$country) {
        $country = "localhost";
    }
    if (!$state) {
        $state = "Some-State";
    }
    if (!$city) {
        $city = "Somewhere";
    }
    if (!$company) {
        $company = "Test server";
    }
    if (!$section) {
        $section = "Test Certificate";
    }
    if (!$fqdn) {
        $fqdn = "localhost";
    }
    
    if (!open EXEC, "| /usr/bin/openssl req -new -key $key -out $csr -config /opt/nec/wbmc/lib/ssl.conf > /dev/null 2>&1") {
        $err = "̾׵κ˼Ԥޤ";
        goto done;
    }
    print EXEC "$country\n";
    print EXEC "$state\n";
    print EXEC "$city\n";
    print EXEC "$company\n";
    print EXEC "$section\n";
    print EXEC "$fqdn\n";
    close(EXEC);

 done:
    return($err);
}

#
# ʽ̾
#
sub createCertificate
{
    local($key, $csr, $crt) = @_;
    local($err);
    
    if (!open EXEC, "| /usr/bin/openssl x509 -in $csr -out $crt -days 365 -signkey $key -req > /dev/null 2>&1") {
        $err = "ʽ̾κ˼Ԥޤ";
        goto done;
    }
    close(EXEC);

 done:
    return($err);
}

#
# ɬפʥǥ쥯ȥå̵к
#
sub checkDirectory
{
    local($err);

    if (! -d "/etc/httpd/conf/ssl.key") {
        if ($err = &makeDirectory("/etc/httpd/conf/ssl.key")) {
            goto done;
        }
    }
    if (! -d "/etc/httpd/conf/ssl.csr") {
        if ($err = &makeDirectory("/etc/httpd/conf/ssl.csr")) {
            goto done;
        }
    }
    if (! -d "/etc/httpd/conf/ssl.crt") {
        if ($err = &makeDirectory("/etc/httpd/conf/ssl.crt")) {
            goto done;
        }
    }

 done:
    return($err);
}

#
# ǥ쥯ȥ
#
sub makeDirectory
{
    local($dir) = @_;
    local($err);
    
    if (!open CMD, "/bin/mkdir -p \"$dir\" |") {
        $err = "ǥ쥯ȥκ˼Ԥޤ"; 
        goto done;
    }
    close(CMD);

 done:
    return($err);
}

#
# ξ
#
sub getCertificateInfo
{
    local($crt, $option, *text) = @_;
    local($tmp) = "/etc/httpd/conf/tmp.$$";
    local($err);
    
    if (!open CMD, "/usr/bin/openssl x509 -in $crt -out $tmp -$option |") {
        &removeFile($tmp);
        $err = "PEMξϿƲ";
        goto done;
    }
    close(CMD);
    @text = ();
    if (!-e $tmp || -z $tmp) {
        &removeFile($tmp);
        $err = "PEMξϿƲ";
        goto done;
    }
    if (!open IN, "$tmp") {
        &removeFile($tmp);
        $err = "ξɤ߹ߤ˼Ԥޤ";
        goto done;
    }
    while(<IN>) {
        push @text, $_;
    }
    close(IN);
    &removeFile($tmp);

done:
    return($err);
}

#
# եκ
#
sub removeFile
{
    local($err);

    local($file) = @_;
    if (-e $file) {
        unlink($file);
    }
    return($err);
}

#
# 񡢾̾׵Υѥ᡼å
#
sub checkCertificateParameter
{
    local($country, $state, $city,
                $company, $section, $fqdn) = @_;
    local($err);

    # 顼å
    if (!$country || $country =~ /^\s+$/) {
        $err = "񥳡ɤꤷƲ";
        goto done;
    }
    if (length($country) != 2) {
        $err = "񥳡ɤϣʸǻꤷƲ";
        goto done;
    }
    if ($country =~ /[^A-Za-z]/) {
        $err = "񥳡ɤȾѱʸǻꤷƲ";
        goto done;
    }
    $state =~ s/^\s*//;
    $state =~ s/\s*$//;
    if (!$state || $state =~ /^\s+$/) {
        $err = "ƻܸ̾ꤷƲ";
        goto done;
    }
    if ($state =~ /[^\x20-\x7E]/) {
        $err = "ƻܸ̾ȾѱѿȾѵǻꤷƲ";
        goto done;
    }
    $city =~ s/^\s*//;
    $city =~ s/\s*$//;
    if (!$city || $city =~ /^\s+$/) {
        $err = "ԶĮ¼̾ꤷƲ";
        goto done;
    }
    if ($city =~ /[^\x20-\x7E]/) {
        $err = "ԶĮ¼̾ȾѱѿȾѵǻꤷƲ";
        goto done;
    }
    $company =~ s/^\s*//;
    $company =~ s/\s*$//;
    if (!$company || $company =~ /^\s+$/) {
        $err = "̾ꤷƲ";
        goto done;
    }
    if ($company =~ /[^\x20-\x7E]/) {
        $err = "̾ȾѱѿȾѵǻꤷƲ";
        goto done;
    }
    $section =~ s/^\s*//;
    $section =~ s/\s*$//;
    if (!$section || $section =~ /^\s+$/) {
        $err = "̾ꤷƲ";
        goto done;
    }
    if ($section =~ /[^\x20-\x7E]/) {
        $err = "̾ȾѱѿȾѵǻꤷƲ";
        goto done;
    }
    $fqdn =~ s/^\s*//;
    $fqdn =~ s/\s*$//;
    if (!$fqdn || $fqdn =~ /^\s+$/) {
        $err = "ۥ̾ꤷƲ";
        goto done;
    }
    if (!&checkLongHostName($fqdn) && !&checkShortHostName($fqdn)) {
        $err = "ۥ̾FQDN⤷ϥۥ̾ꤷƲ";
        goto done;
    }

done:
    return($err);
}

#
# Listen ؼҤĴ
#
sub changeListen{
    local(@lines) = ();
    my($wbmc_conf);

    $wbmc_conf = "/etc/httpd/conf/wbmc.conf";
    if (!&readFile($wbmc_conf, "wbmc.conf", *lines)) {
        return("եɤ߹ߤ˼Ԥޤ");
    }

    &checkVirtualHost(*lines);

    if (!&writeFile($wbmc_conf, "wbmc.conf", @lines)) {
        return("եν񤭹ߤ˼Ԥޤ");
    }
}

1;


