#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: ml_html.pl,v 1.3 2002/10/25 01:53:30 snavi Exp $


require "../../../../../lib/wbmc.pl";


$fml_dir = "/home/fml";
$web_dir = "/home/web";


#
# Function
#   HTMLϢǥ쥯ȥ/եκ
# Parameters
#   $listname        ᡼󥰥ꥹ̾
#   $domainname      ɥᥤ̾
# Return
#   ʤ
#

sub del_html
{
    my($listname, $domainname) = @_;

    my($html_dir) = "$web_dir/$domainname/htdocs/ml/$listname";
    my($mrc_file) = "$fml_dir/$domainname/$listname/$listname.mrc";
    my($index_dir) = "$fml_dir/$domainname/$listname/namazu";
    my($mknmzrc_file) = "$fml_dir/$domainname/$listname/mknmzrc_$listname";
    my($lock_file) = "wbmc_ml_html.conf";
    my($conf_file) = "$fml_dir/$domainname/$listname/$lock_file";

    # HTMLեǼǥ쥯ȥ
    system ("/bin/rm -rf $html_dir") if (-d "$html_dir");

    # MRCե
    unlink $mrc_file if (-e "$mrc_file");

    # ǥåեǼǥ쥯ȥ
    system ("/bin/rm -rf $index_dir") if (-d "$index_dir");

    # mknmzrcե
    unlink $mknmzrc_file if (-e "$mknmzrc_file");

    # HTMLե
    unlink $conf_file if (-e "$conf_file");

    return;
}


#
# Function
#   MRCեΥޥ
# Parameters
#   $mrc_file        MRCե̾
#   $listname        ᡼󥰥ꥹ̾
#   $mail_addr       ԥ᡼륢ɥ쥹(̤ξ"")
# Return
#       ""
#       顼å
#

sub custom_mrc
{
    my($mrc_file, $listname, $mail_addr) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($lock_file) = "$listname.mrc";

    if (!&readFile($mrc_file, $lock_file, *lines)) {
        $ret = "MRCեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^\s*(.+)\s+\(Date\s+Index\)$/) {
            $_ = $org;
            s/$1/$listname/g;
            push (@tmp, $_);
            next;
        }
        if (/^\s*(.+)\s+\(by\s+thread\)$/) {
            $_ = $org;
            s/$1/$listname/g;
            push (@tmp, $_);
            next;
        }
        if (/^<a\s+href=\"mailto:(.+)\">(.+)<\/a>$/) {
            $_ = $org;
            s/$1/$mail_addr/g;
            push (@tmp, $_);
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($mrc_file, $lock_file, @tmp)) {
        $ret = "MRCեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

done:

    return($ret);

}

#
# Function
#   mknmzrcեΥޥ
# Parameters
#   $mknmzrc_file        mknmzrcե̾
#   $listname            ᡼󥰥ꥹ̾
#   $mail_addr           ԥ᡼륢ɥ쥹(̤ξ"")
# Return
#       ""
#       顼å
#

sub custom_mknmzrc
{
    my($mknmzrc_file, $listname, $mail_addr) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($lock_file) = "mknmzrc_$listname";

    if (!&readFile($mknmzrc_file, $lock_file, *lines)) {
        $ret = "mknmzrcեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^#*\s*\$ADDRESS\s*=\s*/) {
            $_ = "\$ADDRESS = \'$mail_addr\'\n";
            push (@tmp, $_);
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($mknmzrc_file, $lock_file, @tmp)) {
        $ret = "mknmzrcեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

done:

    return($ret);

}

#
# Function
#   namazurcեΥޥ
# Parameters
#   $namazurc_file        mknmzrcե̾
#   $listname             ᡼󥰥ꥹ̾
#   $domainname           ɥᥤ̾
#   $index_dir            namazuǥåեǼǥ쥯ȥ
#   $html_dir             HTMLեǼǥ쥯ȥ
#   $template_dir         namazuƥץ졼ȥեǼǥ쥯ȥ
# Return
#       ""
#       顼å
#

sub custom_namazurc
{
    my($namazurc_file, $listname, $domainname, $index_dir, $html_dir, $template_dir) = @_;

    my($ret, $org) = "";
    my($ent01, $ent02, $ent03) = "";
    my(@tmp) = "";
    my($lock_file) = ".namazurc";

    if (!&readFile($namazurc_file, $lock_file, *lines)) {
        $ret = "namazurcեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^(#*Index)\s+(.+)$/) {
            $ent01 = (split('\s+', $_))[1];
            $_ = $org;
            s/$1/Index/;
            s/$ent01/$index_dir/;
            push (@tmp, $_);
            next;
        }
        if (/^(#*Template)\s+(.+)$/) {
            $ent01 = (split('\s+', $_))[1];
            $_ = $org;
            s/$1/Template/;
            s/$ent01/$template_dir/;
            push (@tmp, $_);
            next;
        }
        if (/^(#*Replace)\s+(.+)\s+(.+)$/) {
            $ent01 = (split('\s+', $_))[1];
            $ent02 = (split('\s+', $_))[2];
            $ent03 = "http://$domainname/ml/$listname";
            $_ = $org;

            s/$1/Replace/;
            s/$ent01/$html_dir/;
            s/$ent02/$ent03/;
            push (@tmp, $_);
            next;
        }
        if (/^(#*Lang)\s+/) {
            $_ = $org;
            s/$1/Lang/;
            push (@tmp, $_);
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($namazurc_file, $lock_file, @tmp)) {
        $ret = "namazurcեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

done:

    return($ret);

}

#
# Function
#   wbmc.confեΥޥ(CGI¹Եɲ)
# Parameters
#   $cgi_dir               CGIǥ쥯ȥ
#   $domainname            ɥᥤ̾
# Return
#       ""
#       顼å
#

sub cgi_on
{
    my($cgi_dir, $domainname) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($flag) = 0;
    my($conf_file) = "/etc/httpd/conf/wbmc.conf";
    my($lock_file) = "wbmc.conf";

    my($line01) = "\t<Directory \"$cgi_dir\">\n";
    my($line02) = "\t\tOptions +ExecCGI -Includes -Indexes -FollowSymLinks -MultiViews\n";
    my($line03) = "\t\tAllowOverride None\n";
    my($line04) = "\t<\/Directory>\n";

    if (!&readFile($conf_file, $lock_file, *lines)) {
        $ret = "$conf_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^ServerName\s+$domainname$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if (/^<Directory\s+\"$cgi_dir\">$/ and $flag == 1) {
            $flag = 2;
            push (@tmp, $org);
            next;
        }
        if (/^Options\s+/ and $flag == 2) {
            $_ = $org;
            s/-ExecCGI/+ExecCGI/g;
            push (@tmp, $_);
            $flag = 0;
            next;
        }
        if (/^<\/Directory>$/ and $flag == 2) {
            $flag = 0;
            push (@tmp, $org);
            next;
        }
        if (/^<\/VirtualHost>$/ and $flag == 1) {
            push (@tmp, $line01);
            push (@tmp, $line02);
            push (@tmp, $line03);
            push (@tmp, $line04);
            push (@tmp, $org);
            $flag = 0;
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($conf_file, $lock_file, @tmp)) {
        $ret = "$conf_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

    system ("/etc/rc.d/init.d/httpd restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   wbmc.confեΥޥ(CGI¹Եĺ)
# Parameters
#   $cgi_dir               CGIǥ쥯ȥ
#   $domainname            ɥᥤ̾
# Return
#       ""
#       顼å
#

sub cgi_off
{
    my($cgi_dir, $domainname) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($flag) = 0;
    my($conf_file) = "/etc/httpd/conf/wbmc.conf";
    my($lock_file) = "wbmc.conf";

    if (!&readFile($conf_file, $lock_file, *lines)) {
        $ret = "$conf_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^<Directory\s+\"$cgi_dir\">$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if (/^Options\s+/ and $flag == 1) {
            $_ = $org;
            s/\+ExecCGI/-ExecCGI/g;
            push (@tmp, $_);
            $flag = 0;
            next;
        }
        if (/^<\/Directory>$/) {
            $flag = 0;
            push (@tmp, $org);
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($conf_file, $lock_file, @tmp)) {
        $ret = "$conf_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

    system ("/etc/rc.d/init.d/httpd restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   HTMLμư
# Parameters
#   $fml_dir                  ᡼󥰥ꥹȥǥ쥯ȥ
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
#   $def                      Indexڡɽեå(on/off)
#   $update_select            
#   $arg1                     (1)
#   $arg2                     (2)
#   $mhonarc_cmd              mhonarcޥ
#   $mrc_file                 MRCե
#   $html_dir                 HTMLեǼǥ쥯ȥ
#   $spool_dir                סǥ쥯ȥ
#   $mknmz_cmd                mknmzޥ
#   $mknmzrc_file             mknmzrcե
#   $index_dir                Namazuǥåǥ쥯ȥ
# Return
#       ""
#       顼å
#

sub autorun_html
{
    my($fml_dir, $domainname, $listname, $def, $update_select, $arg1, $arg2, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir) = @_;

    my($ret);
    my($flag) = 0;
    my(@tmp) = "";
    my($bin_lock) = "$domainname" . "_" . "$listname";
    my($bin_file) = "/opt/nec/wbmc/bin/$bin_lock";
    my($crontab_lock) = "crontab";
    my($crontab_file) = "/etc/$crontab_lock";
    my($crond_scpt) = "/etc/rc.d/init.d/crond";

    # ư¹ԥץȺ
    if (($ret = &make_autorun($fml_dir, $domainname, $listname, $def, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir, $bin_lock, $bin_file)) ne "") {
        goto done;
    }

    # /etc/crontab
    if (!&readFile($crontab_file, $crontab_lock, *lines)) {
        $ret = "$crontab_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    if ($update_select eq "HOUR_ON") {
        $schedule = "0 0-23/$arg1 * * * root $bin_file &> /dev/null\n";
    } elsif ($update_select eq "DAILY_ON") {
        $schedule = "$arg2 $arg1 * * * root $bin_file &> /dev/null\n";
    } elsif ($update_select eq "WEEKLY_ON") {
        $schedule = "0 $arg2 * * $arg1 root $bin_file &> /dev/null\n";
    } 

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^#\s*$domainname\/$listname\s+HTML\s+update$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if ($flag == 1) {
            $flag = 2;
            push (@tmp, $schedule);
            next;
        }
        push (@tmp, $org);
    }
    if ($flag == 0) {
        push (@tmp, "# $domainname/$listname HTML update\n");
        push (@tmp, $schedule);
    }
            
    if (!&writeFile($crontab_file, $crontab_lock, @tmp)) {
        $ret = "$crontab_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    system ("$crond_scpt restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   HTMLμư
# Parameters
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
# Return
#       ""
#       顼å
#

sub del_autorun
{
    my($domainname, $listname) = @_;

    my($flag) = 0;
    my(@tmp) = "";
    my($bin_lock) = "$domainname" . "_" . "$listname";
    my($bin_file) = "/opt/nec/wbmc/bin/$bin_lock";
    my($crontab_lock) = "crontab";
    my($crontab_file) = "/etc/$crontab_lock";
    my($crond_scpt) = "/etc/rc.d/init.d/crond";

    # 륹ץȺ
    unlink $bin_file if (-e $bin_file);

    # /etc/crontab
    if (!&readFile($crontab_file, $crontab_lock, *lines)) {
        $ret = "$crontab_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^#\s*$domainname\/$listname\s+HTML\s+update$/) {
            $flag = 1;
            next;
        }
        if ($flag == 1) {
            $flag = 2;
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($crontab_file, $crontab_lock, @tmp)) {
        $ret = "$crontab_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    system ("$crond_scpt restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   ֥饦Υॢ޻
# Parameters
#   $title               ȥ
#   $show_str            ɽʸ
#   $append              ɽ(0)/ɲɽ(1)
# Return
#       ""
#       ""
#

sub no_timeout
{
    my($title, $show_str, $append) = @_;

    if ($append == 0) {
        print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
END_OF_DATA
    }

    print <<END_OF_DATA;
<TABLE><TR><TD></TD></TR></TABLE>
<HR>
$show_str<BR>
END_OF_DATA

    # ˲ɽ褦ߡǡ
    print "<!--\n";
    print "A" x 1024;
    print "-->\n";

    $count = 0;
    for(;;) {
        if($count eq "0"){
            print "<TABLE><TR><TD></TD></TR></TABLE>";
        }elsif($count % 50){
            print "";
        }else{
            print "<BR>";
        }
        # ॢбΤᡢSTDOUХåեեå夹롣
        $buff = select(STDOUT);
        $| = 1;
        select($buff);
        sleep 5;         # 5äޤ
        $count++;
    }
}

#
# Function
#   ư¹ԥץȺ
# Parameters
#   $fml_dir                  ᡼󥰥ꥹȥǥ쥯ȥ
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
#   $def                      Indexڡɽեå(on/off)
#   $mhonarc_cmd              mhonarcޥ
#   $mrc_file                 MRCե
#   $html_dir                 HTMLեǼǥ쥯ȥ
#   $spool_dir                סǥ쥯ȥ
#   $mknmz_cmd                mknmzޥ
#   $mknmzrc_file             mknmzrcե
#   $index_dir                Namazuǥåǥ쥯ȥ
#   $bin_lock                 ץȥե̾
#   $bin_file                 ץȥեХѥ
# Return
#       ""
#       顼å
#

sub make_autorun
{
    my($fml_dir, $domainname, $listname, $def, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir, $bin_lock, $bin_file) = @_;

    my($ret);
    my(@tmp) = "";
    my($template1) = "script_template1";
    my($template2) = "script_template2";
    my($result_mhonarc) = "$fml_dir/$domainname/$listname/result_mhonarc";
    my($result_mknmz) = "$fml_dir/$domainname/$listname/result_mknmz";

    if ($def eq "on" or $def eq "on1") {
        if (!&readFile($template1, $template1, *lines)) {
            $ret = "ƥץ졼ȥեɤ߹ߤ˼Ԥޤ";
            goto done;
        }

        if ($def eq "on") {
            foreach (@lines) {
                s/__MHONARC_CMD/$mhonarc_cmd/g;
                s/__MRC_FILE/$mrc_file/g;
                s/__HTML_DIR/$html_dir/g;
                s/__SPOOL_DIR/$spool_dir/g;
                s/__RESULT_MHONARC/$result_mhonarc/g;
                s/__MKNMZ_CMD/$mknmz_cmd/g;
                s/__MKNMZRC_FILE/$mknmzrc_file/g;
                s/__INDEX_DIR/$index_dir/g;
                s/__RESULT_MKNMZ/$result_mknmz/g;

                push (@tmp, $_);
            }
        } elsif ($def eq "on1") {
            foreach (@lines) {
                s/__MHONARC_CMD/$mhonarc_cmd/g;
                s/__MRC_FILE/$mrc_file/g;
                s/__HTML_DIR/$html_dir/g;
                s/__SPOOL_DIR/$spool_dir/g;
                s/__RESULT_MHONARC/$result_mhonarc/g;
                s/__MKNMZ_CMD/$mknmz_cmd/g;
                s/__MKNMZRC_FILE/$mknmzrc_file/g;
                s/__INDEX_DIR/$index_dir/g;
                s/__RESULT_MKNMZ/$result_mknmz/g;
                s/ -I / -T /g;

                push (@tmp, $_);
            }
        }

        if (!&writeFile($bin_file, $bin_lock, @tmp)) {
            $ret = "$bin_fileեν񤭹ߤ˼Ԥޤ";
            goto done;
        }
    } elsif ($def eq "off") {
        if (!&readFile($template2, $template2, *lines)) {
            $ret = "ƥץ졼ȥեɤ߹ߤ˼Ԥޤ";
            goto done;
        }

        foreach (@lines) {
            s/__MHONARC_CMD/$mhonarc_cmd/g;
            s/__MRC_FILE/$mrc_file/g;
            s/__HTML_DIR/$html_dir/g;
            s/__SPOOL_DIR/$spool_dir/g;
            s/__RESULT_MHONARC/$result_mhonarc/g;

            push (@tmp, $_);
        }

        if (!&writeFile($bin_file, $bin_lock, @tmp)) {
            $ret = "$bin_fileեν񤭹ߤ˼Ԥޤ";
            goto done;
        }
    }
    chmod 0755, $bin_file;

done:

    return($ret);

}

1;
