# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: mailertable.pl,v 1.1.1.1 2002/09/09 07:43:32 snavi Exp $

# mailertable Υե̾
$mailertable_name="/etc/mail/mailertable";

#
# ե뤫ɥᥤ̾žɤؿ
#
sub read_mailertable
{
  my(@table)=();

  open(TABLE,$mailertable_name) || die;
  @table=<TABLE>;
  close(TABLE);
  chomp @table;
  chomp @table;
  return(@table);
}

#
# ȤФԿΥơ֥
#
sub make_mapping_table
{
  my(@record)=@_; # ȹԤޤ᤿ mailertable 
  my(@table)=();
  my($record,$table)=(0,0);
  my($domain,$agent,$dest);

  for($record=0; $record<=$#record; $record++){
    # ȹԡԤФ
    if( $record[$record] =~ /\s*#/ || $record[$record] !~ /\S/ ){
      next;
    }
    $table[$table]=$record;
    $table++;
  }
  return(@table);
}

#
# mailertable Υ쥳ɤϥåѴ
#
sub record2hash
{
  my($record)=$_[0];
  my($domain,$agent,$dest,$is_dns,$comment,$is_sub,$dest_type,$is_error);

  # ɥᥤ̾ȡžʬФ
  $record =~ m/(.+)\t(.+):(.+)/;
  ($domain,$agent,$dest)=($1,$2,$3);
  if( $domain eq "" || $agent eq "" || $dest eq "" ){
    $is_error=1;
  }
  else{
    $is_error=0;
  }

  # ȤʬФ
  $comment="";
  if( $dest =~ /#/ ){
    $dest = $`;
    $comment = $';
  }

  $domain =~ s/\s+//g;
  $dest =~ s/\s+//g;

  # DNS ꤬ͭɤĴ٤
  $is_dns=1;
  if( $dest =~ /\[(.+)\]/ ){
    $dest=$1;
    $is_dns=0;
  }

  # ž褬ۥ̾IPɥ쥹桼
  if( ipAddrCheck($dest) ){
    $dest_type=1; # IPɥ쥹
  }
  else{
    $dest_type=0; # ۥ̾
  }
  if( $agent eq "local" ){
    $dest_type=2; # 桼
  }

  # ֥ɥᥤؤžɤĴ٤
  $is_sub=0;
  if( $domain =~ s/^\.// ){
    $is_sub=1;
  }
# if( $domain =~ s/^\+// ){ # ɥᥤȥ֥ɥᥤξž
#   $is_sub=2;
# }

  return("domain",$domain,
    "agent","$agent",
    "dest",$dest,
    "is_dns",$is_dns,
    "comment",$comment,
    "is_sub",$is_sub,
    "dest_type",$dest_type,
    "is_error",$is_error);
}


#
# ե˽񤭽Ф
#
sub write_mailertable
{
  my(%input)=@_;
  my($i,@record,@table);
  my($str);

  @record=&read_mailertable();
  @table=&make_mapping_table(@record);

  if($input{"is_add"}==1){
    $table[$input{"no"}]=$#record+1;
  }

  open(TABLE,"> $mailertable_name");
  for($i=0; $i<$table[$input{"no"}]; $i++){
    print TABLE "$record[$i]\n";
  }
  print TABLE &hash2record(%input);
  $i++;
  for(; $i<=$#record; $i++){
    print TABLE "$record[$i]\n";
  }
  close(TABLE);
}

#
# ϥå mailertable Υ쥳ɤѴ
#
sub hash2record
{
  my(%a)=@_;

  if( $a{"dest_type"}==2 ){
    $a{"is_dns"}="1";
  }

  if( $a{"is_dns"} eq "" || $a{"dest_type"}==1 ){
    $a{"dest"}="[$a{'dest'}]";
  }

  if( $a{"comment"} ne "" ){
    $a{"comment"}="#".$a{"comment"};
  }

  if( ($a{"is_sub"})==1 ){
    $a{"domain"}=".".$a{"domain"};
  }

# if( ($a{"is_sub"})==2 ){
#   $a{"domain"}="+".$a{"domain"};
# }

  return("$a{'domain'}\t$a{'agent'}:$a{'dest'} $a{'comment'}\n");
}


#
# URLΥǥɤԤϥåˤ
#
sub input_decode
{
  my($input)=$_[0];
  my(@input);

  $input =~ s/\n//g;
  $input =~ tr/+/ /;
  $input =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
  @input=split(/[&=]/,$input);
  return(@input);
}



#
# ե뤫ꤵ줿쥳ɤä
#  ä쥳ɤֹ
sub delete_mailertable
{
  my($no)=$_[0];
  my($i,@record,@table);
  my($str);

  @record=&read_mailertable();
  @table=&make_mapping_table(@record);

  open(TABLE,"> $mailertable_name");
  for($i=0; $i<=$#record; $i++){
    if($i != $table[$no] ){
      print TABLE "$record[$i]\n";
    }
  }
  close(TABLE);
}



#
# 쥳ɤư
#  ư쥳ֹ桢ư쥳ֹ
sub move_mailertable
{
  my($from,$to)=@_;
  my($i,@record,@table);
  my($str);

  if($from==$to){
    return;
  }

  @record=&read_mailertable();
  @table=&make_mapping_table(@record);

  unless( checkNum($from, 0, $#table) && checkNum($to, 0, $#table) ){
    return;
  }

  open(TABLE,"> $mailertable_name");
  for($i=0; $i<=$#record; $i++){
    if($i == $table[$from] ){
      next;
    }
    if($i == $table[$to] ){
      if( $from > $to ){
        print TABLE "$record[$table[$from]]\n";
        print TABLE "$record[$i]\n";
      }
      else{
        print TABLE "$record[$i]\n";
        print TABLE "$record[$table[$from]]\n";
      }
      next;
    }
    print TABLE "$record[$i]\n";
  }
  close(TABLE);
}

#
# ᡼륢ɥ쥹Ȥå
#
sub isMailaddrCheck
{
  return(1) if( $_[0] =~ /@/ && checkUserName($`) && checkDomainName($'));
  return(1) if( $_[0] !~ /@/ && checkUserName($_[0]) );
  return(0);
}

1;
