
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: network.pl,v 1.1.1.1 2002/09/09 07:43:31 snavi Exp $

#--------------------------------------------------------------------


#--------------------------------------------------------------------
# 255.255.255.0 -> 24
#--------------------------------------------------------------------
sub mask2bit {
	local($mask) = @_;

	my ($bit, $b, $error, $end_flag, $counter, $cnt);

	$bit = 0;
	$error = 0;
	$end_flag = 0;
	$counter = 0;
	$cnt = 0;

	if (!&checkNetMask($mask)) {
		return 0;
	}
	@col = split(/\./,$mask);

	while ($counter < 4) {
		$b = 128;
		for ($cnt = 0 ; $cnt < 8 ; $cnt ++) {
			if(($col [$counter] <= 255) 
				&& ($col[$counter] & $b)) { 
				if ($end_flag){
					$error++;
					last;
				}
				$bit++;
			} else {
				$end_flag = 1;
			}
			$b = $b >> 1;
		}
		$counter++;
	}
	if ($error != 0) {
		return 0;
	}
	return $bit;
}

#--------------------------------------------------------------------
# 10.8.99.0/24 -> 256
#--------------------------------------------------------------------
sub getHnum {
	local($val) = @_;
	my ($hostnum, @a, $i, $max);
	
	$hostnum = 0;
	@a = split(/\//, $val);
	if ($#a != 1) {
		return 0;
	}
	if (!&ipAddrCheck($a[0]) || !&checkNum($a[1], 1, 31)) {
		return 0;
	}
	$max = 32 - $a[1];

	for ($i = 0; $i <= $max; $i++) {
		if ($i == 0) {
			$hostnum = 1;
		}
		else {
			$hostnum *= 2;
		}
	}
	return $hostnum;
}

#--------------------------------------------------------------------
# 65534 -> 255.254
#--------------------------------------------------------------------
sub num2Addr {
	local($val) = @_;
	my ($hostaddr, @n, $i, $atfirst);

	if (!&checkNum($val, 0, 4294967295)) {
		return 0;
	}
	$hostaddr = "";
	$n[0] = ($val >> 24) & 0xff;
	$n[1] = ($val >> 16) & 0xff;
	$n[2] = ($val >> 8) & 0xff;
	$n[3] = $val & 0xff;

	$atfirst = 1;
	for ($i = 0; $i <= $#n; $i++) {
		if (($atfirst == 1) && !$n[$i]) {
			next;
		}
		if ($atfirst == 0) {
			$hostaddr .= ".";
		}
		$hostaddr .= "$n[$i]";
		$atfirst = 0;
	}
	if ($atfirst == 1) {
		$hostaddr = "0";
	}
	return $hostaddr;
}

#--------------------------------------------------------------------
# 0.0.255.254 -> 65534
#--------------------------------------------------------------------
sub addr2Num {
	local($val) = @_;
	my (@col, $i, $num);

	if (!&ipAddrCheck($val)) {
		return 0;
	}
	@col = split(/\./, $val);
	if ($#col != 3) {
		return 0;
	}
	$num = 0;
	$num += ($col[0] << 24);
	$num += ($col[1] << 16);
	$num += ($col[2] << 8);
	$num += $col[3];

	return $num;
}

#--------------------------------------------------------------------
# 24 -> 255.255.255.0
#--------------------------------------------------------------------
sub bit2mask {
	local($bit) = @_;
	my ($mask, $m, $i);

	if (!&checkNum($bit, 1, 31)) {
		return 0;
	}
	$m = 0;
	for ($i = 0; $i < $bit; $i++) {
		$m += (1 << (31 - $i));
	}
	$mask = &num2Addr($m);
	return $mask; 
}

1;

