#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------

if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "option.cgi");
	exit(1);
}

$forwarders = $FORM{'forwarders'};
$forwardip = $FORM{"forwardip"};
$only = $FORM{"only"};
$query = $FORM{"query"};
$otheropt = $FORM{"option"};


$infilename = "/etc/named.conf";
$outfilename = "/etc/named.conf.tmp";

$tmp = $forwardip;
$tmp =~ s/[\n\r\s]//g;
if($tmp eq ""){
    $forwardip = "";
}

if(checkIPList($forwardip) == 0){
    &showErrorPage("forwardersͤǤ", "option.cgi");
    exit(1);
}


$InOptions = 0;
$level = 0;

open(INFILE, "$infilename");
open(OUTFILE, ">$outfilename");

while(<INFILE>)
{
    if($InOptions == 0){
	if(/^options\s*\{/){
	    $InOptions = 1;
	    $level = 1;
	}
	print OUTFILE $_;
	next;
    } else{
	# show 'directory' field
	if(/^\s*directory\s+\"/){
	    print OUTFILE $_;
	    next;
	}
	# ignore 'forward only;', query-source string
	if((/^\s*forward\s+only/) ||
	   (/^\s*query-source\s+address\s+\*\s+port\s+53\;/)){
	    next;
	}
        # ignore forwarders datas
	if(/^\s*forwarders/){
	    if(/\}/){
		next;
	    }
	    while(<INFILE>){
		if(/\}/){
		    last;
	        }
	    }
	    next;
	}
        $level += /\{/g;
        $level -= /\}/g;
	# search terminate string
	if((/^\}/) && ($level == 0)){
	    $InOptions = 0;
	    if($forwardip ne ""){
		$forwardip =~ s/\r//g;
		$forwardip =~ s/\n$//;
		$forwardip =~ s/\n/\n\t\t/g;
		$forwardip = "\t\t" . $forwardip . "\n";
		
		print OUTFILE "\tforwarders {\n$forwardip\t};\n";
	    }
	    if($only eq "on"){
		print OUTFILE "\tforward only\;\n";
	    }
	    if($query eq "on"){
		print OUTFILE "\tquery-source address * port 53\;\n";
	    }
	    if($otheropt ne ""){
		$otheropt =~ s/\r//g;
		$otheropt =~ s/\n$//;
		$otheropt =~ s/\n/\n\t/g;
		if($otheropt !~ /\n$/){
		    $otheropt = "\t" . $otheropt . "\n";
		}
		print OUTFILE $otheropt;
	    }
	    print OUTFILE $_;
	    next;
	}
	# ignore other option datas
#	print OUTFILE $_;
    }
}

close(INFILE);
close(OUTFILE);
unlink($infilename);
system("/bin/mv $outfilename $infilename");

if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

&showResultPage("","named.cgi");
