#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

## 20000511 1.1  1st release
#----------------------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------


if ($err = &readParam()) {
    $err = $STR_ERR_SYSTEM;
    &showErrorPage("$err", "named.cgi");
    exit(1);
}

$infilename = "/etc/named.conf";
$outfilename = "/etc/named.conf.tmp";


$oldtype = $FORM{'ZONE_TYPE'};
$zname = $FORM{'ZONE_NAME'};
$zfile = $FORM{'ZONE_FILE'};
$zonefile = $FORM{'zonefile'};
$type = $FORM{'type'};
$masters = $FORM{'masters'};
$aquerycheck = $FORM{'querycheck'};
$aquery =$FORM{'allow-query'};
$atransfercheck = $FORM{'transfercheck'};
$atransfer = $FORM{'allow-transfer'};
$other = $FORM{'other'};


$mode = "OutZone";
#$level = 0;		## del 20040226

$masters =~ s/\s*\r//g;
$masters =~ s/\n$//;
$masters =~ s/\n/\n\t\t/g;
$masters = "\t\t" . $masters . "\n";
$aquery =~ s/\s*\r//g;
$aquery =~ s/\n$//;
$atransfer =~ s/\s*\r//g;
$atransfer =~ s/\n$//;


#check paramaters
if ($type eq "slave" && $masters eq ""){
        &showErrorPage("mastersͤꤷƤ",
		       "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
        exit(1);
}

if(checkIPList2($aquery) == 0){
    &showErrorPage("allow-queryͤǤ",
		   "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
    exit(1);
}

if(checkIPList2($atransfer) == 0){
    &showErrorPage("allow-transferͤǤ",
		   "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
    exit(1);
}
if(($type eq "slave") && (checkIPList($masters) == 0)){
    &showErrorPage("mastersͤǤ",
		   "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
    exit(1);
}

if(checkNoPathFileName($zonefile) == 0){
    &showErrorPage("Zoneե̾ͤǤ",
		   "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
    exit(1);
}

$tmp = $aquery;
$tmp =~ s/\r//g;
$tmp =~ s/\n//g;
$tmp =~ s/\s//g;
if($tmp eq ""){
    $aquery = "";
}
$tmp = $atransfer;
$tmp =~ s/\r//g;
$tmp =~ s/\n//g;
$tmp =~ s/\s//g;
if($tmp eq ""){
    $atransfer = "";
}




open(INFILE, "$infilename");
open(OUTFILE, ">$outfilename");

while(<INFILE>){
    if(/^zone\s*\"(.*)\"/){
	if($1 eq $zname){
            print OUTFILE $_;
#            $level = 1;	## del 20040226
            $mode = "InZone";
	    next;
        }
    }
    if($mode eq "OutZone"){
        print OUTFILE $_;
    } elsif($mode eq "InZone"){
        # replace 'type' field
        if(/(.*type ).*\;/){
            print OUTFILE "$1$type;\n";
	    next;
        }
        # replace 'file' field
        if(/(.*file.*\")(.*)\"\;/){
            if($zonefile ne $2){
	        # change zone filename
		# check if already exist
		if(-e "/var/named/$zonefile"){
		    close(INFILE);
		    close(OUTFILE);
		    unlink($outfilename);
		    &showErrorPage("ꤵ줿Zoneե̾ϴ¸ߤޤ",
				   "property.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_TYPE=$oldtype");
		    exit(1);
		}

		print OUTFILE "$1$zonefile\";\n";
                system("/bin/mv /var/named/$2 /var/named/$zonefile");
            } else{
		print OUTFILE $_;
	    }
            next;
        }

        # replace 'masters', 'allow-query', "allow-transfer' field
        if((/.*masters.*{/) || (/\s*allow-query\s*\{/) ||
           (/\s*allow-transfer\s*\{/)){
	    # erase field
	    while(<INFILE>){
		if(/\}/){
		    last;
		}
	    }
	    next;
        }

        # [[ must check multiple blanket per line ]]
        # check finished blanket (comment:no count)
	$top = 0;			## add 20040226
	$end = 0;			## add 20040226
        if((/\{/) && !(/\;.*\{/)){
#            $level++;			## del 20040226
	    $top = 1;			## add 20040226
	}
        if((/\}/) && !(/\;.*\}/)){
#	    $level--;			## del 20040226
	    $end = 1;			## add 20040226
#	    if($level == 0){		## del 20040226
	    if($top == 0 && $end == 1){	## add 20040226
		# check not written allow-query, allow-transfer
		if($type eq "slave"){
		    print OUTFILE "\tmasters {\n$masters\t};\n";
		}
		# check not written allow-query, allow-transfer
		if($aquery ne ""){
		    $aquery =~ s/\n/\n\t\t/g;
		    $aquery = "\t\t" . $aquery . "\n";
		    print OUTFILE "\tallow-query {\n$aquery\t};\n";
		}
		if($atransfer ne ""){
		    $atransfer =~ s/\n/\n\t\t/g;
		    $atransfer = "\t\t" . $atransfer . "\n";
		    print OUTFILE "\tallow-transfer {\n$atransfer\t};\n";
		}
		if($other ne ""){
		    $other = "\t" . $other;
		    if($other !~ /\n$/){
			$other = $other . "\n";
		    }
		    $other =~ s/\n/\n\t/g;
		    $other =~ s/\r//g;
		    $other =~ s/\t$//;
		    print OUTFILE $other;
		}
		print OUTFILE $_;
                $mode = "OutZone";
            }
	}
    }
}

close(INFILE);
close(OUTFILE);
unlink($infilename);
system("/bin/mv $outfilename $infilename");


# Delete zone file if change 'master -> slave'
if(($oldtype eq "master") && ($type eq "slave")){
    unlink("/var/named/$zonefile");
}


# Create zone file if change 'slave -> master'
if(($oldtype eq "slave") && ($type eq "master")){
    unless(-e "/var/named/$zonefile"){
	unlink("/var/named/$zonefile");

        # generate serial number
	chomp($localhost =`hostname`);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdat) = localtime;
	$year += 1900;
	$mon++;
	if ($mday < 10)  { $mday = "0$mday";   }
	if ($mon < 10)  { $mon = "0$mon";   }
	$serialnum = $year . $mon . $mday . "00";

	$zone .= "@   IN      SOA     $localhost.     root.$localhost.      (\n";
	$zone .= "                    $serialnum\n";
	$zone .= "                    28800\n";
	$zone .= "                    14400\n";
	$zone .= "                    3600000\n";
	$zone .= "                    86400 \n";
	$zone .= ")\n\n";

	open(ZONEFILE, ">/var/named/$zonefile");
	print(ZONEFILE $zone);
	close(ZONEFILE);
    }
}

if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

&showResultPage("","named.cgi");
