# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: samba.pl,v 1.2 2002/10/18 12:23:47 snavi Exp $
# 000802 v4.1 requireν (oku)

require "../../../lib/wbmc.pl";


# SJIS -> EUC ɤ߹
sub readFileS2E {

    local($filename, $lockfile, *line) = @_;

    local(*LOCK);
    local(*IN);
    my($ret);
    my($lockfileflag);

    $ret = 0;
    $lockfileflag = 0;

    if ($filename eq "") {
	goto done;
    }

    if ($lockfile ne "") {
	if (!&lockFile($lockfile, $WBMC_LOCK_R_B, *LOCK)) {
	    goto done;
	}
	$lockfileflag = 1;
    }

    if (!open(IN, "/usr/bin/nkf -e $filename|")) {
	goto done;
    }
    @line = <IN>;
    close(IN);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
	close(LOCK);
    }

    return($ret);
}


# EUC -> SJIS ǽ񤭹
sub writeFileE2S {

    local($filename, $lockfile, @line) = @_;

    local(*LOCK);
    local(*OUT);
    my($ret);
    my($lockfileflag);
    my($tmpfile);
    my($filemode);

    $ret = 0;
    $lockfileflag = 0;
    $tmpfile = "$filename.$$";

    if ($filename eq "") {
	goto done;
    }

    if ($lockfile ne "") {
	if (!&lockFile($lockfile, 2, *LOCK)) {
	    goto done;
	}
	$lockfileflag = 1;
    }

    if (!open(OUT, "| /usr/bin/nkf -s > $tmpfile")) {
	goto done;
    }
    if (!print(OUT @line)) {
	close(OUT);
	goto done;
    }
    close(OUT);

    if (-e $filename) {
	$filemode = (stat($filename))[2];
    } else {
	$filemode = 0644;
    }

    if (!rename($tmpfile, $filename)) {
	goto done;
    }

    chmod($filemode & 07777, $filename);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
	close(LOCK);
    }

    if (-f $tmpfile) {
	unlink($tmpfile);
    }

    return($ret);
}

#
# Sambaեν
#
sub sambaInit
{
    my($err);
    my($smb_file);
    my($smb_lock);
    local(@file);
    my($i);
    my($global_flag);
    my($global_find);
    my($global_line);
    my($encrypt_find);
    my($smbpasswd_find);
    my($deadtime_find);
    my($write_flag);

    $err = "";
    $smb_file = "/etc/samba/smb.conf";
    $smb_lock = "smb.conf";
    $global_flag = 0;
    $global_find = 0;
    $global_line = 0;
    $encrypt_find = 0;
    $smbpasswd_find = 0;
    $deadtime_find = 0;
    $write_flag = 0;

    # smb.conf ɤ߹
    if (!&readFileS2E($smb_file, $smb_lock, *file)) {
	$err = "$smb_file ɤ߹ߤ˼Ԥޤ";
	goto done;
    }

    for ($i = 0; $i < @file; $i++) {
	if ($file[$i] =~ /^\s*#/) {
		next;
	}
	if ($file[$i] =~ /^\s*;/) {
		next;
	}

	if ($global_flag == 1 && $file[$i] =~ /^\s*\[/) {
		$global_flag = 0;
	}
	if ($file[$i] =~ /^\s*\[global\]\s*$/i) {
		$global_flag = 1;
		$global_find = 1;
		$global_line = $i;
		next;
	}

	# encrypt password : exist
	if ($global_flag == 1 && 
	    $file[$i] =~ /^\s*encrypt\s+passwords\s*=\s*yes\s*$/i) {
		$encrypt_find = 1;
	}
	# encrypt password = no -> yes ѹ
	if ($global_flag == 1 && 
	    $file[$i] =~ /^\s*encrypt\s+passwords\s*=/i) {
		$file[$i] = "\tencrypt passwords = yes\n";
		$encrypt_find = 1;
		$write_flag = 1;
	}

	# smb passwd file : exist
	if ($global_flag == 1 &&
	    $file[$i] =~ /^\s*smb\s+passwd\s+file\s*=\s*\/etc\/smbpasswd\s*$/i) {
		$smbpasswd_find = 1;
	}
	# smb passwd file = /etc/smbpasswd ѹ
	if ($global_flag == 1 && $smbpasswd_find != 1 &&
	    $file[$i] =~ /^\s*smb\s+passwd\s+file\s*=\s*/i) {
		$file[$i] = "\tsmb passwd file = /etc/smbpasswd\n";
		$smbpasswd_find = 1;
		$write_flag = 1;
	}

	# deadtime = : exist
	if ($global_flag == 1 && 
	    $file[$i] =~ /^\s*deadtime\s*=\s*([^\s]+)/i) {
		$deadtime_find = 1;
		if (&parseUint($1) < 0) {
			$file[$i] = "\tdeadtime = 5\n";
			$write_flag = 1;
		}
	}
    }

    if (!$global_find) {
	splice(@file,$global_line,0,"[global]\n");
	splice(@file,$global_line+1,0,"\tencrypt passwords = yes\n");
	splice(@file,$global_line+1,0,"\tsmb passwd file = /etc/smbpasswd\n");
	splice(@file,$global_line+1,0,"\tdeadtime = 5\n");
	$encrypt_find = 1;
	$smbpasswd_find = 1;
	$deadtime_find = 1;
	$write_flag = 1;
    }

    # encrypt password ɲ
    if ($encrypt_find == 0) {
	splice(@file,$global_line+1,0,"\tencrypt passwords = yes\n");
	$write_flag = 1;
    }

    # smb passwd file ɲ
    if ($smbpasswd_find == 0) {
	splice(@file,$global_line+1,0,"\tsmb passwd file = /etc/smbpasswd\n");
	$write_flag = 1;
    }

    # deadtime ɲ
    if ($deadtime_find == 0) {
	splice(@file,$global_line+1,0,"\tdeadtime = 5\n");
	$write_flag = 1;
    }

    # ե񤭹
    if ($write_flag == 1) {
	if (!writeFileE2S($smb_file, $smb_lock, @file)) {
	    $err = "$smb_file ν񤭹ߤ˼Ԥޤ";
	    goto done;
	}
    }

done:
    return($err);
}

1;

