#!/bin/bash

# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: aft_alb_init_mw03.sh,v 1.4 2002/10/12 01:36:24 snavi Exp $

IPADDR=$1
NETMSK=$2
NETADDR=$3
BCASTADDR=$4
MODE=$5

ETHER0="eth0"
ETHER1="eth1"
ETHER0_CFG_FILE="ifcfg-eth0"
ETHER1_CFG_FILE="ifcfg-eth1"

IANS="ians"
IANS_SCPT_FILE="ans"
IANS_MODULE_TGZ="ians-1.7.65.tar.gz"
IANS_CFG_FILE="ians.conf"

TEAM="MAILWEB"
VIRTUAL_NAME="vad"

SOURCE_DIR="/opt/nec/wbmc/adm/system/aftalb/ians"
SCRIPT_DIR="/etc/rc.d/init.d"
IANS_DIR="iANS-1.7.65"
IANS_SRC_DIR="$IANS_DIR/src"
IANS_SCPT_DIR="$IANS_DIR/install_scripts/Redhat"
IANS_CFG_DIR="/etc/ians"
NET_SCPT_DIR="/etc/sysconfig/network-scripts"

#
# STEP 0
#

# open IANS_MODULE_TGZ
cd $SOURCE_DIR
tar zxvf $IANS_MODULE_TGZ

# change directory to SOURCE_DIR/IANS_SRC_DIR and install
cd $SOURCE_DIR/$IANS_SRC_DIR
make install

#
# STEP 1
#

# down NIC
ifconfig $ETHER0 down
ifconfig $ETHER1 down

# install IANS module
insmod $IANS

# AFT/ALB configuration
ianscfg -a -t $TEAM -M $MODE
ianscfg -C -t $TEAM -M $MODE
ianscfg -a -t $TEAM -m $ETHER0 -p primary
ianscfg -a -t $TEAM -m $ETHER1 -p secondary
ianscfg -a -t $TEAM -v $VIRTUAL_NAME
ianscfg -c $TEAM

# check configuration
ifconfig $VIRTUAL_NAME $IPADDR netmask $NETMSK
ianscfg -s

#
# STEP 2
#

# make directory IANS_CFG_DIR
mkdir -p $IANS_CFG_DIR

# write configuration
ianscfg -w -f $IANS_CFG_DIR/$IANS_CFG_FILE

#
# STEP 3
#

# change directory to NET_SCPT_DIR
cd $NET_SCPT_DIR

# change ETHER0 and ETHER11 ONBOOT configuration
sed -e 's/ONBOOT=.*/ONBOOT=no/g' $ETHER0_CFG_FILE > $ETHER0_CFG_FILE.tmp
sed -e 's/ONBOOT=.*/ONBOOT=no/g' $ETHER1_CFG_FILE > $ETHER1_CFG_FILE.tmp
mv -f $ETHER0_CFG_FILE.tmp $ETHER0_CFG_FILE
mv -f $ETHER1_CFG_FILE.tmp $ETHER1_CFG_FILE

# make virtual adapter configuration file
echo DEVICE="$VIRTUAL_NAME" > ifcfg-"$VIRTUAL_NAME"
echo IPADDR="$IPADDR" >> ifcfg-"$VIRTUAL_NAME"
echo NETMASK="$NETMSK" >> ifcfg-"$VIRTUAL_NAME"
echo NETWORK="$NETADDR" >> ifcfg-"$VIRTUAL_NAME"
echo BROADCAST="$BCASTADDR" >> ifcfg-"$VIRTUAL_NAME"
echo ONBOOT="yes" >> ifcfg-"$VIRTUAL_NAME"
echo BOOTPROTO="none" >> ifcfg-"$VIRTUAL_NAME"

#
# STEP 4
#

# copy ans to /etc/rc.d/init.d
cp -f $SOURCE_DIR/$IANS_SCPT_DIR/$IANS_SCPT_FILE $SCRIPT_DIR

# execute chkconfig command
chkconfig --level 345 $IANS_SCPT_FILE on

# clean temporary files
rm -rf $SOURCE_DIR/$IANS_DIR
