#!/bin/bash
# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

LOGGER=/usr/bin/logger
DATE=/bin/date
MAIL="/bin/mail -s"
MAIL_SUBJECT="SOFTWARE RAID TROUBLE"
MAIL_TO=root
BROKEN_MES="MIRROR DISK $1 broke down."
MDSTAT=/proc/mdstat
#MDSTAT=/tmp/mdstat
CURRENT_TIME=`LANG=C $DATE "+%b %d %T"`
FLAG_FILE="/var/opt/nec/wbmc/raid-check.flg"

if [ ! -e $FLAG_FILE ] ; then
	exit 0;
fi

function checkraid
{
	DISK="ok"
	cat $MDSTAT | while read i ; do
		if echo $i | grep -e '^md' > /dev/null; then
			if echo $i | grep hdb | grep hda > /dev/null ; then
				/bin/true
			elif echo $i | grep hda > /dev/null ; then
				echo "hdb"
			else
				echo "hda"
			fi
		fi
	done
	echo $DISK
}

function write_syslog
{
	$LOGGER "MIRROR DISK $1 broke down."
}

function mail_to_root
{
	$MAIL  "$MAIL_SUBJECT" "$MAIL_TO" << EOM
$CURRENT_TIME $HOSTNAME "MIRROR DISK $1 broke down."
EOM
}

# main
BROKEN_DISK=`checkraid|head -n 1`
if [ "$BROKEN_DISK" != "ok" ] ; then
	write_syslog $BROKEN_DISK
	mail_to_root $BROKEN_DISK
	rm $FLAG_FILE
fi
