# $Id: wbmc_dist_conf.pl,v 1.12 2003/03/26 05:31:41 snavi Exp $ 
# $Revision: 1.12 $ 
# $Date: 2003/03/26 05:31:41 $

use IPC::Open3;
use IO::Socket;

require "/opt/nec/wbmc/lib/wbmc.pl";

$wbmc_dc_ssh_prog = '/usr/bin/ssh';
$wbmc_dc_scp_prog = '/usr/bin/scp';
$wbmc_dc_scp_opt = '-p -B -q';
#$wbmc_dc_neighbor_list = 'cluster_server';
#$wbmc_dc_master_flag = 'cluster_flg';
$wbmc_dc_neighbor_list = '/etc/opt/nec/cluster_server';
$wbmc_dc_master_flag = '/etc/opt/nec/cluster_flg';

sub wbmc_dc_is_master {
    open(FLAG_FILE, $wbmc_dc_master_flag);
    my $flag = <FLAG_FILE>;
    close(FLAG_FILE);
    if($flag =~ /^master/) {
	return 1;
    } else {
	return 0;
    }
}

## cluster_server t@Cǂݍ
sub parse_server_list {
    my($file) = @_;
    #  i[ꏊj
    #         /etc/opt/nec/cluster_server
    #  `j
    #         IPAhX  T[o [m|o]
    #         T[óA"m" B
    #         T[óA"o" B
    #  j
    #         10.8.45.111       server1  o
    #         10.8.45.112       server2  m
    #         10.8.45.113       server3  o
    #         10.8.45.114       server4  o
    my @server_list = ();
    open(INFILE, $file);
    while(<INFILE>) {
	$line = $_;
	if ($line !~ /\s*[0-9]+\./) {
	    next;
	}
	@server = split(/\s/, $line, 3);
	$me_flag = $server[2];
	if ($me_flag =~ /m/) {
	    next;
	}
	push(@server_list, [$server[0], $server[1]])
    }
    close(INFILE);
    return @server_list;
}

## eT[o file copy
sub wbmc_dc_cp {
    my($filename) = @_;
    my(@list) = &parse_server_list($wbmc_dc_neighbor_list);  
    my @result_list = ();
    my $result;
    #&real_wbmc_conf_edit_for_master(); # add 20021029 -> del 20030326
    #&ftpaccess_edit_for_master($filename); # add 20021028 -> del 20030326
    for $host (@list) {
        #$local_file_name = &wbmc_conf_edit_for_slave($filename, $host->[0]); # add 20021019 -> del 20030326
	$result = &wbmc_dc_cp_sigle_host($filename, $filename, $host->[0]);
	#$result = &wbmc_dc_cp_sigle_host($local_file_name, $filename, $host->[0]); # add 20021019 ιԤؤ -> del 20030326
	push(@result_list, $result);
    }
    #&wbmc_conf_edit_for_master($filename); # add 20021019 -> del 20030326
    return @result_list;
}

## eT[o ssh  command s
sub wbmc_dc_rsh {
    my($cmdline) = @_;
    my(@list) = &parse_server_list($wbmc_dc_neighbor_list);  
    my @result_list = ();
    my $result;
    for $host (@list) {
	$result = &wbmc_dc_rsh_sigle_host($cmdline, $host->[0], 'root');
	push(@result_list, $result);
    }
    return @result_list;
}

sub wbmc_dc_cp_sigle_host {
    my($filename, $remote_path, $addr) = @_;
    my($pid);
    my($message) = '';
    my($port,$paddr);

    if (&cluster_typechk() eq "cluster") {
        &writeLog("failover skip", "wbmc_cluster", "/var/log/wbmc_cluster");
        return [$addr, $?, $message];
    }

    if ($message = &wbmc_dc_connect_chk($addr ,23)) {
        &writeLog("$addr:$message", "wbmc_cluster", "/var/log/wbmc_cluster");
        $message = "";
        return [$addr, $?, $message];
    }
 
    $pid = open3('WRITER', 'READER', '', 
		 $wbmc_dc_scp_prog . ' ' .
		 $wbmc_dc_scp_opt . ' ' .
		 $filename . ' ' .
		 $addr . ':' . $remote_path);
 
    system("/opt/nec/wbmc/bin/wbmc_dc_pid $pid &");

    while(<READER>) {
	$message .= $_;
	if ($_ =~ /password/) {
	    print STDERR 'invalid sshd configuration on ', $addr, "\n";
	    $message .= "\n" . 'invalid sshd configuration on '. $addr . "\n";
	    last;
	}
    }
    close(READER);
    close(WRITER);
    waitpid($pid, 0);
    return [$addr, $?, $message];
}
# $pid = open3('WTRFH', 'RDRFH', 'ERRFH'
#                         'some cmd and args', 'optarg', ...)

sub wbmc_dc_rsh_sigle_host {
    my($cmdline, $addr, $user) = @_;
    my($pid);
    my($message) = '';

    if ($message = &wbmc_dc_connect_chk($addr ,23)) {
        &writeLog("$addr:$message", "wbmc_cluster", "/var/log/wbmc_cluster");
        $message = "";
        return [$addr, $?, $message];
    }

    $pid = open3('WRITER', 'READER', '', 
		 $wbmc_dc_ssh_prog . ' ' .
		 $wbmc_dc_ssh_opt . ' ' .
		 '-l ' . $user . ' ' .
		 $addr . ' ' .
		 $cmdline);

    system("/opt/nec/wbmc/bin/wbmc_dc_pid $pid &");

    while(<READER>) {
	$message .= $_;
    }
    close(WRITER);
    close(READER);
    waitpid($pid, 0);
    return [$addr, $?, $message];
}

sub wbmc_dc_connect_chk {

    my($host, $port) = @_;
    my($sockaddr, $name, $alias, $proto);
    my($type, $len, $hostaddri, $sock, $hostaddr);
    my($message) = '';

    $sockaddr = 'S n a4 x8';
    ($name, $alias, $proto) = getprotobyname('tcp');
    ($name, $alias, $type, $len, $hostaddr) = gethostbyname($host);
    $sock = pack($sockaddr, &AF_INET, $port, $hostaddr);
    if (!socket(SOCKHND, &PF_INET, &SOCK_STREAM, $proto)) {
        $message = "can not create socket" ;
    } 
    if (!connect(SOCKHND, $sock)) {
        if ($! =~ /Connection refused/) {
        } else {
            $message = "can not connect:$!";
        }
    }
    close SOCKHND;
    return $message;
}

# wbmc_conf_edit_for_slave
#
# add 20021019 RedHat7.3LBԶѽ
# slavewbmc.confIPʬslaveʪѹ롣
#
sub wbmc_conf_edit_for_slave
{
    local($check_file_name) = "/etc/httpd/conf/wbmc.conf";
    local($out_put_file) = "/opt/nec/tmp/wbmc.conf.slave";
    local(@port_list_listen) = ();
    local(@port_list_nmvhst) = ();
    local($type);
    local($del_flg);

    local($file_name, $host) = @_;


    $type = &cluster_typechk();
    if ($type ne "mirror") {
        return($file_name);
    }
    if ($file_name eq $check_file_name) {
        &readFile("$file_name", "WBMC_CONF_SLAVE", *line);
    }
    else {
        return($file_name);
    }

    for ($i = 0; $i <= $#line; $i++) {
        $del_flg = 0;
        if ($line[$i] =~ /^<VirtualHost\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            splice(@line, $i, 1, "<VirtualHost $host:$port>\n");
            next;
        }
        if ($line[$i] =~ /^Listen\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            foreach (@port_list_listen) {
                if ($_ eq $port) {
                    $del_flg = 1;
                    next;
                }
            }
            if ($del_flg == 0) {
                splice(@line, $i, 1, "Listen $host:$port\n");
                push(@port_list_listen, $port);
                next;
            }
            else {
                splice(@line, $i, 1);
                $i--;
                next;
            }
        }
        if ($line[$i] =~ /^NameVirtualHost\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            foreach (@port_list_nmvhst) {
                if ($_ eq $port) {
                    $del_flg = 1;
                    next;
                }
            }
            if ($del_flg == 0) {
                splice(@line, $i, 1, "NameVirtualHost $host:$port\n");
                push(@port_list_nmvhst, $port);
                next;
            }
            else {
                splice(@line, $i, 1);
                $i--;
                next;
            }
        }
    }

    &writeFile("$out_put_file", "WBMC_CONF_SLAVE", @line);

    return ($out_put_file);
}

# wbmc_conf_edit_for_master
#
# add 20021019 RedHat7.3LBԶѽ
# masterwbmc.confIPʬIPѹshadow_wbmc.confȤ
#
sub wbmc_conf_edit_for_master
{
    local($in_put_file) = @_;
    local($file_name) = "/etc/httpd/conf/wbmc.conf";
    local($real_file_name) = "/etc/httpd/conf/realwbmc.conf";
    local($out_put_tmp_file) = "/opt/nec/tmp/shadow_wbmc.conf";
    local($out_put_file) = "/etc/httpd/conf/shadow_wbmc.conf";
    local(@port_list_listen) = ();
    local(@port_list_nmvhst) = ();
    local($type);
    local($del_flg);


    if ($in_put_file ne $file_name) {
        return(0);
    }
    $type = &cluster_typechk();
    if ($type ne "mirror") {
        return(0);
    }
    &readFile("$real_file_name", "REALWBMC_CONF", *line);
    for ($i = 0; $i <= $#line; $i++) {
        #if ($line[$i] =~ /^NameVirtualHost\s/) {
        if ($line[$i] =~ /<VirtualHost\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /(\d+\.\d+\.\d+\.\d+)\:(\d+)/) {
                $host = $1;
                push(@port_list_listen, $2);
                push(@port_list_nmvhst, $2);
            }
        }
    }

    &readFile("$file_name", "WBMC_CONF_MASTER", *line);
    for ($i = 0; $i <= $#line; $i++) {
        $del_flg = 0;
        if ($line[$i] =~ /^<VirtualHost\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            splice(@line, $i, 1, "<VirtualHost $host:$port>\n");
            next;
        }
        if ($line[$i] =~ /^Listen\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            foreach (@port_list_listen) {
                if ($_ eq $port) {
                    $del_flg = 1;
                    next;
                }
            }
            # 20030324 ListenԤϾäʤ褦
            #if ($del_flg == 0) {
                splice(@line, $i, 1, "Listen $host:$port\n");
                push(@port_list_listen, $port);
                next;
            #}
            #else {
            #    splice(@line, $i, 1);
            #    $i--;
            #    next;
            #}
        }
        if ($line[$i] =~ /^NameVirtualHost\s/) {
            @ent = split(/\s/, $line[$i]);
            if ($ent[1] =~ /\:(\d+)/) {
                $port = $1;
            }
            foreach (@port_list_nmvhst) {
                if ($_ eq $port) {
                    $del_flg = 1;
                    next;
                }
            }
            if ($del_flg == 0) {
                splice(@line, $i, 1, "NameVirtualHost $host:$port\n");
                push(@port_list_nmvhst, $port);
                next;
            }
            else {
                splice(@line, $i, 1);
                $i--;
                next;
            }
        }
    }

    &writeFile("$out_put_tmp_file", "WBMC_CONF_MASTER_TMP", @line);
    system("/bin/mv $out_put_tmp_file $out_put_file > /dev/null 2>&1");
    &httpd_conf_edit_for_master();

    return(0);

}

# httpd_conf_edit_for_master
#
# add 20021019 RedHat7.3LBԶѽ
# masterhttpd.confIncludewbmc.confshadow_wbmc.confѹ롣
#
sub httpd_conf_edit_for_master
{
    local($file_name) = "/etc/httpd/conf/httpd.conf";
    local($include_file) = "/etc/httpd/conf/shadow_wbmc.conf";
    local($out_put_tmp_file) = "/opt/nec/tmp/httpd.conf.tmp";


    &readFile("$file_name", "HTTPD_CONF_MASTER", *line);
    for ($i = 0; $i <= $#line; $i++) {
        #if ($line[$i] =~ /^Include\s\/etc\/httpd\/conf\/wbmc.conf\s/) {
        if ($line[$i] =~ /\/wbmc.conf\s*/) {
            if ( -e $include_file) {
                splice(@line, $i, 1, "Include /etc/httpd/conf/shadow_wbmc.conf\n");
                next;
            }
        }
    }

    &writeFile("$out_put_tmp_file", "HTTPD_CONF_MASTER_TMP", @line);
    system("/bin/mv $out_put_tmp_file $file_name > /dev/null 2>&1");
    return(0);
}

# httpd_conf_edit_for_slave
#
# add 20021029 RedHat7.3LBԶѽ
# slavehttpd.confIncludeshadow_wbmc.confwbmc.confѹ롣
#
sub httpd_conf_edit_for_slave
{
    local($file_name) = "/etc/httpd/conf/httpd.conf";
    #local($include_file) = "/etc/httpd/conf/shadow_wbmc.conf";
    #local($include_file) = "/etc/httpd/conf/wbmc.conf";
    local($out_put_file) = "/opt/nec/tmp/httpd.conf_slave.tmp";


    &readFile("$file_name", "HTTPD_CONF_SLAVE", *line);
    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /shadow_wbmc.conf\s*/) {
            splice(@line, $i, 1, "Include /etc/httpd/conf/wbmc.conf\n");
            next;
        }
    }

    &writeFile("$out_put_file", "HTTPD_CONF_SLAVE_TMP", @line);
    system("/bin/mv $out_put_file $file_name > /dev/null 2>&1");
    return(0);
}

# real_wbmc_conf_edit_for_master
#
# add 20021019 RedHat7.3LBԶѽ
# masterrealwbmc.confListenNameVirtualHost񤯡
#
sub real_wbmc_conf_edit_for_master
{
    local($real_file_name) = "/etc/httpd/conf/realwbmc.conf";
    local($out_put_file) = "/opt/nec/tmp/realwbmc.conf.tmp";
    local($type);


    $type = &cluster_typechk();
    if ($type ne "mirror") {
        return(0);
    }
    $liten_flg = 0;
    $nvhst_flg = 0;
    &readFile("$real_file_name", "REAL_WBMC_CONF", *line);
    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /^Listen\s/) {
            splice(@line, $i, 1);
            $i--;
            next;
        }
        if ($line[$i] =~ /^NameVirtualHost\s/) {
            splice(@line, $i, 1);
            $i--;
            next;
        }
    }

    &writeFile("$out_put_file", "REAL_WBMC_CONF", @line);
    system("/bin/mv $out_put_file $real_file_name > /dev/null 2>&1");

    return(0);

}

# cluster_typechk
#
# add 20021026 RedHat7.3LBԶѽ
# 饹֤Υ⡼ɼ롣/opt/nec/wbmc/lib/cluster_com.plήѤǤ
#
sub cluster_typechk
{
        my($filename,$cluster_type);
        local(*MT);
        my(@line);

        $cluster_type = "";
        # 饹פ
        $filename = "/etc/opt/nec/clustertype";
        if (-e $filename) {
                if (open(MT, $filename)) {
                        @line = <MT>;
                        close(MT);

                        if (defined($line[0])) {
                                $line[0] =~ s/^\s*//;
                                $line[0] =~ s/\s*$//;
                                if ($line[0] ne "") {
                                        $cluster_type = $line[0];
                                }
                        }
                }
    }
        return $cluster_type;
}

# ftpaccess_edit_for_slave
#
# add 20021028 RedHat7.3LBԶѽ
# slaveftpaccessIPʬslaveʪѹ롣
#
sub ftpaccess_edit_for_slave
{
    local($check_file_name) = "/etc/ftpaccess";
    local($out_put_file) = "/opt/nec/tmp/ftpaccess.slave";
    local(@port_list_listen) = ();
    local(@port_list_nmvhst) = ();
    local($b_flg);
    local($type);

    local($file_name, $host) = @_;


    $type = &cluster_typechk();
    if ($type ne "mirror") {
        return($file_name);
    }
    if ($file_name eq $check_file_name) {
        &readFile("$file_name", "FTPACCESS_SLAVE", *line);
    }
    else {
        return($file_name);
    }

    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /^virtual\s/) {
        #if ($line[$i] =~ /^virtual\s\d+\:\d+\:\d\+:\d+\sallow/) {
            @ent = split(/\s+/, $line[$i]);
            $ent[1] = $host;
            foreach (@ent) {
                if ($b_flg == 0) {
                    $ftp_access_line .= $_;
                    $b_flg = 1;
                }
                else {
                    $ftp_access_line .= " ";
                    $ftp_access_line .= $_;
                }
            }
            #$ftp_access_line .= "\n";
            splice(@line, $i, 1, "$ftp_access_line\n");
            $ftp_access_line = "";
            $b_flg = 0;
            next;
        }
    }

    &writeFile("$out_put_file", "FTPACCESS_SLAVE", @line);

    return ($out_put_file);
}

# ftpaccess_edit_for_master
#
# add 20021028 RedHat7.3LBԶѽ
# masterftpaccessIPʬIPѹ롣
#
sub ftpaccess_edit_for_master
{
    local($in_put_file) = @_;
    local($file_name) = "/etc/ftpaccess";
    local($real_file_name) = "/etc/opt/nec/cluster_server";
    local($out_put_file) = "/opt/nec/tmp/ftpaccess.master";
    local($type);


    if ($in_put_file ne $file_name) {
        return(0);
    }
    $type = &cluster_typechk();
    if ($type ne "mirror") {
        return(0);
    }
    &readFile("$real_file_name", "CLUSTER_SERVER", *line);
    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /m$/) {
            @ent = split(/\s/, $line[$i]);
            $host = $ent[0];
        }
    }

    &readFile("$file_name", "FTPACCESS_MASTER", *line);
    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /^virtual\s/) {
            @ent = split(/\s+/, $line[$i]);
            if (($ent[2] eq "allow") && ($ent[3] =~ /\@/)) {
                $ent[1] = $host;
                foreach (@ent) {
                    if ($b_flg == 0) {
                        $ftp_access_line .= $_;
                        $b_flg = 1;
                    }
                    else {
                        $ftp_access_line .= " ";
                        $ftp_access_line .= $_;
                    }
                }
                #$ftp_access_line .= "\n";
                splice(@line, $i, 1, "$ftp_access_line\n");
                $ftp_access_line = "";
                $b_flg = 0;
                next;
            }
        }
    }

    &writeFile("$out_put_file", "FTPACCESS_MASTER_TMP", @line);
    system("/bin/mv $out_put_file $file_name > /dev/null 2>&1");

    return(0);

}

1;
