# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: confedit.pl,v 1.1.1.1 2002/09/09 07:43:35 snavi Exp $

#----------------------------------------------------------------------------
require "/opt/nec/wbmc/lib/dns/named.pl";
require "/opt/nec/wbmc/lib/dns/confread.pl";
require "/opt/nec/wbmc/lib/dns/confwrite.pl";

#----------------------------------------------------------------------------
sub addDomain {
	local ($cfname, $zname, $mode, $machine, $contact, *ms, *ns, *mx) = @_;
	my($err);

	$err = 0;
	$zz->{"keywd"} = "zone";
	$zz->{"zname"} = "$zname";
	if ($#ms >= 0) {
		$zz->{"type"} = "slave";
	}
	else {
		$zz->{"type"} = "master";
	}
	$zz->{"file"} = "$mode.$zname";
	$zz->{"file"} =~ s/\//\_/g;
	$zz->{"masters"}->{"argc"} = $#ms+1;
	for ($i = 0; $i <= $#ms; $i++) {
		$zz->{"masters"}->{$i} = $ms[$i];
	}
	if ($err = &addZone($cfname, $mode,
			$machine, $contact, *zz, *ns, *mx)) {
		return $err;
	}
	return $err;
}

sub delDomain {
	local ($cfname, $zname, $ztype) = @_;

	$err = &delZone($cfname, $zname, $ztype);

	return $err;
}

sub delNetwork {
	local ($cfname, $zname, $ztype) = @_;
	my ($addr, $tmpcfname, $workdir, $rrfilename, $fp,
		$i, $j, $delete, @zfiles, $err);

	$err = 0;
	$workdir = ".";
	@zfiles = ();

	$addr = &reverse2Net($zname);
	if (!($addr = &getFullNet($addr))) {
#	if (!($addr = getAddr($zname))) {
		$err = "delNetwork:$STR_ERR_BADVALUE";
		return $err;
	}
	$aclname = "net_$addr";

	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "options") {
			next;
		}
		if ($confs[$i]->{directory}) {
			$workdir = $confs[$i]->{directory};
			last;
		}
	}
	$delete = 0;
	for ($i = 0, $j = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} eq "zone") {
			if ($confs[$i]->{zname} eq $zname) {
				$rrfilename = "$workdir/$confs[$i]->{file}";
				$zfiles[$j++] = $rrfilename;
				splice(@confs, $i, 1);
				$i--;
				$delete = 1;
			}
			else {
				&delAclCode($confs[$i], $aclname);
			}
		}
		elsif ($confs[$i]->{keywd} eq "acl") {
			if ($confs[$i]->{name} eq $aclname) {
				splice(@confs, $i, 1);
				$i--;
			}
		}
		else {
			&delAclCode($confs[$i], $aclname);
		}
	}
	if ($delete == 0) {
#		$err = "delNetwork:$STR_ERR_NOSUCHZONE($zname)";
#		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delNetwork:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "delNetwork:$STR_ERR_CANTOPENFILE($tmpcfname)";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
		for ($i = 0; $i <= $#zfiles; $i++) {
			unlink($zfiles[$i]);
		}
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

sub combPrivateZoneNet {
	local($cfname, $zname, $net) = @_;
	my($aclname, $argc, $value, $i, $j, $fp, $tmpcfname, $err);

	$err = 0;
	if (!($addr = &getFullNet($net))) {
#	if (!($addr = &getNet($net))) {
		$err = "combPrivateZoneNet:$STR_ERR_BADNETWORK";
		return $err;
	}
	$aclname = "net_$addr";
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "acl") {
			next;
		}
		if ($confs[$i]->{name} eq $aclname) {
			last;
		}
	}
	if ($i > $#confs) {
		$acl->{"keywd"} = "acl";
		$acl->{"name"} = "$aclname";
		$acl->{"acl"}->{"argc"} = 2;
		$acl->{"acl"}->{0} = "$net";
		$acl->{"acl"}->{1} = "localhost";
		unshift(@confs, $acl);
	}

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}


		if ($confs[$i]->{zname} eq $zname) {
			last;
		}
	}
	if ($i > $#confs) {
		$err = "combPrivateZoneNet:$STR_ERR_NOSUCHZONE";
		return $err;
	}
	$argc = $confs[$i]->{"allow-query"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$value = $confs[$i]->{"allow-query"}->{$j};
		if ($value eq "none" || $value eq "any") {
			$confs[$i]->{"allow-query"}->{$j} = "$aclname";
			last;
		}
		elsif ($value eq $aclname) {
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-query"}->{"argc"} = $j+1;
		$confs[$i]->{"allow-query"}->{$j} = "$aclname";
	}

#	$argc = $confs[$i]->{"allow-update"}->{"argc"};
#	for ($j = 0; $j < $argc; $j++) {
#		$value = $confs[$i]->{"allow-update"}->{$j};
#		if ($value eq "none" || $value eq "any") {
#			$confs[$i]->{"allow-update"}->{$j} = "$aclname";
#			last;
#		}
#		elsif ($value eq $aclname) {
#			last;
#		}
#	}
#	if ($j >= $argc) {
#		$confs[$i]->{"allow-update"}->{"argc"} = $j+1;
#		$confs[$i]->{"allow-update"}->{$j} = "$aclname";
#	}

	$argc = $confs[$i]->{"allow-transfer"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$value = $confs[$i]->{"allow-transfer"}->{$j};
		if ($value eq "none" || $value eq "any") {
			$confs[$i]->{"allow-transfer"}->{$j} = "$aclname";
			last;
		}
		elsif ($value eq $aclname) {
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-transfer"}->{"argc"} = $j+1;
		$confs[$i]->{"allow-transfer"}->{$j} = "$aclname";
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "combPrivateZoneNet:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "combPrivateZoneNet:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}

	return $err;
}

sub combGlobalZoneNs {
	local($cfname, $zname, *ns) = @_;
	my($aclname, $argc, $value, $i, $j, $k, $fp, $tmpcfname, $err);

	$err = 0;
	$aclname = "secondary-ns";
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "acl") {
			next;
		}
		if ($confs[$i]->{name} eq $aclname) {
			last;
		}
	}
	if ($i > $#confs) {
		$acl->{"keywd"} = "acl";
		$acl->{"name"} = "$aclname";
		$acl->{"acl"}->{"argc"} = $#ns + 1;
		for ($k = 0; $k <= $#ns; $k++) {
			$acl->{"acl"}->{$k} = $ns[$k];
		}
		unshift(@confs, $acl);
	}
	else {
		$argc = $confs[$i]->{"acl"}->{"argc"};
		for ($k = 0; $k <= $#ns; $k++) {
			for ($j = 0; $j < $argc; $j++) {
				if ($ns[$k] eq $confs[$i]->{"acl"}->{$j}) {
					last;
				}
			}
			if ($j < $argc) {
				next;
			}
			$argc++;
			$confs[$i]->{"acl"}->{"argc"} = $argc;
			$confs[$i]->{"acl"}->{$j} = $ns[$k];
		}
	}


	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}


		if ($confs[$i]->{zname} eq $zname) {
			last;
		}
	}
	if ($i > $#confs) {
		$err = "combGlobalZoneNs:$STR_ERR_NOSUCHZONE($zname)";
		return $err;
	}
	$argc = $confs[$i]->{"allow-query"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$value = $confs[$i]->{"allow-query"}->{$j};
		if ($value eq "none") {
			$confs[$i]->{"allow-query"}->{$j} = "any";
			last;
		}
		elsif ($value eq "any") {
			last;
		}
	}
	if ($argc == 0) {
		$confs[$i]->{"allow-query"}->{"argc"} = 1;
		$confs[$i]->{"allow-query"}->{$j} = "any";
	}

#	$argc = $confs[$i]->{"allow-update"}->{"argc"};
#	for ($j = 0; $j < $argc; $j++) {
#		$value = $confs[$i]->{"allow-update"}->{$j};
#		if ($value eq "none" || $value eq "any") {
#			$confs[$i]->{"allow-update"}->{$j} = "$aclname";
#			last;
#		}
#		elsif ($value eq $aclname) {
#			last;
#		}
#	}
#	if ($j >= $argc) {
#		$confs[$i]->{"allow-update"}->{"argc"} = $j+1;
#		$confs[$i]->{"allow-update"}->{$j} = "$aclname";
#	}

	$argc = $confs[$i]->{"allow-transfer"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$value = $confs[$i]->{"allow-transfer"}->{$j};
		if ($value eq "none" || $value eq "any") {
			$confs[$i]->{"allow-transfer"}->{$j} = "$aclname";
			last;
		}
		elsif ($value eq $aclname) {
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-transfer"}->{"argc"} = $j+1;
		$confs[$i]->{"allow-transfer"}->{$j} = "$aclname";
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "combGlobalZoneNet:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "combGlobalZoneNs:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}

	return $err;
}

sub addSecondNs {
	local($cfname, *ns) = @_;
	my($argc, $value, $elm, $addflag, $i, $j, $k, $tmpcfname, $err);

	$err = 0;

	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} ne "acl") {
			next;
		}
		if ($confs[$i]->{"name"} eq "secondary-ns") {
			last;
		}
	}
	if ($i > $#confs) {
	        $elm->{"keywd"} = "acl";
		$elm->{"name"} =  "secondary-ns";
	        $elm->{"acl"}->{"argc"} = 0;
		unshift(@confs, $elm);
		$i = 0;
	}
	$addflag = 0;
	$argc = $confs[$i]->{"acl"}->{"argc"};
	for ($j = 0; $j <= $#ns; $j++) {
		for ($k = 0; $k < $argc; $k++) {
			$value = $confs[$i]->{"acl"}->{$k};
			if ($value eq $ns[$j]) {
				last;
			}
		}
		if ($k >= $argc) {
			$confs[$i]->{"acl"}->{"argc"}++;
			$confs[$i]->{"acl"}->{$argc} = $ns[$j];
			$addflag = 1;
		}
	}
	if ($addflag == 0) {
		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "addSecondNs:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "addSecondNs:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}

	return $err;
}

sub delSecondNs {
	local($cfname, *ns) = @_;
	my($argc, $value, $i, $j, $k, $delete, $tmpcfname, $err);

	$err = 0;

	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} ne "acl") {
			next;
		}
		if ($confs[$i]->{"name"} eq "secondary-ns") {
			last;
		}
	}
	if ($i > $#confs) {
		$err = "delSecondNs:$STR_ERR_NOSUCH2NDNS";
		return $err;
	}
	$delete = 0;
	$argc = $confs[$i]->{"acl"}->{"argc"};
	for ($j = 0; $j <= $#ns; $j++) {
		for ($k = 0; $k < $argc; $k++) {
			$value = $confs[$i]->{"acl"}->{$k};
			if ($value eq $ns[$j]) {
				&shiftCode($confs[$i]->{"acl"}, $k, $argc-1);
				$argc--;
				$k--;
				$delete = 1;
			}
		}
		$confs[$i]->{"acl"}->{"argc"} = $argc;
	}
	if ($delete == 0) {
		$err = "delSecondNs:$STR_ERR_NOSUCH2NDNS";
		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delSecondNs:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "delSecondNs:$STR_ERR_CANTOPENFILE($tmpcfname)";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}

	return $err;
}

sub editSecondNs {
	local($cfname, $orgns, $ns) = @_;
	my($argc, $value, $i, $j, $k, $delete, $tmpcfname, $err);

	$err = 0;

	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	if ($err = &getConf($cfname, *confs, *others)) {
		return $err;
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} ne "acl") {
			next;
		}
		if ($confs[$i]->{"name"} eq "secondary-ns") {
			last;
		}
	}
	if ($i > $#confs) {
		$err = "editSecondNs:$STR_ERR_NOSUCH2NDNS";
		return $err;
	}
	$changeflag = 0;
	$argc = $confs[$i]->{"acl"}->{"argc"};
	for ($k = 0; $k < $argc; $k++) {
		$value = $confs[$i]->{"acl"}->{$k};
		if ($value eq $orgns) {
			$confs[$i]->{"acl"}->{$k} = $ns;
			$changeflag = 1;
		}
	}
	if ($changeflag == 0) {
		$err = "editSecondNS:$STR_ERR_NOSUCH2NDNS";
		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "editSecondNs:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "editSecondNs:$STR_ERR_CANTOPENFILE($tmpcfname)";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}

	return $err;
}

#----------------------------------------------------------------------------
sub addZone {
	local ($cfname, $mode, $rrmachine, $rrcontact, *zz, *zns, *zmx) = @_;
	my ($tmpcfname, $workdir, $rrfilename, $tmpzfile, $fp, $i, $j, $err);

	$err = 0;
	$workdir = ".";
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	&getConf($cfname, *confs, *others);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}
		if ($confs[$i]->{zname} eq $zz->{zname}) {
			$err = "addZone:$STR_ERR_ZONEEXIST($zz->{zname}).";
			return $err;
		}
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "options") {
			next;
		}
		if ($confs[$i]->{directory}) {
			$workdir = $confs[$i]->{directory};
			last;
		}
	}
	push (@confs, $zz);

	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "addZone:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "addZone:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp,*confs);
	close(OUT);
	close(LOCK);
	if ($err) {
		return $err;
	}
	if ($zz->{type} ne "master") {
		if (!$err) {
			rename($tmpcfname, $cfname);
		}
		else {
			unlink($tmpcfname);
		}
		return $err;
	}
	if ($zz->{file}) {
#		$tmpzfile = $zz->{file};
#		$tmpzfile =~ s/\//\_/g;
		$rrfilename = "$workdir/$zz->{file}";
	}
	else {
		return $err;
	}

	$err = createZoneFile($rrfilename, $zz->{zname}, $zz->{type},
			$rrmachine, $rrcontact, *zns, *zmx);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

sub createZoneFile {
	local($zfile, $zname, $ztype, $rrmachine, $rrcontact, *zns, *zmx) = @_;
	my($i, $err);
	local(@r);

	$err = 0;
	$i = 0;
	$r[$i] = {};
	$r[$i]->{rrorigin} = &getOrigin($zname);
	$r[$i]->{rrdomain} = &getOrigin($zname);
	$r[$i]->{rroptttl} = 0;
	$r[$i]->{rroptclass} = "IN";
	$r[$i]->{rrtype} = "SOA";
	$r[$i]->{soa_machine} = $rrmachine;
	$r[$i]->{soa_contact} = $rrcontact;
	if ($ztype eq "master") {
		$r[$i]->{soa_serial} = &getSerial(0);
	}
	else {
		$r[$i]->{soa_serial} = 0;
	}
	$r[$i]->{soa_refresh} = 28800;
	$r[$i]->{soa_retry} = 14400;
	$r[$i]->{soa_expire} = 3600000;
	$r[$i]->{soa_minimum} = 86400;

	for ($j = 0, ++$i; $j <= $#zns; $j++, $i++) {
		$r[$i] = {};
		$r[$i]->{rrorigin} = &getOrigin($zname);
		$r[$i]->{rrdomain} = &getOrigin($zname);
		$r[$i]->{rroptttl} = 86400;
		$r[$i]->{rroptclass} = "IN";
		$r[$i]->{rrtype} = "NS";
		$r[$i]->{rrdata} = $zns[$j];
	}
	for ($j = 0; $j <= $#zmx; $j++, $i++) {
		$r[$i] = {};
		$r[$i]->{rrorigin} = &getOrigin($zname);
		$r[$i]->{rrdomain} = &getOrigin($zname);
		$r[$i]->{rroptttl} = 86400;
		$r[$i]->{rroptclass} = "IN";
		$r[$i]->{rrtype} = "MX";
		$r[$i]->{mx_priority} = "$zmx[$j]->{mx_priority}";
		$r[$i]->{mx_server} = $zmx[$j]->{mx_server};
	}
	$err = &addRR($zfile, -1, $zname, *r);

	return $err;
}

sub addZoneOrg {
	local ($cfname, $rrmachine, $rrcontact, *zz, *zns, *zmx) = @_;
	my ($tmpcfname, $workdir, $rrfilename, $fp, $i, $j, $err);

	$err = 0;
	$workdir = ".";
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	&getConf($cfname, *confs, *others);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}
		if ($confs[$i]->{zname} eq $zz->{zname}) {
			$err = "addZoneOrg:$STR_ERR_ZONEEXIST($zz->{zname}).";
			return $err;
		}
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "options") {
			next;
		}
		if ($confs[$i]->{directory}) {
			$workdir = $confs[$i]->{directory};
			last;
		}
	}
	push (@confs, $zz);
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "addZoneOrg:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "addZoneOrg:$STR_ERR_CANTOPEN_FILE($tmpcfname)";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp,*confs);
	close(OUT);
	close(LOCK);
	if ($err) {
		return $err;
	}

	if ($zz->{file}) {
		$rrfilename = "$workdir/$zz->{file}";
	}
	else {
		return $err;
	}
	$i = 0;
	$r[$i] = {};
	$r[$i]->{rrorigin} = &getOrigin($zz->{zname});
	$r[$i]->{rrdomain} = &getOrigin($zz->{zname});
	$r[$i]->{rroptttl} = 0;
	$r[$i]->{rroptclass} = "IN";
	$r[$i]->{rrtype} = "SOA";
	$r[$i]->{soa_machine} = $rrmachine;
	$r[$i]->{soa_contact} = $rrcontact;
	$r[$i]->{soa_serial} = &getSerial(0);
	$r[$i]->{soa_refresh} = 28800;
	$r[$i]->{soa_retry} = 14400;
	$r[$i]->{soa_expire} = 3600000;
	$r[$i]->{soa_minimum} = 86400;

	for ($j = 0, ++$i; $j <= $#zns; $j++, $i++) {
		$r[$i] = {};
		$r[$i]->{rrorigin} = &getOrigin($zz->{zname});
		$r[$i]->{rrdomain} = &getOrigin($zz->{zname});
		$r[$i]->{rroptttl} = 86400;
		$r[$i]->{rroptclass} = "IN";
		$r[$i]->{rrtype} = "NS";
		$r[$i]->{rrdata} = $zns[$j];
	}
	for ($j = 0; $j <= $#zmx; $j++, $i++) {
		$r[$i] = {};
		$r[$i]->{rrorigin} = &getOrigin($zz->{zname});
		$r[$i]->{rrdomain} = &getOrigin($zz->{zname});
		$r[$i]->{rroptttl} = 86400;
		$r[$i]->{rroptclass} = "IN";
		$r[$i]->{rrtype} = "MX";
		$r[$i]->{mx_priority} = "$zmx[$j]->{priority}";
		$r[$i]->{mx_server} = $zmx[$j]->{server};
	}
	if ($#r >= 0) {
		$err = &addRR($rrfilename, -1, $zz->{zname}, *r);
	}
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub delZone {
	local ($cfname, $zname, $ztype) = @_;
	my ($tmpcfname, $workdir, $rrfilename, $fp,
		$i, $j, $delete, @zfiles, $err);

	$err = 0;
	$workdir = ".";
	@zfiles = ();
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	&getConf($cfname, *confs, *others);
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "options") {
			next;
		}
		if ($confs[$i]->{directory}) {
			$workdir = $confs[$i]->{directory};
			last;
		}
	}
	$delete = 0;
	for ($i = 0, $j = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}
		if (($confs[$i]->{zname} eq $zname)
			&& ($confs[$i]->{type} eq $ztype)) {
			$rrfilename = "$workdir/$confs[$i]->{file}";
			$zfiles[$j++] = $rrfilename;
			splice(@confs, $i, 1);
			$i--;
			$delete = 1;
		}
	}
	if ($delete == 0) {
		$err = "delZone:$STR_ERR_NOSUCHZONE";
		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delZone:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "delZone:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
		for ($i = 0; $i <= $#zfiles; $i++) {
			unlink($zfiles[$i]);
		}
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub editZone {
	local ($cfname, $orgzname, $orgztype, 
		$machine, $contact, *zz, *zns, *zmx) = @_;

	my ($tmpcfname, $workdir, $zfile, $tmpzfile, $fp, $i, $err);

	$err = 0;
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	&getConf($cfname, *confs, *others);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "zone") {
			next;
		}
		if (($confs[$i]->{zname} eq $orgzname)
			&& ($confs[$i]->{type} eq $orgztype)) {
			$tmpzfile = $confs[$i]->{file};
			last;
		}
	}
	if ($i > $#confs) {
		$err = "editZone:$STR_ERR_NOSUCHZONE($orgzname)";
		return $err;
	}
	splice(@confs, $i, 1, $zz);
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delZone:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "editZone:$STR_ERR_CANTOPENFILE($tmpcfname)";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if ($err) {
		return $err;
	}

	$workdir = &getNamedWorkdir(@confs);
	$zfile = "$workdir/$zz->{file}";
	if ($tmpzfile ne $zz->{file}) {	
		$err = createZoneFile($zfile, $zz->{zname}, $zz->{type},
			$machinem, $contact, *zns, *zmx);
	}
	else {
		$err = changeSoaNsMxRR($zfile, $zz->{zname},
				$machine, $contact, *zns, *zmx);
	}

	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub changeSoaNsMxRR {
	local($zfile, $zname, $machine, $contact, *zns, *zmx) = @_;
	my($changeflag, $num, $tmpzfile, $err);

	for ($i = 0; $i <= $#zns; $i++) {
		$rns[$i] = {};
		$rns[$i]->{rrorigin} = &getOrigin($zname);
		$rns[$i]->{rrdomain} = &getOrigin($zname);
		$rns[$i]->{rroptttl} = 86400;
		$rns[$i]->{rroptclass} = "IN";
		$rns[$i]->{rrtype} = "NS";
		$rns[$i]->{rrdata} = $zns[$i];
	}
	for ($i = 0; $i <= $#zmx; $i++) {
		$rmx[$i] = {};
		$rmx[$i]->{rrorigin} = &getOrigin($zz->{zname});
		$rmx[$i]->{rrdomain} = &getOrigin($zz->{zname});
		$rmx[$i]->{rroptttl} = 86400;
		$rmx[$i]->{rroptclass} = "IN";
		$rmx[$i]->{rrtype} = "MX";
		$rmx[$i]->{mx_priority} = "$zmx[$i]->{mx_priority}";
		$rmx[$i]->{mx_server} = $zmx[$i]->{mx_server};
	}

	$err = 0;
	$num = 0;
	splice(@rr, 0, $#rr+1);
	$incfile = "";
	$incopt = "";
	$defttl = 86400;
	&readRR($zname, $zfile, *rr, *incfile, *incopt, *defttl);
	for ($i = 0; $i <= $#rr; $i++) {
		if ($rr[$i]->{rrtype} eq "SOA") {
			$rr[$i]->{soa_serial} = &getSerial($rr[$i]->{soa_serial});
			if ($rr[$i]->{soa_machine} ne $machine) {
				$rr[$i]->{soa_machine} = $machine;
			}
			if ($rr[$i]->{soa_contact} ne $contact) {
				$rr[$i]->{soa_contact} = $contact;
			}
			$num = $i+1;
		}
		elsif ($rr[$i]->{rrtype} eq "NS") {
			for ($j = 0; $j <= $#zns; $j++) {
				if ($zns[$j] ne $rr[$i]->{rrdata}) {
					last;
				}
			}
			splice(@rr, $i, 1);
			$i--;
		}
		elsif ($rr[$i]->{rrtype} eq "MX") {
			for ($j = 0; $j <= $#zmx; $j++) {
				if (($zmx[$j]->{mx_priority} 
						ne $rr[$i]->{mx_priority})
						|| ($zmx[$j]->{mx_server} 
						ne $rr[$i]->{mx_server})) {
					last;
				}
			}
			splice(@rr, $i, 1);
			$i--;
		}
	}
	if ($#rns >= 0) {
		splice(@rr, $num, 0, @rns);
		$num = $num + $#rns + 1;
	}
	if ($#rmx >= 0) {
		splice(@rr, $num, 0, @rmx);
	}
	$tmpzfile = "$zfile.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "changeSoaNsMxRR:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpzfile")) {
		$err = "changeSoaNsMxRR:$STR_ERR_CANTOPENFILE($tmpzfile).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printRR($fp, $zz->{zname}, *rr, $incfile, $incopt, $defttl);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpzfile, $zfile);
	}
	else {
		unlink($tmpzfile);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub addRR {
	local ($rrfilename, $rnum, $zname, *r) = @_;
	my ($prevorigin, $tmprrfilename, $fp, $i, $j,
		$rrdomain, $rroptttl, $rroptclass, $rrtype, $rrdata,
		$mxpri, $mxsv, $hwcpu, $swos, $err);

	if ($#r < 0) {
		$err = "addRR:$STR_ERR_NORR";
		return $err;
	}
	$err = 0;
	$prevorigin = &getOrigin($zname);
	splice(@rhead, 0, $#rhead+1);
	$incfile = "";
	$incopt = "";
	$defttl = 86400;
	&readRR($prevorigin, $rrfilename, *rhead,
			*incfile, *incopt, *defttl);

	for ($j = 0; $j <= $#r; $j++) {

		$rrdomain = $r[$j]->{rrdomain};
		$rroptttl = $r[$j]->{rroptttl};
		$rroptclass = $r[$j]->{rroptclass};
		$rrtype = $r[$j]->{rrtype};
		$rrdata = $r[$j]->{rrdata};
		$mxpri = $r[$j]->{mx_priority};
		$mxsv = $r[$j]->{mx_server};
		$hwcpu = $r[$j]->{hinfo_hw_cpu};
		$swos = $r[$j]->{hinfo_sw_os};

		for ($i = 0; $i <= $#rhead; $i++) {

			if (($rhead[$i]->{rrdomain} ne $rrdomain)
#				|| ("$rhead[$i]->{rroptttl}" eq "$rroptttl")
#				|| ($rhead[$i]->{rroptclass} ne $rroptclass)
				|| ($rhead[$i]->{rrtype} ne $rrtype)) {
				next;
			}

			if (($rrtype eq "SOA") || ($rrtype eq "NULL")) {
				last;
			}
			elsif (($rrtype eq "NS")
				|| ($rrtype eq "A")
				|| ($rrtype eq "CNAME")
				|| ($rrtype eq "PTR")
				|| ($rrtype eq "RP")) {
				if ($rhead[$i]->{rrdata} eq $rrdata) {
					last;
				}
			}
			elsif (($rrtype eq "MX")) {
				if (("$mxpri" eq "$rhead[$i]->{mx_priority}")
					&& ($mxsv eq $rhead[$i]->{mx_server})) {
					last;
				}
			}
			elsif (($rrtype eq "HINFO")) {
				if (($hwcpu eq $rhead[$i]->{hinfo_hw_cpu})
				&& ($swos eq $rhead[$i]->{hinfo_sw_os})) {
					last;
				}
			}
		}
		if ($i <= $#rhead) {
			last;
		}
	}
	if ($j <= $#r) {
		$err = "addRR:$STR_ERR_RREXIST";
		return $err;
	}

	if ($#rhead < 0) {
		@rhead = @r;
	}
	else {
		if ($rnum < $#rhead) {
			splice(@rhead, $rnum+1, 0, @r);
		}
		else {
			splice(@rhead, $#rhead+1, 0, @r);
		}
	}
	$tmprrfilename = "$rrfilename.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "addRR:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmprrfilename")) {
		$err = "addRR:$STR_ERR_CANTOPENFILE($tmprrfilename)";
		close(LOCK);
		return $err;
	}

	$fp = OUT;
	$err = &printRR($fp, $zname, *rhead, $incfile, $incopt, $defttl);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmprrfilename, $rrfilename);
	}
	else {
		unlink($tmprrfilename);
	}
	return $err;
}

sub editRR {
	local ($rrfilename, $rnum, $zname, *r) = @_;
	my ($prevorigin, $rhead, $tmprrfilename, $fp, $err);

	$err = 0;
	$prevorigin = &getOrigin($zname);
	splice(@rhead, 0, $#rhead+1);
	$incfile = "";
	$incopt = "";
	$defttl = 86400;
	&readRR($prevorigin, $rrfilename, *rhead,
			*incfile, *incopt, *defttl);

	if ($rnum > $#rhead) {
		$err = "editRR:$STR_ERR_NOSUCHRR";
		return &err;
	}
	splice(@rhead, $rnum, $#r+1, @r);
	$tmprrfilename = "$rrfilename.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "editRR:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmprrfilename")) {
		$err = "editRR:$STR_ERR_CANTOPENFILE($tmprrfilename)";
		close(LOCK);
		return &err;
	}
	$fp = OUT;
	$err = &printRR($fp, $zname, *rhead, $incfile, $incopt, $defttl);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmprrfilename, $rrfilename);
	}
	else {
		unlink($tmprrfilename);
	}
	return $err;
}

sub delRR {
	local ($rrfilename, $zname, *r) = @_;
	my ($prevorigin, $tmprrfilename, $fp, $i, $j,
		$rrdomain, $rroptttl, $rroptclass,
		$rrtype, $rrdata, $mxpri, $mxsv, $hwcpu, $swos, $err);

	$err = 0;
	$prevorigin = &getOrigin($zname);
	splice(@rhead, 0, $#rhead+1);
	$incfile = "";
	$incopt = "";
	$defttl = 86400;
	if ($err = &readRR($prevorigin, $rrfilename, *rhead,
				*incfile, *incopt, *defttl)) {
		return $err;
	}

	for ($j = 0; $j <= $#r; $j++) {

		$rrdomain = $r[$j]->{rrdomain};
		$rroptttl = $r[$j]->{rroptttl};
		$rroptclass = $r[$j]->{rroptclass};
		$rrtype = $r[$j]->{rrtype};
		$rrdata = $r[$j]->{rrdata};
		$mxpri = $r[$j]->{mx_priority};
		$mxsv = $r[$j]->{mx_server};
		$hwcpu = $r[$j]->{hinfo_hw_cpu};
		$swos = $r[$j]->{hinfo_sw_os};

		for ($i = 0; $i <= $#rhead; $i++) {

			if (($rhead[$i]->{rrdomain} ne $rrdomain)
#				|| ("$rhead[$i]->{rroptttl}" eq "$rroptttl")
#				|| ($rhead[$i]->{rroptclass} ne $rroptclass)
				|| ($rhead[$i]->{rrtype} ne $rrtype)) {
				next;
			}

			if (($rrtype eq "SOA") || ($rrtype eq "NULL")) {
				splice(@rhead, $i, 1);
				$i--;
			}
			elsif (($rrtype eq "NS")
				|| ($rrtype eq "A")
				|| ($rrtype eq "CNAME")
				|| ($rrtype eq "PTR")
				|| ($rrtype eq "RP")) {
				if ($rhead[$i]->{rrdata} eq $rrdata) {
					splice(@rhead, $i, 1);
					$i--;
				}
			}
			elsif (($rrtype eq "MX")) {
				if (("$mxpri" eq "$rhead[$i]->{mx_priority}")
					&& ($mxsv eq $rhead[$i]->{mx_server})) {
					splice(@rhead, $i, 1);
					$i--;
				}
			}
			elsif (($rrtype eq "HINFO")) {
				if (($hwcpu eq $rhead[$i]->{hinfo_hw_cpu})
				&& ($swos eq $rhead[$i]->{hinfo_sw_os})) {
					splice(@rhead, $i, 1);
					$i--;
				}
			}
		}
	}

	$tmprrfilename = "$rrfilename.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delRR:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $rrfilename")) {
		$err = "delRR:$STR_ERR_CANTOPENFILE($tmprrfilename).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = printRR($fp, $zname, *rhead, $incfile, $incopt, $defttl);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmprrfilename, $rrfilename);
	}
	else {
		unlink($tmprrfilename);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub delAcl {
	local ($cfname, *acls) = @_;
	my ($tmpcfname, $fp, $i, $j, $k, $delete, $err);

	$err = 0;
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#oters+1);
	&getConf($cfname, *confs, *others);
	$delete = 0;

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} eq "acl") {
			for ($j = 0; $j <= $acls; $j++) {
				if ($confs[$i]->{name} eq $acls[$j]) {
					splice(@confs, $i, 1);
					$i--;
					$delete = 1;
				}
			}
		}
		else {
			for ($j = 0; $j <= $acls; $j++) {
				&delAclCode($confs[$i], $acls[$j]);
			}
		}
	}
	if ($delete == 0) {
		$err = "delAcl:$STR_ERR_NOSUCHACL";
		return $err;
	}
	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "delAcl:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "delAcl:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub delAclCode {
	local($cf, $aclname) = @_;
	my($argc, $preargc, $i);

	$argc = $cf->{"allow-query"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"allow-query"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"allow-query"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"allow-query"}->{0} = "none";
	}
	$cf->{"allow-query"}->{"argc"} = $argc;
	$argc = $cf->{"allow-update"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"allow-update"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"allow-update"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"allow-update"}->{0} = "none";
	}
	$cf->{"allow-update"}->{"argc"} = $argc;

	$argc = $cf->{"allow-recursion"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"allow-recursion"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"allow-recursion"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"allow-recursion"}->{0} = "none";
	}
	$cf->{"allow-recursion"}->{"argc"} = $argc;

	$argc = $cf->{"allow-transfer"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"allow-transfer"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"allow-transfer"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"allow-transfer"}->{0} = "none";
	}
	$cf->{"allow-transfer"}->{"argc"} = $argc;

	$argc = $cf->{"blackhole"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"blackhole"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"blackhole"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"blackhole"}->{0} = "none";
	}
	$cf->{"blackhole"}->{"argc"} = $argc;

	$argc = $cf->{"listen-on-acl"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"listen-on-acl"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"listen-on-acl"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"listen-on-acl"}->{0} = "none";
	}
	$cf->{"listen-on-acl"}->{"argc"} = $argc;

	$argc = $cf->{"topology"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"topology"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"topology"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"topology"}->{0} = "none";
	}
	$cf->{"topology"}->{"argc"} = $argc;

	$argc = $cf->{"sortlist"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"sortlist"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"sortlist"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"sortlist"}->{0} = "none";
	}
	$cf->{"sortlist"}->{"argc"} = $argc;

	$argc = $cf->{"allow"}->{"argc"};
	$preargc = $argc;
	for ($i = 0; $i < $argc; $i++) {
		if ($cf->{"allow"}->{$i} eq "$aclname") {
			&shiftCode($cf->{"allow"}, $i, $argc-1);
			$argc--;
			$i--;
		}
	}
	if ($preargc > 0 && $argc < 1) {
		$argc = 1;
		$cf->{"allow"}->{0} = "none";
	}
	$cf->{"allow"}->{"argc"} = $argc;

}

sub shiftCode {
	local($lp, $s, $e) = @_;
	my ($i);

	for ($i = $s; $i < $e; $i++) {
		$lp->{$i} = $lp->{$i+1};
	}
}

#----------------------------------------------------------------------------
sub setZoneAcl {
	local($cfname, $zname, $query, $update, $transfer) = @_;
	my($i, $j, $argc, $tmpcfname, $fp, $err);

	$err = 0;
	splice(@confs, 0, $#confs+1);
	splice(@others, 0, $#others+1);
	&getConf($cfname, *confs, *others);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} ne "zone") {
			next;
		}
		if ($confs[$i]->{"zname"} eq $zname) {
			$zfile = $confs[$i]->{"file"};
			last;
		}
	}
	if ($i > $#confs) {
		$err = "$STR_ERR_BADDOMAIN(|$cfname|$#confs|$zname|).\n";
		return $err;
	}
	$argc = $confs[$i]->{"allow-query"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$aname = $confs[$i]->{"allow-query"}->{$j};
		if ($aname eq $query) {
			last;
		}
		if ($aname eq "none") {
			$confs[$i]->{"allow-query"}->{$j} = $query;
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-query"}->{"argc"}++;
		$confs[$i]->{"allow-query"}->{$argc} = $query;
	}

	$argc = $confs[$i]->{"allow-update"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$aname = $confs[$i]->{"allow-update"}->{$j};
		if ($aname eq $update) {
			last;
		}
		if ($aname eq "none") {
			$confs[$i]->{"allow-update"}->{$j} = $update;
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-update"}->{"argc"}++;
		$confs[$i]->{"allow-update"}->{$argc} = $update;
	}

	$argc = $confs[$i]->{"allow-transfer"}->{"argc"};
	for ($j = 0; $j < $argc; $j++) {
		$aname = $confs[$i]->{"allow-transfer"}->{$j};
		if ($aname eq $transfer) {
			last;
		}
		if ($aname eq "none") {
			$confs[$i]->{"allow-transfer"}->{$j} = $transfer;
			last;
		}
	}
	if ($j >= $argc) {
		$confs[$i]->{"allow-transfer"}->{"argc"}++;
		$confs[$i]->{"allow-transfer"}->{$argc} = $transfer;
	}

	$tmpcfname = "$cfname.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "setZoneAcl:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpcfname")) {
		$err = "setZoneAcl:$STR_ERR_CANTOPENFILE($tmpcfname).";
		close(LOCK);
		return $err;
	}
	$fp = OUT;
	$err = printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
	return $err;
}

#----------------------------------------------------------------------------
sub getNamedWorkdir {
	local(@confs) = @_;
	my($i, $workdir);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{keywd} ne "options") {
			next;
		}
		if ($confs[$i]->{directory}) {
			$workdir = $confs[$i]->{directory};
			last;
		}
	}
	if (!$workdir) {
		$workdir = ".";
	}
	return $workdir;
}

#----------------------------------------------------------------------------
sub getSerial {
	local($serial) = @_;
	my($newserial);

	$newserial = "";
	open(IN, "/bin/date +%Y%m%d |");
	while($line = <IN>) {
		$line =~ s/\s*$//;
		$newserial .= $line;
	}
	$newserial = sprintf("%s00", $newserial);
	if ($newserial <= $serial) {
		if (($serial+1) < ($newserial+100)) {
			$newserial = $serial + 1;
		}
		else {
			$newserial = $serial;
		}
	}
	return $newserial;
}

#----------------------------------------------------------------------------
sub setOptions {
	local($cfname, *opt) = @_;
	my($err, $elm, $setflag, $i, $j, $fp, $tmpcfname);

	$err = 0;
	$setflag = 0;
	@confs = ();
	@others = ();
	if (!$cfname) {
		$err = $STR_ERR_BADVALUE;
		goto done;
	}
	if (-e $cfname) {
		if ($err = &getConf($cfname, *confs, *others)) {
			goto done;
		}
	}
	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} eq "options") {
			last;
		}
	}
	if ($i > $#confs) {
		$elm->{"keywd"} = "options";
		unshift(@confs, $elm);
		$i = 0;
	}

	if ($opt->{"version"}) {
		$confs[$i]->{"version"} = $opt->{"version"};
		$setflag = 1;
	}
	if ($opt->{"directory"}) {
		$confs[$i]->{"directory"} = $opt->{"directory"};
		$setflag = 1;
	}
	if ($opt->{"named-xfer"}) {
		$confs[$i]->{"named-xfer"} = $opt->{"named-xfer"};
		$setflag = 1;
	}
	if ($opt->{"dump-file"}) {
		$confs[$i]->{"dump-file"} = $opt->{"dump-file"};
		$setflag = 1;
	}
	if ($opt->{"memstatistics-file"}) {
		$confs[$i]->{"memstatistics-file"} =
					$opt->{"memstatistics-file"};
		$setflag = 1;
	}
	if ($opt->{"pid-file"}) {
		$confs[$i]->{"pid-file"} = $opt->{"pid-file"};
		$setflag = 1;
	}
	if ($opt->{"statistics-file"}) {
		$confs[$i]->{"statistics-file"} = $opt->{"statistics-file"};
		$setflag = 1;
	}
	if ($opt->{"auth-nxdomain"}) {
		$confs[$i]->{"auth-nxdomain"} = $opt->{"auth-nxdomain"};
		$setflag = 1;
	}
	if ($opt->{"deallocate-on-exit"}) {
		$confs[$i]->{"deallocate-on-exit"}=
		$setflag = 1;
					$opt->{"deallocate-on-exit"};
	}
	if ($opt->{"dialup"}) {
		$confs[$i]->{"dialup"} = $opt->{"dialup"};
		$setflag = 1;
	}
	if ($opt->{"fake-iquery"}) {
		$confs[$i]->{"fake-iquery"} = $opt->{"fake-iquery"};
		$setflag = 1;
	}
	if ($opt->{"fetch-glue"}) {
		$confs[$i]->{"fetch-glue"} = $opt->{"fetch-glue"};
		$setflag = 1;
	}
	if ($opt->{"has-old-clients"}) {
		$confs[$i]->{"has-old-clients"} = $opt->{"has-old-clients"};
		$setflag = 1;
	}
	if ($opt->{"host-statistics"}) {
		$confs[$i]->{"host-statistics"} = $opt->{"host-statistics"};
		$setflag = 1;
	}
	if ($opt->{"multiple-cnames"}) {
		$confs[$i]->{"multiple-cnames"} = $opt->{"multiple-cnames"};
		$setflag = 1;
	}
	if ($opt->{"notify"}) {
		$confs[$i]->{"notify"} = $opt->{"notify"};
		$setflag = 1;
	}
	if ($opt->{"recursion"}) {
		$confs[$i]->{"recursion"} = $opt->{"recursion"};
		$setflag = 1;
	}
	if ($opt->{"rfc2308-type1"}) {
		$confs[$i]->{"rfc2308-type1"} = $opt->{"rfc2308-type1"};
		$setflag = 1;
	}
	if ($opt->{"use-id-pool"}) {
		$confs[$i]->{"use-id-pool"} = $opt->{"use-id-pool"};
		$setflag = 1;
	}
	if ($opt->{"treat-cr-as-space"}) {
		$confs[$i]->{"tread-cr-as-space"} = $opt->{"tread-cr-as-space"};
		$setflag = 1;
	}
	if ($opt->{"also-notify"}) {
		$confs[$i]->{"also-notify"} = $opt->{"also-notify"};
		$setflag = 1;
	}
	if ($opt->{"forward"}) {
		$confs[$i]->{"forward"} = $opt->{"forward"};
		$setflag = 1;
	}
	if ($opt->{"lame-ttl"}) {
		$confs[$i]->{"lame-ttl"} = $opt->{"lame-ttl"};
		$setflag = 1;
	}
	if ($opt->{"max-transfer-time-in"}) {
		$confs[$i]->{"max-transfer-time-in"} =
					$opt->{"max-transfer-time-in"};
		$setflag = 1;
	}
	if ($opt->{"max-ncache-ttl"}) {
		$confs[$i]->{"max-ncache-ttl"} = $opt->{"max-ncache-ttl"};
		$setflag = 1;
	}
	if ($opt->{"min-roots"}) {
		$confs[$i]->{"min-roots"} = $opt->{"min-roots"};
		$setflag = 1;
	}
	if ($opt->{"serial-queries"}) {
		$confs[$i]->{"serial-queries"} = $opt->{"serial-queries"};
		$setflag = 1;
	}
	if ($opt->{"transfer-format"}) {
		$confs[$i]->{"transfer-format"} = $opt->{"transfer-format"};
		$setflag = 1;
	}
	if ($opt->{"transfers-in"}) {
		$confs[$i]->{"transfer-in"} = $opt->{"transfer-in"};
		$setflag = 1;
	}
	if ($opt->{"transfers-out"}) {
		$confs[$i]->{"transfers-out"} = $opt->{"transfers-out"};
		$setflag = 1;
	}
	if ($opt->{"transfers-per-ns"}) {
		$confs[$i]->{"transfers-per-ns"} =
					$opt->{"transfers-per-ns"};
		$setflag = 1;
	}
	if ($opt->{"transfer-source"}) {
		$confs[$i]->{"transfer-source"} = $opt->{"transfer-source"};
		$setflag = 1;
	}
	if ($opt->{"maintain-ixfr-base"}) {
		$confs[$i]->{"maintain-ixfr-base"} =
					$opt->{"maintain-ixfr-base"};
		$setflag = 1;
	}
	if ($opt->{"max-ixfr-log-size"}) {
		$confs[$i]->{"max-ixfr-log-size"} = $opt->{"max-ixfr-log-size"};
		$setflag = 1;
	}
	if ($opt->{"coresize"}) {
		$confs[$i]->{"coresize"} = $opt->{"coresize"};
		$setflag = 1;
	}
	if ($opt->{"datasize"}) {
		$confs[$i]->{"datasize"} = $opt->{"datasize"};
		$setflag = 1;
	}
	if ($opt->{"files"}) {
		$confs[$i]->{"files"} = $opt->{"files"};
		$setflag = 1;
	}
	if ($opt->{"stacksize"}) {
		$confs[$i]->{"stacksize"} = $opt->{"stacksize"};
		$setflag = 1;
	}
	if ($opt->{"cleaning-interval"}) {
		$confs[$i]->{"cleaning-interval"} = $opt->{"cleaning-interval"};
		$setflag = 1;
	}
	if ($opt->{"heartbeat-interval"}) {
		$confs[$i]->{"heartbeat-interval"} =
					$opt->{"heartbeat-interval"};
		$setflag = 1;
	}
	if ($opt->{"interface-interval"}) {
		$confs[$i]->{"interface-interval"} =
					$opt->{"interface-interval"};
		$setflag = 1;
	}
	if ($opt->{"statistics-interval"}) {
		$confs[$i]->{"statistics-interval"} =
					$opt->{"statistics-interval"};
		$setflag = 1;
	}
	if ($opt->{"forwarders"}->{"argc"} > 0) {
		$confs[$i]->{"forwarders"}->{"argc"} =
					$opt->{"forwarders"}->{"argc"};
		for ($j = 0; $j < $opt->{"forwarders"}->{"argc"}; $j++) {
			if (!($opt->{"forwarders"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"forwarders"}->{$j} =
					$opt->{"forwarders"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"check-names-type"}) {
		$confs[$i]->{"check-names-type"} = $opt->{"check-names-type"};
		if ($opt->{"check-names-value"}) {
			$confs[$i]->{"check-names-value"} =
					$opt->{"check-names-value"};
		}
		$setflag = 1;
	}
	if ($opt->{"allow-query"}->{"argc"} > 0) {
		$confs[$i]->{"allow-query"}->{"argc"} =
					$opt->{"allow-query"}->{"argc"};
		for ($j = 0; $j < $opt->{"allow-query"}->{"argc"}; $j++) {
			if (!($opt->{"allow-query"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"allow-query"}->{$j} =
					$opt->{"allow-query"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"allow-recursion"}->{"argc"} > 0) {
		$confs[$i]->{"allow-recursion"}->{"argc"} =
					$opt->{"allow-recursion"}->{"argc"};
		for ($j = 0; $j < $opt->{"allow-recursion"}->{"argc"}; $j++) {
			if (!($opt->{"allow-recursion"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"allow-recursion"}->{$j} =
					$opt->{"allow-recursion"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"allow-transfer"}->{"argc"} > 0) {
		$confs[$i]->{"allow-transfer"}->{"argc"} =
					$opt->{"allow-transfer"}->{"argc"};
		for ($j = 0; $j < $opt->{"allow-transfer"}->{"argc"}; $j++) {
			if (!($opt->{"allow-transfer"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"allow-transfer"}->{$j} =
					$opt->{"allow-transfer"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"blackhole"}->{"argc"} > 0) {
		$confs[$i]->{"blackhole"}->{"argc"} =
					$opt->{"blackhole"}->{"argc"};
		for ($j = 0; $j < $opt->{"blackhole"}->{"argc"}; $j++) {
			if (!($opt->{"blackhole"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"blackhole"}->{$j} =
					$opt->{"blackhole"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"topology"}->{"argc"} > 0) {
		$confs[$i]->{"topology"}->{"argc"} =
					$opt->{"topology"}->{"argc"};
		for ($j = 0; $j < $opt->{"topology"}->{"argc"}; $j++) {
			if (!($opt->{"topology"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"topology"}->{$j} =
					$opt->{"topology"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"sortlist"}->{"argc"} > 0) {
		$confs[$i]->{"sortlist"}->{"argc"} =
					$opt->{"sortlist"}->{"argc"};
		for ($j = 0; $j < $opt->{"sortlist"}->{"argc"}; $j++) {
			if (!($opt->{"sortlist"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"sortlist"}->{$j} =
					$opt->{"sortlist"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"listen-on-acl"}->{"argc"} > 0) {
		if ($opt->{"listen-on-port"}) {
			$confs[$i]->{"listen-on-port"} =
					$opt->{"listen-on-port"};
		}
		$confs[$i]->{"listen-on-acl"}->{"argc"} =
					$opt->{"listen-on-acl"}->{"argc"};
		for ($j = 0; $j < $opt->{"listen-on-acl"}->{"argc"}; $j++) {
			if (!($opt->{"listen-on-acl"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"listen-on-acl"}->{$j} =
					$opt->{"listen-on-acl"}->{$j};
		}
		$setflag = 1;
	}
	if ($opt->{"query-source-address"}) {
		$confs[$i]->{"query-source-address"} =
				$opt->{"query-source-address"};
		if ($opt->{"query-source-port"}) {
			$confs[$i]->{"query-source-port"} =
					$opt->{"query-source-port"};
		}
		$setflag = 1;
	}
	else {
		if ($opt->{"query-source-port"}) {
			$confs[$i]->{"query-source-port"} =
					$opt->{"query-source-port"};
		}
		$setflag = 1;
	}
	if ($opt->{"rrset-order"}->{"argc"} > 0) {
		$confs[$i]->{"rrset-order"}->{"argc"} =
					$opt->{"rrset-order"}->{"argc"};
		for ($j = 0; $j < $opt->{"rrset-order"}->{"argc"}; $j++) {
			if ($opt->{"rrset-order-class"}->{$j}) {
				$confs[$i]->{"rrset-order-class"}->{$j} =
					$opt->{"rrset-order-class"}->{$j};
			}
			if ($opt->{"rrset-order-type"}->{$j}) {
				$confs[$i]->{"rrset-order-type"}->{$j} =
					$opt->{"rrset-order-type"}->{$j};
			}
			if ($opt->{"rrset-order-name"}->{$j}) {
				$confs[$i]->{"rrset-order-name"}->{$j} =
					$opt->{"rrset-order-name"}->{$j};
			}
			if (!($opt->{"rrset-order-order"}->{$j})) {
				$err = $STR_ERR_BADVALUE;
				goto done;
			}
			$confs[$i]->{"rrset-order-order"}->{$j} =
					$opt->{"rrset-order-order"}->{$j};
		}
		$setflag = 1;
	}
	if (!$setflag) {
		goto done;
	}
	if (!&lockFile($NAMEDLOCKFILE, "$WBMC_LOCK_W_B", *LOCK)) {
		$err = "setOptions:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		goto done;
	}
	$tmpcfname = "$cfname\.tmp";
	if (!open(OUT, "> $tmpcfname")) {
		$err = "setOptions:$STR_ERR_CANTOPENFILE($tmpcfname)";
		close(LOCK);
		goto done;
	}
	$fp = OUT;
	$err = &printConf($fp, *confs);
	close(OUT);
	close(LOCK);
	if (!$err) {
		rename($tmpcfname, $cfname);
	}
	else {
		unlink($tmpcfname);
	}
done:
	return $err;
}
#----------------------------------------------------------------------------

1;

