# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: confread.pl,v 1.1.1.1 2002/09/09 07:43:35 snavi Exp $

require "/opt/nec/wbmc/lib/dns/namedapi.pl";
require "$COMMONAPIS";

#----------------------------------------------------------------------------
# Read configuration file
#----------------------------------------------------------------------------
sub getConf {
	local($cfname, *confs, *others) = @_;
	my ($err);

	$err = 0;
	if ($err = &readConf($cfname, *bufs, *others)) {
		goto done;
	}
	if ($err = &parseConf(*bufs, *confs)) {
		goto done;
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
sub readConf {
	local($cfname, *bufs, *obufs) = @_;
	my ($onebuf, $num, $onum, $line, @col, $delimiter, $err);

	$err = 0;
	if (!&readFile($cfname, $NAMEDLOCKFILE, *elements)) {
		$err = "readConf:$STR_ERR_CANTREADFILE($cfname)";
		goto done;
	}
	$num = 0;
	$onum = 0;
	$delimiter = ";";
	for ($lineno = 0; $lineno <= $#elements; $lineno++) {
		$line = $elements[$lineno];

		$onebuf = "";
		$modifyflag = 0;
		$commentflag = 0;
		$bracketnum = 0;

		$line =~ s/\s*$//;
		$line =~ s/^\s*//;

		@col = split(/\s+/, $line);

		if ($col[0] eq "include") {
			&readDelimiterOneLine($line, $delimiter, 
				*modifyflag, *commentflag, *readbuf);
			$onebuf .= $readbuf;
			if ($modifyflag == 1) {
				$bufs[$num++] = $onebuf;
				next;
			}
			for ($lineno++; $lineno <= $#elements; $lineno++) {
				$line = $elements[$lineno];

				$line =~ s/\s*$//;
				$line =~ s/^\s*//;
				&readDelimiterOneLine($line, $delimiter,
					*modifyflag, *commentflag, *readbuf);
				$onebuf .= $readbuf;
				if ($modifyflag == 1) {
					$bufs[$num++] = $onebuf;
					last;
				}
			}
			if ($modifyflag != 1) {
				$err = "readConf:$STR_ERR_SYNTAX";
				goto done;
			}
		}
		elsif (($col[0] eq "logging")
				|| ($col[0] eq "options")
				|| ($col[0] eq "zone")
				|| ($col[0] eq "acl")
				|| ($col[0] eq "key")
				|| ($col[0] eq "trusted-keys")
				|| ($col[0] eq "server")
				|| ($col[0] eq "controls")){
			&readBracketOneLine($line, *modifyflag, 
				*commentflag, *bracketnum, *readbuf);
			$onebuf .= " ";
			$onebuf .= $readbuf;
			if ($modifyflag == 1 && $bracketnum == 0) {
				$bufs[$num++] = $onebuf;
				next;
			}
			for ($lineno++; $lineno <= $#elements; $lineno++) {
				$line = $elements[$lineno];

				$line =~ s/\s*$//;
				$line =~ s/^\s*//;
				&readBracketOneLine($line, *modifyflag, 
					*commentflag, *bracketnum, *readbuf);
				$onebuf .= " ";
				$onebuf .= $readbuf;
				if ($modifyflag == 1 && $bracketnum == 0) {
					$bufs[$num++] = $onebuf;
					last;
				}
			}
			if ($modifyflag != 1 || $bracketnum != 0) {
				$err = "readConf:$STR_ERR_SYNTAX";
				goto done;
			}
		}
		else {
			if ($line) {
				$obufs[$onum++] = $line;
			}
		}
	}
	if ($bracketnum != 0) {
		$err = "readConf:$STR_ERR_SYNTAX";
		goto done;
	}
	for ($num = 0; $num <= $#bufs; $num++) {
		$bufs[$num] =~ s/\"//g;
	}
done:
	return $err;
}

#----------------------------------------------------------------------------"
sub readBracketOneLine {
	local($line, *modifyflag, *commentflag, *bracketnum, *readbuf) = @_;
	my ($len, $i, $j, $w, $w2, $err);

	$err = 0;
	$len = length($line);
	if ($len < 1) {
		next;
	}
	$i = $len;
	$j = 0;
	$readbuf = "";
	while ($i > 0) {
		$w = substr($line, $j++, 1);
		$i--;
		if ($w eq "/") {
			$w2 = substr($line, $j, 1);
			if ($w2 eq "/") {
				last;
			}
			elsif ($w2 eq "*") {
				$commentflag = 1;
				last;
			}
			else {
				if ($commentflag == 0) {
					$readbuf .= "/";
				}
			}
		}
		elsif ($w eq "*") {
			$w2 = substr($line, $j, 1);
			if (($commentflag == 1) && ($w2 eq "/")) {
				$commentflag = 0;
				$j++;
				$i--;
			}
			else {
				if ($commentflag == 0) {
					$readbuf .= "*";
				}
			}
		}
		elsif ($w eq "{") {
			if ($commentflag == 0) {
				$modifyflag = 1;
				$readbuf .= " ";
				$readbuf .= "$w";
				$readbuf .= " ";
				$bracketnum++;
			}
		}
		elsif ($w eq "}") {
			if ($commentflag == 0) {
				$readbuf .= " ";
				$readbuf .= "$w";
				$readbuf .= " ";
				$bracketnum--;
			}
		}
		elsif ($w eq ";") {
			if ($commentflag == 0) {
				$readbuf .= " ";
				$readbuf .= "$w";
				$readbuf .= " ";
			}
		}
		else {
			if ($commentflag == 0) {
				$readbuf .= "$w";
			}
		}
	}
}

sub readDelimiterOneLine {
	local($line, $delimiter, *modifyflag, *commentflag, *readbuf) = @_;
	my ($len, $i, $j, $w, $w2, $err);

	$err = 0;
	$len = length($line);
	if ($len < 1) {
		next;
	}
	$i = $len;
	$j = 0;
	$readbuf = "";
	while ($i > 0) {
		$w = substr($line, $j++, 1);
		$i--;
		if ($w eq "/") {
			$w2 = substr($line, $j, 1);
			if ($w2 eq "/") {
				last;
			}
			elsif ($w2 eq "*") {
				$commentflag = 1;
				last;
			}
			else {
				if ($commentflag == 0) {
					$readbuf .= "/";
				}
			}
		}
		elsif ($w eq "*") {
			$w2 = substr($line, $j, 1);
			if (($commentflag == 1) && ($w2 eq "/")) {
				$commentflag = 0;
				$j++;
				$i--;
			}
			else {
				if ($commentflag == 0) {
					$readbuf .= "*";
				}
			}
		}
		elsif ($w eq "$delimiter") {
			if ($commentflag == 0) {
				$readbuf .= " ";
				$readbuf .= "$w";
				$modifyflag = 1;
			}
		}
		else {
			if ($commentflag == 0) {
				$readbuf .= "$w";
			}
		}
	}
	return $err;
}
#----------------------------------------------------------------------------
sub parseConf {
	local(*bufs, *confs) = @_;
	my ($i, $err);
	
	$err = 0;
	for ($i = 0; $i <= $#bufs; $i++) {
		if ($err = &parseElement($bufs[$i], *confs, $i)) {
			goto done;
		}
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
sub parseElement {
	local($buf, *confs, $num) = @_;
	my ($line, @col, $keyword, $err);

	$err = 0;
	$elm = 0;
	$line = $buf;
	$line =~ s/^\s*//;

	@col = split(/\s+/, $line);
	if ($#col < 0) {
		$err = "parseElement:$STR_ERR_NODATA";
		goto done;
	}
	$keyword = "$col[0]";
	$elm = $num+1;
	$elm->{"keywd"} = $keyword;

	$line =~ s/$keyword//;
	$line =~ s/^\s*//;

	if ($keyword eq "options") {
		&parseOptions($line, *elm);
	}
	elsif ($keyword eq "acl") {
		&parseAcl($line, *elm);
	}
	elsif ($keyword eq "zone") {
		&parseZone($line, *elm);
	}
	elsif ($keyword eq "logging") {
		&parseLogging($line, *elm);
	}
	elsif ($keyword eq "key") {
		&parseKey($line, *elm);
	}
	elsif ($keyword eq "trusted-keys") {
		&parseTrustedKeys($line, *elm);
	}
	elsif ($keyword eq "server") {
		&parseServer($line, *elm);
	}
	elsif ($keyword eq "controls") {
		&parseControls($line, *elm);
	}
	elsif ($keyword eq "include") {
		&parseInclude($line, *elm);
	}
	else {
		$elm->{other} = $buf;
	}
	if ($elm) {
		push(@confs, $elm);
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseLogging {
	local($buf, *elm) = @_;
	my($i, @col, $err, $ch, $ca);

	$err = 0;
	$ch = 0;
	$ca = 0;
	$orgline = $buf;
	if ($err =  &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseLogging:$STR_ERR_SYNTAX";
		goto done;
	}

	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "channel")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"channel"}->{"argc"} = $ch+1;
			$elm->{"channel"}->{$ch}->{"name"} = "$value";
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$tmporgline = $line;
			$tmporgline =~ s/\s//g;
			if ($err = &getNextValue(*line, *keyword)) {
				goto done;
			}
			if ($keyword eq "file") {
				if ($err = &getNextValue(*line, *value)) {
					goto done;
				}
				$elm->{"channel"}->{$ch}->{"file"} = "$value";
				$tmporgline = $line;
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				if ($value eq "versions") {
					if ($err = &getNextValue(*tmporgline, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"versions"} = "$value";
					$line = $tmporgline;
				}
				$tmporgline = $line;
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				if ($value eq "size") {
					if ($err = &getNextValue(*tmporgline, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"size"} = "$value";
					$line = $tmporgline;
				}
			}
			elsif ($keyword eq "syslog") {
				if ($err = &getNextValue(*line, *value)) {
					goto done;
				}
				$elm->{"channel"}->{$ch}->{"syslog"} = "$value";
			}
			elsif ($keyword eq "null") {
				$elm->{"channel"}->{$ch}->{"null"} = "null";
			}
			else {
				$err = "parseLogging:$STR_ERR_SYNTAX";
				goto done;
			}
			if ($err = &getNextValue(*line, *value)) {
				goto done;
			}
			if ($value ne ";") {
				$err = "parseLogging:$STR_ERR_SYNTAX";
				goto done;
			}
			$tmporgline = $line;
			$tmporgline =~ s/\s//g;
			while ($tmporgline) {
				if ($err = &getNextValue(*line, *keyword)) {
					goto done;
				}
				if ($keyword eq "severity") {
					if ($err = &getNextValue(*line, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"severity"} = "$value";
					if ($value eq "debug") {
						$tmporgline = $line;
						if ($err = &getNextValue(*tmporgline, *value)) {
							goto done;
						}
						if ("$value" eq int($value)) {
							$elm->{"channel"}->{$ch}->{"debug"} = "$value";
							$line = $tmporgline;
						}
					}
				}
				elsif ($keyword eq "print-category") {
					if ($err = &getNextValue(*line, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"print-category"} = "$value";
				}
				elsif ($keyword eq "print-severity") {
					if ($err = &getNextValue(*line, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"print-severity"} = "$value";
				}
				elsif ($keyword eq "print-time") {
					if ($err = &getNextValue(*line, *value)) {
						goto done;
					}
					$elm->{"channel"}->{$ch}->{"print-time"} = "$value";
				}
				else {
					$err = "parseLogging:$STR_ERR_SYNTAX";
					goto done;
				}
				if ($err = &getNextValue(*line, *value)) {
					goto done;
				}
				if ($value ne ";") {
					$err = "parseLogging:$STR_ERR_SYNTAX";
					goto done;
				}
				$tmporgline = $line;
				$tmporgline =~ s/\s//g;
			}
			$ch++;
		}
		elsif (($keyword eq "category")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"category"}->{"argc"} = $ca + 1;
			$elm->{"category"}->{$ca}->{"name"} = "$value";
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			if ($value ne ";") {
				$err = "parseLogging:$STR_ERR_SYNTAX";
				goto done;
			}
			$line =~ s/\s//g;
			@col = split(/\;/, $line);
			$elm->{"category"}->{$ca}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"category"}->{$ca}->{$i} = "$col[$i]";
			}
			$ca++;
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseOptions {
	local($buf, *elm) = @_;
	my(@col, $i, $delimiter, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "version")
				|| ($keyword eq "directory")
				|| ($keyword eq "named-xfer")
				|| ($keyword eq "dump-file")
				|| ($keyword eq "memstatistics-file")
				|| ($keyword eq "pid-file")
				|| ($keyword eq "statistics-file")
				|| ($keyword eq "auth-nxdomain")
				|| ($keyword eq "deallocate-on-exit")
				|| ($keyword eq "dialup")
				|| ($keyword eq "fake-iquery")
				|| ($keyword eq "fetch-glue")
				|| ($keyword eq "has-old-clients")
				|| ($keyword eq "host-statistics")
				|| ($keyword eq "multiple-cnames")
				|| ($keyword eq "notify")
				|| ($keyword eq "recursion")
				|| ($keyword eq "rfc2308-type1")
				|| ($keyword eq "use-id-pool")
				|| ($keyword eq "treat-cr-as-space")
				|| ($keyword eq "also-notify")
				|| ($keyword eq "forward")
				|| ($keyword eq "lame-ttl")
				|| ($keyword eq "max-transfer-time-in")
				|| ($keyword eq "max-ncache-ttl")
				|| ($keyword eq "min-roots")
				|| ($keyword eq "serial-queries")
				|| ($keyword eq "transfer-format")
				|| ($keyword eq "transfers-in")
				|| ($keyword eq "transfers-out")
				|| ($keyword eq "transfers-per-ns")
				|| ($keyword eq "transfer-source")
				|| ($keyword eq "maintain-ixfr-base")
				|| ($keyword eq "max-ixfr-log-size")
				|| ($keyword eq "coresize")
				|| ($keyword eq "datasize")
				|| ($keyword eq "files")
				|| ($keyword eq "stacksize")
				|| ($keyword eq "cleaning-interval")
				|| ($keyword eq "heartbeat-interval")
				|| ($keyword eq "interface-interval")
				|| ($keyword eq "statistics-interval")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
		}
		elsif ($keyword eq "forwarders") {
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		elsif ($keyword eq "check-names") {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-type"} = "$value";
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-value"} = "$value";
		}
		elsif (($keyword eq "allow-query")
				|| ($keyword eq "allow-recursion")
				|| ($keyword eq "allow-transfer")
				|| ($keyword eq "blackhole")
				|| ($keyword eq "topology")
				|| ($keyword eq "sortlist")) {
			##
			# address_match_list
			##
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
#			$elm->{"$keyword"} = "$line";
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		elsif ($keyword eq "listen-on") {
			$tmporgline = $orgline;
			if ($err = &getNextValue(*tmporgline, *value)) {
				goto done;
			}
			if ($value ne "{" && $value eq "port") {
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				$elm->{"$keyword-port"} = "$value";
				$orgline = $tmporgline;
			}
			##
			# address_match_list
			##
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
#			$elm->{"$keyword-acl"} = "$line";
			@col = split(/\;/, $line);
			$elm->{"$keyword-acl"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword-acl"}->{$i} = "$col[$i]";
			}
		}
		elsif ($keyword eq "query-source") {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			if ($value eq "address") {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword-address"} = "$value";

				$tmporgline = $orgline;
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				if ($value eq "port") {
					if ($err = &getNextValue(
							*tmporgline, *value)) {
						goto done;
					}
					$elm->{"$keyword-port"} = "$value";
					$orgline = $tmporgline;
				}
			}
			elsif ($value eq "port") {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword-port"} = "$value";

				$tmporgline = $orgline;
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				if ($value eq "address") {
					if ($err = &getNextValue(
							*tmporgline, *value)) {
						goto done;
					}
					$elm->{"$keyword-address"} = "$value";
					$orgline = $tmporgline;
				}
			}
			else {
				$err = "parseOptions:$STR_ERR_SYNTAX";
				goto done;
				next;
			}
		}
		elsif ($keyword eq "rrset-order") {
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				if (&getOrderSpec($col[$i],
					*classname, *typename, *name, *order)) {
					goto done;
				}
				$elm->{"$keyword-class"}->{$i} = $classname;
				$elm->{"$keyword-type"}->{$i} = $typename;
				$elm->{"$keyword-name"}->{$i} = $name;
				$elm->{"$keyword-order"}->{$i} = $order;
			}
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		if ($err = &getNextValue(*orgline, *value)) {
			goto done;
		}
		if ($value ne ";") {
			$err = "parseOptions:$STR_ERR_SYNTAX";
			goto done;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
sub parseZone {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	$elm->{"zname"} = $value;
	$tmporgline = $orgline;
	if ($err = &getNextValue(*tmporgline, *value)) {
		goto done;
	}
	if ($value ne "{") {
		$elm->{opt} = $value;
		$orgline = $tmporgline;
	}
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		$err = "parseZone:$STR_ERR_SYNTAX";
		goto done;
	}
	if ($value ne ";") {
		$err = "parseZone:$STR_ERR_SYNTAX";
		goto done;
	}

	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "type")
				|| ($keyword eq "file")
				|| ($keyword eq "check-names")
				|| ($keyword eq "dialup")
				|| ($keyword eq "notify")
				|| ($keyword eq "transfer-source")
				|| ($keyword eq "max-transfer-time-in")
				|| ($keyword eq "forward")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
		}
		elsif (($keyword eq "allow-update")
				|| ($keyword eq "allow-query")
				|| ($keyword eq "allow-transfer")) {
			##
			# address_match_list
			##
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
#			$elm->{"$keyword"} = "$line";
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{argc} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		elsif ($keyword eq "masters") {
			$tmporgline = $orgline;
			if ($err = &getNextValue(*tmporgline, *value)) {
				goto done;
			}
			if ($value ne "{" && $value eq "port") {
				if ($err = &getNextValue(*tmporgline, *value)) {
					goto done;
				}
				$elm->{"$keyword-port"} = "$value";
				$orgline = $tmporgline;
			}
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		elsif (($keyword eq "forwarders")
				|| ($keyword eq "also-notify")) {
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/\s//g;
			@col = split(/\;/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		elsif ($keyword eq "pubkey") {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-num1"} = "$value";
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-num2"} = "$value";
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-num3"} = "$value";
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword-str"} = "$value";
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		if ($err = &getNextValue(*orgline, *value)) {
			goto done;
		}
		if ($value ne ";") {
			$err = "parseZone:$STR_ERR_SYNTAX";
			goto done;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseAcl {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	$elm->{"name"} = $value;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseAcl:$STR_ERR_SYNTAX";
		goto done;
	}
	##
	# address_match_list
	##
	$line =~ s/\s//g;
#	$elm->{acl} = $line;
	@col = split(/\;/, $line);
	$elm->{"acl"}->{"argc"} = $#col + 1;
	for ($i = 0; $i <= $#col; $i++) {
		$elm->{"acl"}->{$i} = "$col[$i]";
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
sub parseKey {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	$elm->{"key_id"} = $value;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseKey:$STR_ERR_SYNTAX";
		goto done;
	}

	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "algorithm")
				|| ($keyword eq "secret")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		if ($err = &getNextValue(*orgline, *value)) {
			goto done;
		}
		if ($value ne ";") {
			$err = "parseKey:$STR_ERR_SYNTAX";
			goto done;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseTrustedKeys {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($line =~ /^\s*$/) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseTrustedKeys:$STR_ERR_SYNTAX";
		goto done;
	}
	$line =~ s/^\s*//;
	@col = split(/\s+/, $line);
	if ($#col < 4) {
		$err = "parseTrustedKeys:$STR_ERR_SYNTAX";
		goto done;
	}
	$elm->{"domain"} = "$col[0]";
	$elm->{"flags"} = "$col[1]";
	$elm->{"protocol"} = "$col[2]";
	$elm->{"algorithm"} = "$col[3]";
	$elm->{"key"} = "$col[4]";
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseServer {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	$elm->{"ipaddr"} = $value;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseServer:$STR_ERR_SYNTAX";
		goto done;
	}

	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "bogus")
				|| ($keyword eq "transfers")
				|| ($keyword eq "transfer-format")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
		}
		elsif (($keyword eq "keys")) {
			if ($err = &getNextBracket(*orgline, *line)) {
				goto done;
			}
			$line =~ s/^\s*//;
			@col = split(/\s+/, $line);
			$elm->{"$keyword"}->{"argc"} = $#col + 1;
			for ($i = 0; $i <= $#col; $i++) {
				$elm->{"$keyword"}->{$i} = "$col[$i]";
			}
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		if ($err = &getNextValue(*orgline, *value)) {
			goto done;
		}
		if ($value ne ";") {
			goto done;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseControls {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextBracket(*orgline, *line)) {
		goto done;
	}
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseControls:$STR_ERR_SYNTAX";
		goto done;
	}

	$orgline = $line;
	$tmporgline = $orgline;
	$tmporgline =~ s/\s//g;

	while ($tmporgline) {
		if ($err = &getNextValue(*orgline, *keyword)) {
			goto done;
		}
		if (($keyword eq "inet")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
			if ($err = &getNextValue(*orgline, *keyword)) {
				goto done;
			}
			if (($keyword eq "port")) {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword"} = "$value";
			}
			else {
				$err = "parseControls:$STR_ERR_SYNTAX";
				goto done;
			}
			if ($err = &getNextValue(*orgline, *keyword)) {
				goto done;
			}
			if (($keyword eq "allow")) {
				##
				# address_match_list
				##
				if ($err = &getNextBracket(*orgline, *line)) {
					goto done;
				}
				$line =~ s/\s//g;
#				$elm->{"$keyword"} = "$line";
				@col = split(/\;/, $line);
				$elm->{"$keyword"}->{"argc"} = $#col+1;
				for ($i = 0; $i <= $#col; $i++) {
					$elm->{"$keyword"}->{$i} = "$col[$i]";
				}
			}
			else {
				$err = "parseControls:$STR_ERR_SYNTAX";
				goto done;
			}
		}
		elsif (($keyword eq "unix")) {
			if ($err = &getNextValue(*orgline, *value)) {
				goto done;
			}
			$elm->{"$keyword"} = "$value";
			if ($err = &getNextValue(*orgline, *keyword)) {
				goto done;
			}
			if (($keyword eq "perm")) {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword"} = "$value";
			}
			else {
				$err = "parseControls:$STR_ERR_SYNTAX";
				goto done;
			}
			if ($err = &getNextValue(*orgline, *keyword)) {
				goto done;
			}
			if (($keyword eq "owner")) {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword"} = "$value";
			}
			else {
				$err = "parseControls:$STR_ERR_SYNTAX";
				goto done;
			}
			if ($err = &getNextValue(*orgline, *keyword)) {
				goto done;
			}
			if (($keyword eq "group")) {
				if ($err = &getNextValue(*orgline, *value)) {
					goto done;
				}
				$elm->{"$keyword"} = "$value";
			}
			else {
				$err = "parseControls:$STR_ERR_SYNTAX";
				goto done;
			}
		}
		else {
			$tmporgline = $orgline;
			$tmporgline =~ s/\s//g;
			next;
		}
		if ($err = &getNextValue(*orgline, *value)) {
			goto done;
		}
		if ($value ne ";") {
			$err = "parseControls:$STR_ERR_SYNTAX";
			goto done;
		}
		$tmporgline = $orgline;
		$tmporgline =~ s/\s//g;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub parseInclude {
	local($buf, *elm) = @_;
	my($i, @col, $err);

	$err = 0;
	$orgline = $buf;
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	$elm->{"path"} = "$value";
	if ($err = &getNextValue(*orgline, *value)) {
		goto done;
	}
	if ($value ne ";") {
		$err = "parseInclude:$STR_ERR_SYNTAX";
		goto done;
	}
done:
	return $err;
}
#----------------------------------------------------------------------------
sub getNextValue {
	local(*orgline, *value) = @_;
	my(@col, $i, $err);

	$err = 0;
	$orgline =~ s/^\s*//;
	@col = split(/\s+/, $orgline);
	if ($#col < 0) {
		$err = "getNextValue:$STR_ERR_NODATA";
		goto done;
	}
	$value = $col[0];
	$orgline = "";
	for ($i = 1; $i <= $#col; $i++) {
		if ($i != 1) {
			$orgline .= " ";
		}
		$orgline .= "$col[$i]";
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
sub getNextBracket {
	local(*orgline, *line) = @_;
	my(@col, $i, $nexti, $bracket, $bra, $cket, $err);

	$err = 0;
	$orgline =~ s/^\s*//;
	@col = split(/\s+/, $orgline);
	if ($#col < 0) {
		$err = "getNextBracket:$STR_ERR_NODATA";
		goto done;
	}
	$bracket = 0;
	$bra = -1;
	$cket = -1;
	$nexti = 0;
	for ($i = 0; $i <= $#col; $i++) {
		if ($col[$i] eq "{") {
			$bracket++;
			if ($bra == -1) {
				$bra = $i+1;
			}
		}
		elsif($col[$i] eq "}") {
			$bracket--;
			$cket = $i;
			if ($bra != -1 && $bracket == 0) {
				$nexti = $i + 1;
				last;
			}
		}
	}
	if ($bracket != 0) {
		$err = "Syntax error.";
		$err = "getNextBracket:$STR_ERR_SYNTAX";
		goto done;
	}
	$orgline = "";
	for ($i = $nexti; $i <= $#col; $i++) {
		if ($i != $nexti) {
			$orgline .= " ";
		}
		$orgline .= "$col[$i]";
	}
	$line = "";
	for ($i = $bra; $i < $cket; $i++) {
		if ($i != $bra) {
			$line .= " ";
		}
		$line .= $col[$i];
	}
done:
	return $err;
}

#----------------------------------------------------------------------------
# Read zone file
#---------------------------------------------------------------------------
sub readRR {
	local($zname, $rrfilename, *rrecord, 
		*rrincfilename, *rrincoptdomain, *rrdefaultttl) = @_;
	my ($fp, $w, $num, @col, $line, $len, $i, $j, $err);

	$err = 0;
	splice(@rr, 0, $#rr+1);
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_R_B, *LOCK)) {
		$err = "readRR:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		goto done;
	}
	if (!open(IN, "$rrfilename")) {
		$err = "readRR:$STR_ERR_CANTOPENFILE($rrfilename)";
		goto done;
	}
	$fp = IN;
	$rrorigin = &getOrigin($zname);
	$rrdomain = $rrorigin;
	$rroptttl = 86400;
	$rroptclass = "IN";
	$rrdefaultttl = 86400;
	$num = 1;
	while ($line = <IN>) {
		$line =~ s/\s*$//;
		$rrline = $line;
		$line =~ s/^\s*//;
		$w = substr($line, 0, 1);
		if ($w eq ";") {
			next;
		}
		@col = split(/\;/, $line);
		if ($#col < 0) {
			next;
		}
		$line = $col[0];
		# ɲ
		@col = "";
		@col = split(/\s+/, $line);
		if ($#col < 0) {
			next;
		}
		if ($col[0] eq "\$INCLUDE") {
			if ($#col < 2) {
				$err = "readRR:$STR_ERR_SYNTAX";
				goto done;
			}
			$rrincfilename = "$col[1]";
			$rrincoptdomain = "$col[2]";
			next;
		}
		elsif ($col[0] eq "\$ORIGIN") {
			if ($#col < 1) {
				$err = "readRR:$STR_ERR_SYNTAX";
				goto done;
			}
			$rrorigin = "$col[1]";
			$rrdomain = $rrorigin;
			next;
		}
		elsif ($col[0] eq "\$TTL") {
			if ($#col < 1) {
				$err = "readRR:$STR_ERR_SYNTAX";
				goto done;
			}
			$rrdefaultttl = "$col[1]";
			$rroptttl = $rrdefaultttl;
			next;
		}
		$rr = {};
		$rr = $num;
		if (&parseRR($fp, $rrline, *rrorigin, *rrdomain, 
				*rroptttl, *rroptclass, *rr)) {
			next;
		}
		if ($rr) {
			push(@rrecord, $rr);
			$num++;
		}
	}
done:
	close(IN);
	close(LOCK);
	return($err);
}

sub parseRR {
	local($fp, $line, *rrorigin, *rrdomain,
			*rroptttl, *rroptclass, *rr) = @_;
	my(@col, $i, $j, $w, $len, $rrtype, $tmpttl, $nline, $soaline, $err);

	$err = 0;
	@col = split(/\;/, $line);
	if ($#col < 0) {
		goto done;
	}
	$line = $col[0];
	@col = split(/\s+/, $line);
	if ($#col < 0) {
		goto done;
	}
	for ($i = 0; $i <= $#col; $i++) {
		if (($col[$i] eq "SOA") || ($col[$i] eq "A")
			|| ($col[$i] eq "NS") || ($col[$i] eq "CNAME")
			|| ($col[$i] eq "MX") || ($col[$i] eq "NULL")
			|| ($col[$i] eq "RP") || ($col[$i] eq "PTR")
			|| ($col[$i] eq "HINFO") || ($col[$i] eq "TXT")) {
			$rrtype = "$col[$i]";
			last;
		}
	}
	if ($i > $#col || ($i != 1 && $i != 2 && $i != 3)) {
		$err = "parseRR:$STR_ERR_SYNTAX";
		goto done;
	}
	$rr->{rrorigin} = $rrorigin;
	if ($col[0]) {
		$rr->{rrdomain} = "$col[0]";
	}
	else {
		$rr->{rrdomain} = "$rrdomain";
	}
	if ($i == 1) {
		$rr->{rroptttl} = "$rroptttl";
		$rr->{rroptclass} = "$rroptclass";
	}
	elsif ($i == 2) {
		$tmpttl = int($col[1]);
		if ("$col[1]" eq "$tmpttl") { #äTTL
			$rr->{rroptttl} = "$col[1]";
			$rr->{rroptclass} = "$rroptclass";
		}
		else { #opt_class
			$rr->{rroptttl} = "$rroptttl";
			$rr->{rroptclass} = "$col[1]";
		}
	}
	elsif ($i == 3) {
		$rr->{rroptttl} = "$col[1]";
		$rr->{rroptclass} = "$col[2]";
	}
	else {
		$err = "parseRR:$STR_ERR_SYNTAX";
		goto done;
	}
	if ($rr->{rrdomain} eq "@") {
		$rr->{rrdomain} = "$rrorigin";
		$rrdomain = $rr->{rrorigin};
	}
	else {
		if ($rr->{rrdomain} !~ /$rr->{rrorigin}/) {
			$len = length($rr->{rrdomain});
			$w = substr($rr->{rrdomain}, $len-1, 1);
			if (($w ne ".")
				&& ($rr->{rrorigin} ne $rr->{rrdomain})) {
				$rrdomain = $rr->{rrdomain};
				$rr->{rrdomain} = "$rrdomain";
				$rr->{rrdomain} .= ".$rrorigin";
			}
		}
	}
	$rrdomain = $rr->{rrdomain};
	$rroptttl = $rr->{rroptttl};
	$rroptclass = $rr->{rroptclass};
	$rr->{rrtype} = "$rrtype";

	if (($rrtype eq "SOA")) {
		$rr->{soa_machine} = $col[++$i];
		$rr->{soa_contact} = $col[++$i];
	
		$nline = "";
		for (++$i; $i <= $#col; $i++) {
			$nline .= "$col[$i]";
			$nline .= " ";
		}
		$nline =~ s/^\s*//;
		$soaline = " ";
		$flag = 0;
		$bracket = 0;
		$len = length($nline);
		for ($j = 0; $j < $len; $j++) {
			$w = substr($nline, $j, 1);
			if ($w eq "(") {
				$bracket++;
			}
			elsif ($w eq ")") {
				$bracket--;
				if ($bracket == 0) {
					$flag = 1;
					last;
				}
			}
			else {
				if ($bracket > 0) {
					$soaline .= $w;
				}
			}
				
		}
		if ($flag == 0) {
			while ($nline = <$fp>) {
				$soaline .= " ";
				$nline =~ s/\s*$//;
				$w = substr($nline, 0, 1);
				if ($w eq ";") {
					next;
				}
				@col = split(/\;/, $nline);
				if ($#col < 0) {
					next;
				}
				$nline = $col[0];
				$nline =~ s/^\s*//;
				@col = split(/\s+/, $nline);
				if ($#col < 0) {
					next;
				}
				$len = length($nline);
				for ($j = 0; $j < $len; $j++) {
					$w = substr($nline, $j, 1);
					if ($w eq "(") {
						$bracket++;
					}
					elsif ($w eq ")") {
						$bracket--;
						if ($bracket == 0) {
							$flag = 1;
							last;
						}
					}
					else {
						if ($bracket > 0) {
							$soaline .= $w;
						}
					}
				}
				if ($flag == 1) {
					last;
				}
			}
		}
		if ($flag == 0) {
			$err = "parseRR:$STR_ERR_SYNTAX";
			goto done;
		}
		$soaline =~ s/^\s*//;
		@col = split(/\s+/, $soaline);
		if ($#col < 4) {
			$err = "parseRR:$STR_ERR_SYNTAX";
			goto done;
		}
		$rr->{soa_serial} = "$col[0]";
		$rr->{soa_refresh} = "$col[1]";
		$rr->{soa_retry} = "$col[2]";
		$rr->{soa_expire} = "$col[3]";
		$rr->{soa_minimum} = "$col[4]";
		if (!$rr->{rroptttl}) {
			if ($rroptttl > 0) {
				$rr->{rroptttl} = "$rroptttl";
				$rroptttl = "$rroptttl";
			}
			else {
				$rr->{rroptttl} = "$col[4]";
				$rroptttl = "$col[4]";
			}
		}
	}
	elsif (($rrtype eq "NS") || ($rrtype eq "A") 
			|| ($rrtype eq "CNAME") || ($rrtype eq "PTR")) {
		$rr->{rrdata} = $col[++$i];
	}
	elsif (($rrtype eq "MX")) {
		$rr->{mx_priority} = $col[++$i];
		$rr->{mx_server} = $col[++$i];
	}
	elsif (($rrtype eq "NULL")
			|| ($rrtype eq "TXT")
			|| ($rrtype eq "RP")) {
		$i++;
		for ($j = $i; $j <= $#col; $j++) {
			if ($j != $i) {
				$rr->{rrdata} .= " ";
			}
			$rr->{rrdata} .= $col[$j];
		}
	}
	elsif (($rrtype eq "HINFO")) {
		$i++;
		$w = substr($col[$i], 0, 1);
		if ($w eq "\"") {
			for ($j = $i; $j <= $#col; $j++) {
				if ($j != $i) {
					$rr->{hinfo_hw_cpu} .= " ";
				}
				$rr->{hinfo_hw_cpu} .= $col[$j];
				$len = length($col[$j]);
				$w = substr($col[$j], $len-1, 1);
				if ($w eq "\"") {
					last;
				}
			}
			$j = $i;
		}
		else {
			$rr->{hinfo_hw_cpu} = $col[$i];
		}
		$i++;
		$w = substr($col[$i], 0, 1);
		if ($w eq "\"") {
			for ($j = $i; $j <= $#col; $j++) {
				if ($j != $i) {
					$rr->{hinfo_sw_os} .= " ";
				}
				$rr->{hinfo_sw_os} .= $col[$j];
				$len = length($col[$j]);
				$w = substr($col[$j], $len-1, 1);
				if ($w eq "\"") {
					last;
				}
			}
			$j = $i;
		}
		else {
			$rr->{hinfo_sw_os} = $col[$i];
		}
	}
done:
	return $err;
}

#---------------------------------------------------------------------------
sub getOrderSpec {
	local($buf, *classname, *typename, *name, *order) = @_;
	my($err, $i, $setflag);

	$err = 0;
	$setflag = 0;
	if (!$buf) {
		$err = $STR_ERR_BADVALUE;
		goto done;
	}
	$buf =~ s/^\s*//;
	@col = split(/\s+/, $buf);

	$classname = "";
	$typename = "";
	$name = "";
	$order = "";

	for ($i = 0; $i <= $#col; $i += 2) {
		if ($i+1 > $#col) {
			$err = $STR_ERR_EBADVALUE;
			goto done;
		}
		if ($col[$i] eq "class") {
			$classname = $col[$i+1];
		}
		elsif ($col[$i] eq "type") {
			$typename = $col[$i+1];
		}
		elsif ($col[$i] eq "name") {
			$name = $col[$i+1];
		}
		elsif ($col[$i] eq "order") {
			if (($col[$i+1] ne "fixed")
					&& ($col[$i+1] ne "random")
					&& ($col[$i+1] ne "cyclic")) {
				$err = $STR_ERR_EBADVALUE;
				goto done;
			}
			$order = $col[$i+1];
			$setflag = 1;
		}
		else {
			$err = $STR_ERR_EBADVALUE;
			goto done;
		}
	}
	if ($setflag == 0) {
		$err = $STR_ERR_EBADVALUE;
	}
done:
	return($err);
}

#---------------------------------------------------------------------------
1;

