# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: confwrite.pl,v 1.1.1.1 2002/09/09 07:43:35 snavi Exp $

#----------------------------------------------------------------------------
sub printConf {
	local($fp, *confs) = @_;
	my($i);

	for ($i = 0; $i <= $#confs; $i++) {
		if ($confs[$i]->{"keywd"} eq "logging") {
			&printLogging($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "options") {
			&printOptions($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "zone") {
			&printZone($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "acl") {
			&printAcl($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "key") {
			&printKey($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "trusted-keys") {
			&printTrustedKeys($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "server") {
			&printServer($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "controls") {
			&printControls($fp, $confs[$i]);
		}
		elsif ($confs[$i]->{"keywd"} eq "include") {
			&printInclude($fp, $confs[$i]);
		}
		else {
			&printOthers($fp, $confs[$i]);
		}
	}
	
}

#----------------------------------------------------------------------------
sub printLogging {
	local($fp, $elm) = @_;
	my($value, $argc, $i, $j);

	if (!($value = $elm->{"keywd"}) || ($value ne "logging")) {
		return 1;
	}
	print $fp "logging {\n";
	
	for ($j = 0; $j < $elm->{"channel"}->{"argc"}; $j++) {
		if (($value = $elm->{"channel"}->{$j}->{"name"})) {
			print $fp "\tchannel $value {\n";
			if (($value = $elm->{"channel"}->{$j}->{"file"})) {
				print $fp "\t\tfile \"$value\"";
				if (($value = $elm->{"channel"}->{$j}->{"versions"})) {
					print $fp " versions $value";
				}
				if (($value = $elm->{"channel"}->{$j}->{"size"})) {
					print $fp " size $value";
				}
			}
			elsif (($value = $elm->{"channel"}->{$j}->{"syslog"})) {
				print $fp "\t\tsyslog $value";
			}
			else {
				print $fp "\t\tnull";
			}
			print $fp ";\n";
			
			if (($value = $elm->{"channel"}->{$j}->{"severity"})) {
				print $fp "\t\tseverity $value";
				if ($value eq "debug") {
					print $fp " $value";
				}
				print $fp ";\n";
			}
			if (($value = $elm->{"channel"}->{$j}->{"print-category"})) {
				print $fp "\t\tprint-category $value;\n";
			}
			if (($value = $elm->{"channel"}->{$j}->{"print-severity"})) {
				print $fp "\t\tprint-severity $value;\n";
			}
			if (($value = $elm->{"channel"}->{$j}->{"print-time"})) {
				print $fp "\t\tprint-time $value;\n";
			}
			print $fp "\t};\n";
		}
	}
	for ($j = 0; $j < $elm->{"category"}->{"argc"}; $j++) {
		if (($value = $elm->{"category"}->{$j}->{"name"})) {
			print $fp "\tcategory $value {\n";
			$argc = $elm->{"category"}->{$j}->{"argc"};
			for ($i = 0; $i < $argc; $i++) {
				if (($value = $elm->{"category"}->{$j}->{$i})) {
					print $fp "\t\t$value;\n";
				}
			}
			print $fp "\t};\n";
		}
	}
	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printOptions {
	local($fp, $elm) = @_;
	my($value, $value1, $value2, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "options")) {
		return 1;
	}
	print $fp "options {\n";
		
	if (($value = $elm->{"version"})) {
		print $fp "\tversion $value;\n";
	}

	if (($value = $elm->{"directory"})) {
		print $fp "\tdirectory \"$value\";\n";
	}

	if (($value = $elm->{"named-xfer"})) {
		print $fp "\tnamed-xfer \"$value\";\n";
	}

	if (($value = $elm->{"dump-file"})) {
		print $fp "\tdump-file \"$value\";\n";
	}

	if (($value = $elm->{"memstatistics-file"})) {
		print $fp "\tmemstatistics-file \"$value\";\n";
	}

	if (($value = $elm->{"pid-file"})) {
		print $fp "\tpid-file \"$value\";\n";
	}

	if (($value = $elm->{"statistics-file"})) {
		print $fp "\tstatistics-file \"$value\";\n";
	}

	if (($value = $elm->{"auth-nxdomain"})) {
		print $fp "\tauth-nxdomain $value;\n";
	}

	if (($value = $elm->{"deallocate-on-exit"})) {
		print $fp "\tdeallocate-on-exit $value;\n";
	}

	if (($value = $elm->{"dialup"})) {
		print $fp "\tdialup $value;\n";
	}

	if (($value = $elm->{"fake-iquery"})) {
		print $fp "\tfake-iquery $value;\n";
	}

	if (($value = $elm->{"fetch-glue"})) {
		print $fp "\tfetch-glue $value;\n";
	}

	if (($value = $elm->{"has-old-clients"})) {
		print $fp "\thas-old-clients $value;\n";
	}

	if (($value = $elm->{"host-statistics"})) {
		print $fp "\thost-statistics $value;\n";
	}

	if (($value = $elm->{"multiple-cnames"})) {
		print $fp "\tmultiple-cnames $value;\n";
	}

	if (($value = $elm->{"notify"})) {
		print $fp "\tnotify $value;\n";
	}

	if (($value = $elm->{"recursion"})) {
		print $fp "\trecursion $value;\n";
	}

	if (($value = $elm->{"rfc2308-type1"})) {
		print $fp "\trfc2308-type1 $value;\n";
	}

	if (($value = $elm->{"use-id-pool"})) {
		print $fp "\tuse-id-pool $value;\n";
	}

	if (($value = $elm->{"treat-cr-as-space"})) {
		print $fp "\ttreat-cr-as-space $value;\n";
	}

#	$argc =  $elm->{"also-notify"}->{"argc"};
#	if ($argc > 0) {
#		print $fp "\talso-notify {\n";
#		for ($i = 0; $i < $argc; $i++) {
#			if (($value = $elm->{"also-notify"}->{$i})) {
#				print $fp "\t\t$value;\n";
#			}
#		}
#		print $fp "\t};\n";
#	}
	if (($value = $elm->{"also-notify"})) {
		print $fp "\talso-notify $value;\n";
	}

	if (($value = $elm->{"forward"})) {
		print $fp "\tforward $value;\n";
	}

	if (($value = $elm->{"lame-ttl"})) {
		print $fp "\tlame-ttl $value;\n";
	}

	if (($value = $elm->{"max-transfer-time-in"})) {
		print $fp "\tmax-transfer-time-in $value;\n";
	}

	if (($value = $elm->{"max-ncache-ttl"})) {
		print $fp "\tmax-ncache-ttl $value;\n";
	}

	if (($value = $elm->{"min-roots"})) {
		print $fp "\tmin-roots $value;\n";
	}

	if (($value = $elm->{"serial-queries"})) {
		print $fp "\tserial-queries $value;\n";
	}

	if (($value = $elm->{"transfer-format"})) {
		print $fp "\ttransfer-format $value;\n";
	}

	if (($value = $elm->{"transfers-in"})) {
		print $fp "\ttransfers-in $value;\n";
	}

	if (($value = $elm->{"transfers-out"})) {
		print $fp "\ttransfers-out $value;\n";
	}

	if (($value = $elm->{"transfers-per-ns"})) {
		print $fp "\ttransfers-per-ns $value;\n";
	}

	if (($value = $elm->{"transfer-source"})) {
		print $fp "\ttransfer-source $value;\n";
	}

	if (($value = $elm->{"maintain-ixfr-base"})) {
		print $fp "\tmaintain-ixfr-base $value;\n";
	}

	if (($value = $elm->{"max-ixfr-log-size"})) {
		print $fp "\tmax-ixfr-log-size $value;\n";
	}

	if (($value = $elm->{"coresize"})) {
		print $fp "\tcoresize $value;\n";
	}

	if (($value = $elm->{"datasize"})) {
		print $fp "\tdatasize $value;\n";
	}

	if (($value = $elm->{"files"})) {
		print $fp "\tfiles $value;\n";
	}

	if (($value = $elm->{"stacksize"})) {
		print $fp "\tstacksize $value;\n";
	}

	if (($value = $elm->{"cleaning-interval"})) {
		print $fp "\tcleaning-interval $value;\n";
	}

	if (($value = $elm->{"heartbeat-interval"})) {
		print $fp "\theartbeat-interval $value;\n";
	}

	if (($value = $elm->{"interface-interval"})) {
		print $fp "\tinterface-interval $value;\n";
	}

	if (($value = $elm->{"statistics-interval"})) {
		print $fp "\tstatistics-interval $value;\n";
	}

	$argc =  $elm->{"forwarders"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tforwarders {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"forwarders"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$value1 = $elm->{"check-names-type"};
	$value2 = $elm->{"check-names-value"};
	if ($value1 && $value2) {
		print $fp "\tcheck-names $value1 $value2;\n";
	}

#	if (($value = $elm->{"allow-query"})) {
#		print $fp "\tallow-query $value;\n";
#	}
#	if (($value = $elm->{"allow-recursion"})) {
#		print $fp "\tallow-recursion $value;\n";
#	}
#	if (($value = $elm->{"allow-transfer"})) {
#		print $fp "\tallow-transfer $value;\n";
#	}
#	if (($value = $elm->{"blackhole"})) {
#		print $fp "\tblackhole $value;\n";
#	}
#	if (($value = $elm->{"topology"})) {
#		print $fp "\ttopology $value;\n";
#	}
#	if (($value = $elm->{"sortlist"})) {
#		print $fp "\tsortlist $value;\n";
#	}

	$argc =  $elm->{"allow-query"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-query {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-query"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}


	$argc =  $elm->{"allow-recursion"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-recursion {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-recursion"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"allow-transfer"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-transfer {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-transfer"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"blackhole"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tblackhole {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"blackhole"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"topology"}->{"argc"};
	if ($argc > 0) {
		print $fp "\ttopology {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"topology"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"sortlist"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tsortlist {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"sortlist"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

#	if (($value = $elm->{"listen-on-port"})) {
#		print $fp "\tlisten-on-ort $value;\n";
#	}
	$buf = "";
	if (($value = $elm->{"listen-on-port"})) {
		if ($value > 0) {
			$buf = " port $value";
		}
	}
#	if (($value = $elm->{"listen-on-acl"})) {
#		print $fp "\tlisten-on-acl $value;\n";
#	}

	$argc =  $elm->{"listen-on-acl"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tlisten-on$buf {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"listen-on-acl"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}


#	if (($value = $elm->{"query-source-address"})) {
#		print $fp "\tquery-source-address $value;\n";
#	}
#	if (($value = $elm->{"query-source-port"})) {
#		print $fp "\tquery-source-port $value;\n";
#	}
	$buf = "";
	if (($value = $elm->{"query-source-address"})) {
		$buf = "address $value";
	}
	if (($value = $elm->{"query-source-port"})) {
		if ($buf) {
			$buf .= " ";
		}
		$buf .= "port $value";
	}
	if ($buf) {
		print $fp "\tquery-source $buf;\n";
	}
	
	$argc = $elm->{"rrset-order"}->{"argc"};
	if ($argc > 0) {
		print $fp "\trrset-order {\n";
		for ($i = 0; $i < $argc; $i++) {
			print $fp "\t       ";
			if (($value = $elm->{"rrset-order-class"}->{$i})) {
				print $fp " class $value";
			}
			if (($value = $elm->{"rrset-order-type"}->{$i})) {
				print $fp " type $value";
			}
			if (($value = $elm->{"rrset-order-name"}->{$i})) {
				print $fp " name \"$value\"";
			}
			if (($value = $elm->{"rrset-order-order"}->{$i})) {
				print $fp " order $value";
			}
			print $fp ";\n";
		}
		print $fp "\t};\n";
	}

	print $fp "};\n";
	return 0;
}	

#----------------------------------------------------------------------------
sub printZone {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "zone")) {
		return 1;
	}
	print $fp "zone";

	if (($value = $elm->{"zname"})) {
		print $fp " \"$value\"";
	}
	if (($value = $elm->{"opt"})) {
		print $fp " $value";
	}

	print $fp " {\n";

	if (($value = $elm->{"type"})) {
		print $fp "\ttype $value;\n";
	}
	if (($value = $elm->{"file"})) {
		print $fp "\tfile \"$value\";\n";
	}
	if (($value = $elm->{"check-names"})) {
		print $fp "\tcheck-names $value;\n";
	}
	if (($value = $elm->{"dialup"})) {
		print $fp "\tdialup $value;\n";
	}
	if (($value = $elm->{"notify"})) {
		print $fp "\tnotify $value;\n";
	}
	if (($value = $elm->{"transfer-source"})) {
		print $fp "\ttransfer-source $value;\n";
	}
	if (($value = $elm->{"max-transfer-time-in"})) {
		print $fp "\tmax-transfer-time-in $value;\n";
	}
	if (($value = $elm->{"forward"})) {
		print $fp "\tforward $value;\n";
	}


#	if (($value = $elm->{"allow-update"})) {
#		print $fp "\tallow-update $value;\n";
#	}
#	if (($value = $elm->{"allow-query"})) {
#		print $fp "\tallow-query $value;\n";
#	}
#	if (($value = $elm->{"allow-transfer"})) {
#		print $fp "\tallow-transfer $value;\n";
#	}
#	if (($value = $elm->{"also-notify"})) {
#		print $fp "\talso-notify $value;\n";
#	}

	$argc =  $elm->{"allow-update"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-update {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-update"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"allow-query"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-query {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-query"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"allow-transfer"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tallow-transfer {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"allow-transfer"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc =  $elm->{"also-notify"}->{"argc"};
	if ($argc > 0) {
		print $fp "\talso-notify {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"also-notify"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	$argc = $elm->{"masters"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tmasters ";
		if (($value = $elm->{"masters-port"})) {
			print $fp " port $value";
		}
		print $fp " {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"masters"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t\};\n";
	}

	$argc =  $elm->{"forwarders"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tforwarders {\n";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"forwarders"}->{$i})) {
				print $fp "\t\t$value;\n";
			}
		}
		print $fp "\t};\n";
	}

	if (($value = $elm->{"pubkey-num1"})) {
		print $fp "\tpubkey $value";
		if (($value = $elm->{"pubkey-num2"})) {
			print $fp " $value";
		}
		if (($value = $elm->{"pubkey-num3"})) {
			print $fp " $value";
		}
		if (($value = $elm->{"pubkey-str"})) {
			print $fp " $value;";
		}
		print $fp "\n";
	}

	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printAcl {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "acl")) {
		return 1;
	}
	print $fp "acl";

	if (($value = $elm->{name})) {
		print $fp " $value";
	}
	print $fp " {\n";

#	if (($value = $elm->{acl})) {
#		print $fp "\tacl $value;\n";
#	}

	$argc = $elm->{"acl"}->{"argc"};
	if ($argc > 0) {
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"acl"}->{$i})) {
				print $fp "\t$value;\n";
			}
		}
	}
	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printKey {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "key")) {
		return 1;
	}
	print $fp "key";

	if (($value = $elm->{"key_id"})) {
		print $fp " $value";
	}
	print $fp " {\n";

	if (($value = $elm->{"algorithm"})) {
		print $fp "\talgorithm $value;\n";
	}
	if (($value = $elm->{"secret"})) {
		print $fp "\tsecret $value;\n";
	}

	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printTrustedKeys {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "trusted-keys")) {
		return 1;
	}

	print $fp "trusted-keys {\n";

	if (($value = $elm->{"domain"})) {
		print $fp "\t\"$value\"";
	}
	if (($value = $elm->{"flags"})) {
		print $fp " $value";
	}
	if (($value = $elm->{"protocol"})) {
		print $fp " $value";
	}
	if (($value = $elm->{"algorithm"})) {
		print $fp " $value";
	}
	if (($value = $elm->{"key"})) {
		print $fp " $value";
	}
	print $fp ";\n";

	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printServer {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "server")) {
		return 1;
	}
	print $fp "server";

	if (($value = $elm->{"ipaddr"})) {
		print $fp " $value";
	}
	print $fp " {\n";

	if (($value = $elm->{"bogus"})) {
		print $fp "\tbogus $value;\n";
	}
	if (($value = $elm->{"transfers"})) {
		print $fp "\ttransfers $value;\n";
	}
	if (($value = $elm->{"transfer-format"})) {
		print $fp "\ttransfer-format $value;\n";
	}
	$argc = $elm->{"keys"}->{"argc"};
	if ($argc > 0) {
		print $fp "\tkeys {";
		for ($i = 0; $i < $argc; $i++) {
			if (($value = $elm->{"keys"}->{$i})) {
				print $fp " $value";
			}
		}
		print $fp "};\n";
	}
	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printControls {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "controls")) {
		return 1;
	}
	print $fp "controls {\n";

	if (($value = $elm->{"inet"})) {
		print $fp "\tinet $value";
		if (($value = $elm->{"port"})) {
			print $fp " port $value";
		}
		$argc = $elm->{"allow"}->{"argc"};
		if ($argc > 0) {
			print $fp " allow {";
			for ($i = 0; $i < $argc; $i++) {
				if (($value = $elm->{"allow"}->{$i})) {
					print $fp " $value;";
				}
			}
			print $fp " }";
		}
		print $fp ";\n";
	}
	if (($value = $elm->{"unix"})) {
		print $fp "\tunix \"$value\"";
		if (($value = $elm->{"perm"})) {
			print $fp " perm $value";
		}
		if (($value = $elm->{"owner"})) {
			print $fp " owner $value";
		}
		if (($value = $elm->{"group"})) {
			print $fp " group $value";
		}
		print $fp ";\n";
	}

	print $fp "};\n";
	return 0;
}

#----------------------------------------------------------------------------
sub printInclude {
	local($fp, $elm) = @_;
	my($value, $argc, $i);

	if (!($value = $elm->{"keywd"}) || ($value ne "include")) {
		return 1;
	}

	if (($value = $elm->{"path"})) {
		print $fp "include \"$value\";\n";
	}
	return 0;
}

#----------------------------------------------------------------------------
sub printOthers {
	local($fp, $elm) = @_;
	my($value);

	if (!($value = $elm->{"keywd"})) {
		return 1;
	}
	print $fp "\tkeywd $value;\n";
	if (($value = $elm->{"other"})) {
		print $fp "\tother $value;\n";
	}
	return 0;
}


#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
sub printRR {
	local ($fp, $zname, *rrecord, $incfile, $incopt, $defttl) = @_;

	my ($rroptttl, $rroptclasse, $rrorigin, $rrdomain, $dm, $i);

	$rrorigin = &getOrigin($zname);
	$rrdomain = $rrorigin;
	$rroptttl = 86400;

	if ($incfile && $incopt) {
		print $fp "\$INCLUDE\t$incfile\t$incopt\n";
	}
	if ($defttl > 0 && $defttl != 86400) {
		print $fp "\$TTL\t$defttl\n";
	}
	for ($i = 0; $i <= $#rrecord; $i++) {
		if ($rrecord[$i]->{rrtype} eq "SOA") {
			$rroptttl = $rrecord[$i]->{soa_minimum};
			$rroptclass = $rrecord[$i]->{rroptclass};
			last;
		}
	}
	for ($i = 0; $i <= $#rrecord; $i++) {
		if ($rrorigin ne $rrecord[$i]->{rrorigin}) {
			print $fp "\$ORIGIN $rrecord[$i]->{rrorigin}\n";
			$rrorigin = $rrecord[$i]->{rrorigin};
		}
		if ($i == 0) {
			if ($rrecord[$i]->{rrtype} eq "SOA") {
				if ($rrorigin eq $rrecord[$i]->{rrdomain}) {
					print $fp "@";
				}
				else {
					if ($rrorigin eq "\.") {
						$dm = "$rrecord[$i]->{rrdomain}";
					}
					else {
						$dm = "$rrecord[$i]->{rrdomain}";
						$dm =~ s/\.$rrorigin//;
					}
					print $fp "$dm";
				}
			}
			else {
				if ($rrorigin eq $rrecord[$i]->{rrdomain}) {
					print $fp "$rrecord[$i]->{rrdomain}";
				}
				else {
					if ($rrorigin eq "\.") {
						$dm = "$rrecord[$i]->{rrdomain}";
					}
					else {
						$dm = "$rrecord[$i]->{rrdomain}";
						$dm =~ s/\.$rrorigin//;
					}
					print $fp "$dm";
				}
			}
			$rrdomain = $rrecord[$i]->{rrdomain};
		}
		else {
			if ($rrdomain ne $rrecord[$i]->{rrdomain}) {
				if ($rrorigin eq "\.") {
					$dm = "$rrecord[$i]->{rrdomain}";
				}
				else {
					$dm = "$rrecord[$i]->{rrdomain}";
					$dm =~ s/\.$rrorigin//;
				}
				print $fp "$dm";
			}
		}
		print $fp "\t";
		if (($rroptttl != $rrecord[$i]->{rroptttl})
			&& ($rrecord[$i]->{rroptttl} > 0)) {
			print $fp "$rrecord[$i]->{rroptttl}";
			$rroptttl = $rrecord[$i]->{rroptttl};
		}
		print $fp "\t";
#		if ($rroptclass != $rrecord[$i]->{rroptclass}) {
			print $fp "$rrecord[$i]->{rroptclass}";
			$rroptclass = $rrecord[$i]->{rroptclass};
#		}
		print $fp "\t";
		print $fp "$rrecord[$i]->{rrtype}";
		print $fp "\t";

		if ($rrecord[$i]->{rrtype} eq "SOA") {
			print $fp "$rrecord[$i]->{soa_machine}";
			print $fp "\t";
			print $fp "$rrecord[$i]->{soa_contact}";
			print $fp "\t(\n";
			print $fp "\t\t\t\t\t$rrecord[$i]->{soa_serial}\n";
			print $fp "\t\t\t\t\t$rrecord[$i]->{soa_refresh}\n";
			print $fp "\t\t\t\t\t$rrecord[$i]->{soa_retry}\n";
			print $fp "\t\t\t\t\t$rrecord[$i]->{soa_expire}\n";
			print $fp "\t\t\t\t\t$rrecord[$i]->{soa_minimum}";
			print $fp " )";
		}
		elsif (($rrecord[$i]->{rrtype} eq "NS")
				|| ($rrecord[$i]->{rrtype} eq "A") 
				|| ($rrecord[$i]->{rrtype} eq "CNAME")
				|| ($rrecord[$i]->{rrtype} eq "PTR")) {
			print $fp "$rrecord[$i]->{rrdata}";
			print $fp "\t";
		}
		elsif (($rrecord[$i]->{rrtype} eq "MX")) {
			print $fp "$rrecord[$i]->{mx_priority}";
			print $fp "\t";
			print $fp "$rrecord[$i]->{mx_server}";
			print $fp "\t";
		}
		elsif (($rrecord[$i]->{rrtype} eq "NULL")
				|| ($rrecord[$i]->{rrtype} eq "RP")
				|| ($rrecord[$i]->{rrtype} eq "TXT")) {
			print $fp "$rrecord[$i]->{rrdata}";
		}
		elsif (($rrecord[$i]->{rrtype} eq "HINFO")) {
			print $fp "$rrecord[$i]->{hinfo_hw_cpu}";
			print $fp "\t";
			print $fp "$rrecord[$i]->{hinfo_sw_os}";
			print $fp "\t";
		}
		print $fp "\n";
	}
	return 0;
}

#----------------------------------------------------------------------------
sub printMx {
	local($fp, $name, *data) = @_;
	my($i);

	for ($i = 0; $i <= $#data; $i++) {
		print $fp "$name\[$i\]->{mx_priority}=$data[$i]->{mx_priority}\n";
		print $fp "$name\[$i\]->{mx_server}=$data[$i]->{mx_server}\n";
	}
	return 0;
}

sub printList {
	local($fp, $name, *data) = @_;
	my($i);

	for ($i = 0; $i <= $#data; $i++) {
		print $fp "$name\[$i\]=$data[$i]\n";
	}
	return 0;
}

sub printArgList {
	local($fp, $name, $keywd, *data) = @_;
	my($i);

	$argc = $data->{"$keywd"}->{"argc"};
	for ($i = 0; $i < $argc; $i++) {
		print $fp "$name->{$keywd}->{$i}=$data[$i]\n";
	}
	return 0;
}

#----------------------------------------------------------------------------
sub setRootNs {
	local($zname, $zfile, *rns) = @_;
	my($err, $i, $len, $w, $tmpfile, $fp);

	$err = 0;
	if (!$zname || !$zfile) {
		$err = "$STR_ERR_BADVALUE";
		return $err;
        }
	$origin = &getOrigin($zname);

	$tmpfile = "$zfile.tmp";
	if (!&lockFile($NAMEDLOCKFILE, $WBMC_LOCK_W_B, *LOCK)) {
		$err = "setRootNs:$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
		return $err;
	}
	if (!open(OUT, "> $tmpfile")) {
		$err = "setRootNs:$STR_ERR_CANTOPENFILE($tmpfile)";
		close(LOCK);
		return $err;
	}
	for ($i = 0; $i <= $#rns; $i++) {
		$len = length($rns[$i]->{"name"});
		$w = substr($rns[$i]->{"name"}, $len-1, 1);
		if ($w ne ".") {
			$rns[$i]->{"name"} .= "\.$origin";
		}
		print OUT "$origin\t$Z_OPT_TTL  IN  NS  $rns[$i]->{\"name\"}\n";
		print OUT "$rns[$i]->{\"name\"}\t$Z_OPT_TTL  IN  A  $rns[$i]->{\"addr\"}\n";
	}
	close(OUT);
	close(LOCK);

	rename($tmpfile, $zfile);

	return $err;
}

#----------------------------------------------------------------------------
1;

