# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: hosts2zone.pl,v 1.1.1.1 2002/09/09 07:43:35 snavi Exp $

##010615         "1;" ɲ    haramoto

require "/opt/nec/wbmc/bin/confinit.pl";
require "/opt/nec/wbmc/lib/dns/confedit.pl";
require "/opt/nec/wbmc/lib/dns/confwrite.pl";

#
# ̾
#     updateDnsData - DNSΥ򹹿
# 
#     updateDnsData(@hosts)
# 
#     @hosts - /etc/hosts(readFile()ʤɤɤ߹)
# 
#     /etc/hostsξ򸵤ˡDNSΥ򹹿ޤ
#
sub updateDnsData
{
    local(@hosts) = @_;
    local($err);
    local($zone);

    # INITCONF.INIեɤ
    if ($err = &readConfFile("/etc/opt/nec/wbmc/INITCONF.INI")) {
        goto done;
    }

    # ¦ե򹹿
    if ($err = &hosts2zone(
        $IfEth1{'ShortHostName'}, $IfEth1{'DomainName'}, @hosts)) {
        goto done;
    }

    # ¦հե򹹿
    if (($Meta{'NetType'} eq "internet")
            && ($IfEth1{'DnsType'} eq "master")) {
        $zone = $IfEth1{'DnsZoneName'};
    } else {
        $zone = "";
    }
    if ($err = &hosts2rzone(
        $IfEth1{'ShortHostName'}, $IfEth1{'DomainName'},
        $IfEth1{'NetAddr'}, $IfEth1{'NetMask'}, $zone, @hosts)) {
        goto done;
    }

    # slaveλ¦Υեʤ
    if ($IfEth0{'DnsType'} eq "slave") {
        goto done;
    }

    # ¦ե򹹿
    if ($err = &hosts2zone(
        $IfEth0{'ShortHostName'}, $IfEth0{'DomainName'}, @hosts)) {
        goto done;
    }

    # ¦հե򹹿
    if ($err = &hosts2rzone(
        $IfEth0{'ShortHostName'}, $IfEth0{'DomainName'},
        $IfEth0{'NetAddr'}, $IfEth0{'NetMask'}, "", @hosts)) {
        goto done;
    }

done:
    return($err);
}

#
# ̾
#     hosts2zone - DNSΥ򹹿
# 
#     hosts2zone($host, $domain, @hosts)
# 
#     $host - ۥ̾(ex. "www")
#     $domain - ɥᥤ̾(ex. "abc.do.jp")
#     @hosts - /etc/hosts(readFile()ʤɤɤ߹)
# 
#     /etc/hostsξ򸵤ˡDNSΥ()򹹿ޤ
#
sub hosts2zone
{
    local($host, $domain, @hosts) = @_;
    local($hostname, $zname, $zfname);
    local(@orgrr, $orgincfile, $orgincopt, $orgdefttl);
    local($origin, $machine, $contact);
    local($serial, $refresh, $retry, $expire, $minimum);
    local($incfile, $incopt, $optclass, $optttl);
    local(@elms, @rrr);
    local($i, $j, $k, $n, $h);
    local($fp, $tmpbuf, @col, @col2);
    local($err);

    $hostname = "$host.$domain";    # ۥ̾
    $zname = "$domain.";        # ̾
    $zfname = "g.$domain";      # ե̾

    $origin = "$domain.";       # ǥեȥɥᥤ̾
    $machine = "$hostname.";    # ޥ̾
    $contact = "root.$machine"; # ̾
    $serial = &getSerial(0);    # ꥢֹ
    $refresh = 28800;       # եåֳ
    $retry = 14400;         # ȥ饤ֳ
    $expire = 3600000;      # ѥ
    $minimum = 86400;       # ǾTTL

    $incfile = "";
    $incopt = "";
    $optclass = "IN";
    $optttl = $minimum;

    # եɤ߹
    if (-e "/var/named/$zfname") {
        @orgrr = ();
        $orgincfile = "";
        $orgincopt = "";
        $orgdefttl = 0;
        if ($err = readRR($zname, "/var/named/$zfname",
            *orgrr, *orgincfile, *orgincopt, *orgdefttl)) {
            goto done;
        }

        for ($i = 0; $i <= $#orgrr; $i++) {
            if (($orgrr[$i]->{rrtype} eq "SOA")
                &&($orgrr[$i]->{rrdomain} eq "$domain.")) {
                $machine = $orgrr[$i]->{soa_machine};
                $contact = $orgrr[$i]->{soa_contact};
                $serial = &getSerial($orgrr[$i]->{soa_serial});
                $refresh = $orgrr[$i]->{soa_refresh};
                $retry = $orgrr[$i]->{soa_retry};
                $expire = $orgrr[$i]->{soa_expire};
                $minimum = $orgrr[$i]->{soa_minimum};
                last;
            }
        }
    }

    # ۥȥե
    $n = 0;
    for ($i = 0; $i <= $#hosts; $i++) {
        $tmpbuf = $hosts[$i];
        $tmpbuf =~ s/^\s*//;
        $tmpbuf =~ s/\s*$//;
        $tmpbuf =~ s/#.*$//;
        @col = split(/\s+/, $tmpbuf);

        # Ԥ롼ץХåɥ쥹̵
        if (($#col < 1) || ($col[0] eq "127.0.0.1")) {
            next;
        }

        $h = 0;
        for ($j = 1; $j <= $#col; $j++) {
            if ($col[$j] =~ /\.$domain$/) {
                $elms[$n]->{addr} = $col[0];
                $elms[$n]->{argc} = $h;
                $elms[$n]->{$h} = $col[$j];
                $h++;
            }
        }
        if ($h != 0) {
            $n++;
        }
    }

    # ѥ꥽쥳ɤѴ
    $n = 0;

    # SOA쥳ɤ
    $rrr[$n]->{rrorigin} = $origin;
    $rrr[$n]->{rrdomain} = "$domain.";
    $rrr[$n]->{rroptttl} = $optttl;
    $rrr[$n]->{rroptclass} = $optclass;
    $rrr[$n]->{rrtype} = "SOA";
    $rrr[$n]->{soa_machine} = $machine;
    $rrr[$n]->{soa_contact} = $contact;
    $rrr[$n]->{soa_serial} = $serial;
    $rrr[$n]->{soa_refresh} = $refresh;
    $rrr[$n]->{soa_retry} = $retry;
    $rrr[$n]->{soa_expire} = $expire;
    $rrr[$n]->{soa_minimum} = $minimum;
    $n++;

    # NS쥳ɤ
    $rrr[$n]->{rrorigin} = $origin;
    $rrr[$n]->{rrdomain} = "$domain.";
    $rrr[$n]->{rroptttl} = $optttl;
    $rrr[$n]->{rroptclass} = $optclass;
    $rrr[$n]->{rrtype} = "NS";
    $rrr[$n]->{rrdata} = $machine;
    $n++;

    # MX쥳ɤ
    $rrr[$n]->{rrorigin} = $origin;
    $rrr[$n]->{rrdomain} = "$domain.";
    $rrr[$n]->{rroptttl} = $optttl;
    $rrr[$n]->{rroptclass} = $optclass;
    $rrr[$n]->{rrtype} = "MX";
    $rrr[$n]->{mx_priority} = "0";
    $rrr[$n]->{mx_server} = $machine;
    $n++;

    for ($i = 0; $i <= $#elms; $i++) {
        for ($j = 0; $j <= $elms[$i]->{argc}; $j++) {
            @col2 = split(/\./, $elms[$i]->{$j});

            # ۥ̾˥ɥåȤޤ硢ꥸʥɥᥤѹ
            # ۥ̾ϤΤޤޡ
            if ($#col2 > 0) {
                $rrr[$n]->{rrorigin} = "";
                for ($k = 1; $k <= $#col2; $k++) {
                    $rrr[$n]->{rrorigin} .= $col2[$k];
                    $rrr[$n]->{rrorigin} .= ".";
                }
                $rrr[$n]->{rrdomain} = $elms[$i]->{$j};
            }
            # ۥ̾˥ɥåȤޤޤʤ硢ꥸʥɥᥤϡ
            # Τޤޤǡۥ̾˥ꥸʥɥᥤղä롣
            else {
                $rrr[$n]->{rrorigin} = $origin;
                $rrr[$n]->{rrdomain} = $elms[$i]->{$j};
                $rrr[$n]->{rrdomain} .= ".";
                $rrr[$n]->{rrdomain} .= $origin;
            }
            if ($rrr[$n]->{rrorigin} !~ /\.$/) {
                $rrr[$n]->{rrorigin} .= ".";
            }
            if ($rrr[$n]->{rrdomain} !~ /\.$/) {
                $rrr[$n]->{rrdomain} .= ".";
            }
                
            # Ʊɥᥤ̾ξϺ
            for ($k = 0; $k < $#rrr; $k++) {
                if (($rrr[$k]->{rrorigin} eq $rrr[$n]->{rrorigin})
                && ($rrr[$k]->{rrdomain} eq $rrr[$n]->{rrdomain})) {
                    last;
                }
            }
            if ($k < $#rrr) {
                splice(@rrr, $n, 1);
                next;
            }
            # TTL
            $rrr[$n]->{rroptttl} = $optttl;

            # 饹
            $rrr[$n]->{rroptclass} = $optclass;

            # סǡ
            # ǽξ A(ɥ쥹)쥳ɡܰʹߤ
            # CNAME(̾)쥳
            if ($j == 0) {
                $rrr[$n]->{rrtype} = "A";
                $rrr[$n]->{rrdata} = $elms[$i]->{addr};
            }
            else {
                $rrr[$n]->{rrtype} = "CNAME";
                $rrr[$n]->{rrdata} = "$elms[$i]->{0}.";
            }
            $n++;
        }
    }

    # ѥ꥽쥳ɤɸϤؽ
    if (!open(OUT, "> /var/named/$zfname")) {
        $err = "$zfnameؤν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    $fp = OUT;
    printRR($fp, $zname, *rrr, $incfile, $incopt, 0);
    close(OUT);

done:
    return($err);
}

#
# ̾
#     hosts2rzone - DNSΥ򹹿
# 
#     hosts2rzone($host, $domain, $netaddr, $netmask, @hosts)
# 
#     $host - ۥ̾(ex. "www")
#     $domain - ɥᥤ̾(ex. "abc.do.jp")
#     $netaddr - ͥåȥɥ쥹(ex. "192.168.1.0")
#     $netmask - ͥåȥޥ(ex. "255.255.255.240")
#     $zone - հ̾(ex. "0.1.168.192.in-addr.arpa")
#     @hosts - /etc/hosts(readFile()ʤɤɤ߹)
# 
#     /etc/hostsξ򸵤ˡDNSΥ()򹹿ޤ
#
sub hosts2rzone
{
    local($host, $domain, $netaddr, $netmask, $zname, @hosts) = @_;
    local($hostname, $netb, $netnum, $hostnum);
    local($rdomain, $zfname);
    local($origin, $machine, $contact);
    local($serial, $refresh, $retry, $expire, $minimum);
    local($incfile, $incopt, $optttl, $optclass);
    local(@orgrr, $orgincfile, $orgincopt, $orgdefttl);
    local(@elms, @rrr);
    local($i, $j, $k, $n);
    local($fp, @col, $tmpbuf, $tmpnum);
    local($err);

    $hostname = "$host.$domain";            # ۥ̾
    $netb = mask2bit($netmask);         # ͥåȥӥåȿ
    $netnum = addr2Num($netaddr);           # ͥåȥֹ
    $hostnum = getHnum("$netaddr/$netb");       # ۥ
    if ($zname eq "") {
        $zname = &net2Zone("$netaddr/$netb");   # ̾
    }

    $rdomain = "$zname.";               # ɥᥤ̾
    $tmpbuf = &net2Zone("$netaddr/$netb");
    $tmpbuf =~ s/\//_/g;
    $zfname = "g.$tmpbuf";              # ե̾

    $origin = "$zname.";                # ǥեȥɥᥤ̾
    $machine = "$hostname.";            # ޥ̾
    $contact = "root.$machine";         # ̾
    $serial = &getSerial(0);            # ꥢֹ
    $refresh = 28800;               # եåֹ
    $retry = 14400;                 # ȥ饤ֳ
    $expire = 3600000;              # ѥ
    $minimum = 86400;               # ǾTTL

    $incfile = "";
    $incopt = "";
    $optttl = $minimum;
    $optclass = "IN";

    # եɤ߹
    if (-e "/var/named/$zfname") {
        @orgrr = ();
        $orgincfile = "";
        $orgincopt = "";
        $orgdefttl = 0;
        if ($err = readRR($zname, "/var/named/$zfname",
            *orgrr, *orgincfile, *orgincopt, *orgdefttl)) {
            goto done;
        }

        for ($i = 0; $i <= $#orgrr; $i++) {
            if (($orgrr[$i]->{rrtype} eq "SOA")
                &&($orgrr[$i]->{rrdomain} eq $rdomain)) {
                $machine = $orgrr[$i]->{soa_machine};
                $contact = $orgrr[$i]->{soa_contact};
                $serial = &getSerial($orgrr[$i]->{soa_serial});
                $refresh = $orgrr[$i]->{soa_refresh};
                $retry = $orgrr[$i]->{soa_retry};
                $expire = $orgrr[$i]->{soa_expire};
                $minimum = $orgrr[$i]->{soa_minimum};
                last;
            }
        }
    }

    # ۥȥե
    $n = 0;
    for ($i = 0; $i <= $#hosts; $i++) {
        $tmpbuf = $hosts[$i];
        $tmpbuf =~ s/^\s*//;
        $tmpbuf =~ s/\s*$//;
        $tmpbuf =~ s/#.*$//;
        @col = split(/\s+/, $tmpbuf);

        # Ԥ롼ץХåɥ쥹̵
        if (($#col < 1) || ($col[0] eq "127.0.0.1")) {
            next;
        }

        # ϰϳΥɥ쥹̵
        $tmpnum = addr2Num($col[0]);
        if (($tmpnum < $netnum) || ($tmpnum >= ($netnum + $hostnum))) {
            next;
        }

        # ɥ쥹
        $elms[$n]->{addr} = $col[0];

        # ۥ̾
        $elms[$n]->{argc} = $#col - 1;
        for ($j = 1; $j <= $#col; $j++) {
            $elms[$n]->{$j-1} = $col[$j];
        }

        $n++;
    }

    # հѥ꥽쥳ɤѴ
    $n = 0;

    # SOA쥳ɤ
    $rrr[$n]->{rrorigin} = $origin;
    $rrr[$n]->{rrdomain} = $rdomain;
    $rrr[$n]->{rroptttl} = $optttl;
    $rrr[$n]->{rroptclass} = $optclass;
    $rrr[$n]->{rrtype} = "SOA";
    $rrr[$n]->{soa_machine} = $machine;
    $rrr[$n]->{soa_contact} = $contact;
    $rrr[$n]->{soa_serial} = $serial;
    $rrr[$n]->{soa_refresh} = $refresh;
    $rrr[$n]->{soa_retry} = $retry;
    $rrr[$n]->{soa_expire} = $expire;
    $rrr[$n]->{soa_minimum} = $minimum;
    $n++;

    # NS쥳ɤ
    $rrr[$n]->{rrorigin} = $origin;
    $rrr[$n]->{rrdomain} = $rdomain;
    $rrr[$n]->{rroptttl} = $optttl;
    $rrr[$n]->{rroptclass} = $optclass;
    $rrr[$n]->{rrtype} = "NS";
    $rrr[$n]->{rrdata} = $machine;
    $n++;

    for ($i = 0; $i <= $#elms; $i++) {
        for ($j = 0; $j <= $elms[$i]->{argc}; $j++) {
            # ܰʹߤ̵
            if ($j != 0) {
                next;
            }

            # ꥸʥɥᥤ󡢥ɥᥤ
            $rrr[$n]->{rrorigin} = $origin;
            $rrr[$n]->{rrdomain} = (split(/\./, $elms[$i]->{addr}))[3];

            # Ʊɥᥤ̾ξϺ
            for ($k = 0; $k < $#rrr; $k++) {
                if (($rrr[$k]->{rrorigin} eq $rrr[$n]->{rrorigin})
                && ($rrr[$k]->{rrdomain} eq $rrr[$n]->{rrdomain})) {
                    last;
                }
            }
            if ($k < $#rrr) {
                splice(@rrr, $n, 1);
                next;
            }
            # TTL
            $rrr[$n]->{rroptttl} = $optttl;

            # 饹
            $rrr[$n]->{rroptclass} = $optclass;

            # (PTR:ݥ)ǡ
            if ($j == 0) {
                $rrr[$n]->{rrtype} = "PTR";
                @col2 = split(/\./, $elms[$i]->{$j});
                if ($#col2 == 0) {
                    $rrr[$n]->{rrdata} = "$elms[$i]->{$j}"
                                ."."
                                ."$domain";
                }
                else {
                    $rrr[$n]->{rrdata} = $elms[$i]->{$j};
                    if ($rrr[$n]->{rrdata} !~ /\.$/) {
                        $rrr[$n]->{rrdata} .= ".";
                    }
                }
            }
            else {
                next;
            }
            $n++;
        }
    }

    # ѥ꥽쥳ɤɸϤؽ
    if (!open(OUT, "> /var/named/$zfname")) {
        $err = "$zfnameؤν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    $fp = OUT;
    printRR($fp, $zname, *rrr, $incfile, $incopt, 0);
    close(OUT);

done:
    return($err);
}

1;

